@echo off
REM  File: INSTALL.BAT
REM
REM  Installation batch file for ATOMFT v 3_11 under MS-DOS
REM  Usage:
REM     YOU MUST EDIT THIS FILE TO FIT YOUR SYSTEM
REM     edit install.bat
REM     install
REM
REM **************  Edit this block  **********************
REM
REM     Floppy disk from which ATOMFT is being installed
set SRCDISK=a:
REM
REM     Disk where ATOMFT should go:
set ATOMDISK=C:
REM
REM     Directory on that disk where ATOMFT should go:
set ATOMDIR=Atom3_11
REM
REM     Current setting copies only source for Microsoft Fortran v 5.1
REM     Change to PORT if you want only the portable Fortran source
REM     Change to ALL if you want both the Microsoft
REM        and the portable Fortran source
set WHATSRC=PORT
REM
REM     Do you wish to copy the executable ATOMFT.EXE?
REM     YES if you need to run ATOMFT.EXE on your PC with
REM        no Fortran compiler, and then transfer the generated
REM        Fortran object code to another machine for compilation,
REM        linking, and execution.
REM     NO if you run the Fortran compiler on your PC.  You will
REM        build ATOMFT.EXE from the source code using your own
REM        compiler.  You need to build the ATOMFT run-time
REM        library using your own compiler anyway.
set ISEXECPY=NO
REM
REM     Change this to DONE
set ISEDIT=DONE
REM set ISEDIT=DONE
REM
REM *******************************************************

if "%ISEDIT%" == "DONE" goto install
@echo.
@echo YOU MUST EDIT INSTALL.BAT TO SUPPLY
@echo DIRECTORY NAMES FOR YOUR SYSTEM.
@echo.
@echo If you have any problems, contact
@echo    Dr. George F. Corliss
@echo    Department of Mathematics
@echo    Marquette University
@echo    Milwaukee, WI  53233  USA
@echo    E-mail: georgec@math.mscs.mu.edu
@echo    Phone: 414 288-6599, Fax: 414 288-5472
@echo.
goto exit

:install
%ATOMDISK%
cd \
@echo.
@echo Make Atomft directory on the destination drive
mkdir %ATOMDIR%
cd %ATOMDIR%
@echo.
@echo Copy information files
copy %SRCDISK%\*.* .
if "%WHATSRC%" == "PORT" goto portsrc
if "%WHATSRC%" == "ALL" goto bothsrc

:microsrc
@echo.
@echo Make directory for ATOMFT source for Microsoft Fortran v 5.1
if not exist Source.MSF mkdir Source.MSF
@echo.
@echo Copy ATOMFT source for Microsoft Fortran v 5.1
copy %SRCDISK%\Source.MSF\*.* Source.MSF
goto checkbin

:portsrc
@echo.
@echo Make directory for ATOMFT source for portable Fortran 77
if not exist Source mkdir Source
@echo.
@echo Copy ATOMFT source for portable Fortran 77
copy %SRCDISK%\Source\*.* Source
goto checkbin

:bothsrc
@echo.
@echo Make directory for ATOMFT source for Microsoft Fortran v 5.1
if not exist Source.MSF mkdir Source.MSF
@echo.
@echo Copy ATOMFT source for Microsoft Fortran v 5.1
copy %SRCDISK%\Source.MSF\*.* Source.MSF
@echo.
@echo Make directory for ATOMFT source for portable Fortran 77
if not exist Source mkdir Source
@echo.
@echo Copy ATOMFT source for portable Fortran 77
copy %SRCDISK%\Source\*.* Source

:checkbin
if "%ISEXECPY%"=="YES" goto copybin
goto examples

:copybin
@echo.
@echo Make directory for ATOMFT PC executable
if not exist Bin mkdir Bin
@echo.
@echo Copy ATOMFT.EXE
copy %SRCDISK%\Bin\atomft.exe Bin

:examples
@echo.
@echo Make directory for ATOMFT examples
if not exist Examples mkdir Examples
@echo.
@echo Copy ATOMFT Examples
copy %SRCDISK%\Examples\*.* Examples
@echo.
@echo Next you should
@echo   1) change to the source directory,
@echo   2) edit the MAKEFILE and MAKEX2_1.DOS files there,
@echo   3) be sure DOS PATH and environment variables are
@echo      set for your Fortran compiler,
@echo   4) nmake   or nmake all     (assuming Microsoft Fortran)
@echo.
@echo.
@echo Thanks for giving ATOMFT a try.  If you have any problems, contact
@echo    Dr. George F. Corliss
@echo    Department of Mathematics
@echo    Marquette University
@echo    Milwaukee, WI  53233  USA
@echo    E-mail: georgec@math.mscs.mu.edu
@echo    Phone: 414 288-6599, Fax: 414 288-5472
@echo.
@echo An 80+ page printed ATOMFT User Manual containing 38 examples
@echo    of ODE systems is available at no charge from Corliss.
@echo.
@echo ATOMFT is distributed at no cost, but it carries two obligations:
@echo    1. If you have trouble, don't just bitch; contact Corliss!
@echo    2. If you use ATOMFT in your research, send Corliss
@echo       a copy of any resulting papers or technical reports.
@echo.

:exit
