C File atomft1.for                     30-DEC-1993
C
C ATOMFT Compiler, version 3.11, Copyright (C) 1979-93, Y. F. Chang
C  Version 3.11 completed (6/21/93)
C---------------------------------------------------------------
C
C ATOMFT = Automatic TaylOr series Method for solving user-defined
C    FuncTions.
C It is a translator program written in FORTRAN-77 for the automatic
C    solution of systems of ODE's with excellent error control and
C    high speed (with or without user-defined functions).
C
C Version 3.11 features
C 1. The user has the option of calling forth a superfast solution for
C      ODE's using an infinite-series method.  (Precision is reduced.)
C 2. Accurate calculations (7TA) for the radius of convergence.
C 3. The name of the independent variable is printed in the output.
C 4. Complicated inverse functions solved.
C 5. Boundary-value problems.
C 6. Time delay equations.
C 7. Problems with subtractive errors.
C 8. Numerical quadrature of very complicated functions.
C 9. Convenient subroutine form for ATSPGM, all parameters passed in
C     a list.
C 10. A new ZEROT subroutine.
C 11. Subroutine GETDIG finds all the important computer parameters.
C
C The error control and speed is made possible by calculations for
C    the radius of convergence at every integration step.  The 'ATOMFT'
C    program will solve a system of up to 900 equations, each with
C    derivatives up to order 8.
C
C The 'ATOMFT' program is capable of solving initial-value differential
C    algebraic equation (DAE's) problems automatically.  Version 3.11
C    will solve DAE's with multiple constraining constants and multiple
C    constraint equations.  The maximum number of constraints is 9.
C
C For full documentation, please refer to
C    Y. F. Chang, ATOMFT: User Manual, Version 3.11,
C    Marquette University Department of Mathematics, Statistics,
C    and Computer Science Technical Report No. 385, August, 1993.
C You may request a copy from
C    Dr. George F. Corliss
C    Department of Mathematics
C    Marquette University
C    Milwaukee, WI  53233  USA
C
C    E-mail: georgec@math.mscs.mu.edu
C    Phone:  (414) 288-6599
C    Fax:    (414) 288-5472
C
C  Copyright (C) 1979-93, Y. F. Chang.
C-----------------------------------------------------------------------
C MSF:
C These two lines are only for the Microsoft FORTRAN compiler.
c$LARGE
c$STORAGE:2
C Only for Microsoft, remove the comment C at the two preceeding lines.
C Remove the comment C at the two lines preceeding EQSORT and CODGEN
C in files ATOMFT2.for and ATOMFT3.for, respectively.
      DIMENSION DCONS(200),MINDV(200,2),MTRPL(1500,4),INOUT(1500,4),
     A MND(1500),MVAR(600,4),MEQU(600,3)
C---For mainframes, use these 2 lines.
Cc      DIMENSION DCONS(900),MINDV(900,2),MTRPL(3000,4),INOUT(3000,4),
Cc     A MND(3000),MVAR(2000,4),MEQU(2000,3)
C---For small systems, such as Microsoft, use these 2 lines.
Cc      DIMENSION DCONS(200),MINDV(200,2),MTRPL(1500,4),INOUT(1500,4),
Cc     A MND(1500),MVAR(600,4),MEQU(600,3)
      DOUBLE PRECISION DUNIQ,DCONS
      COMMON/SIZE/NEQUS,NVARS,NOPS,MSTK(200)
      COMMON/MACHIN/DUNIQ,MAXEXP,MAXD,IUNIX,NSDIGS,NDDIGS
      COMMON/IOUNIT/IOINPU,IOLIST,IOOBJE,MAXSIZ,NTYP2
      COMMON/INPUT/NOPRT,KINDEX,IBLOK,ICONV(76)
      CHARACTER*1 IBLOK,ICONV,MBLOK
C--The user may chose any symbol to serve as the block terminator.
      DATA MBLOK/'$'/
       IBLOK = MBLOK
C---
      NEQUS  = 200
      NVARS  = 600
      NOPS   = 1500
      MAXSIZ = 10000
C---For mainframes, use these 4 lines.
C      NEQUS  = 900
C      NVARS  = 2000
C      NOPS   = 3000
C      MAXSIZ = 100000
C---For small system, such as Microsoft, use these 4 lines.
C      NEQUS  = 200
C      NVARS  = 600
C      NOPS   = 1500
C      MAXSIZ = 10000
C--------
C IOINPU -- Input unit, record length is 72 charaters
C IOOBJE -- Object Program, record length is 72 characters
C IOLIST -- Output listing
C--------
      IOOBJE = 11
      IOINPU = 12
C---If desired, use these OPEN statements.
      OPEN(IOINPU,FILE='ODEINP.',STATUS='OLD')
      OPEN(IOOBJE,FILE='ATSPGM.',STATUS='NEW')
C---For listing output to a disk file, use IOLIST = any non-zero unit.
C***This carries over to ATSPGM !!***
C***If it is specified IOLIST non-zero, then it is disk file throughout.
C***The same unit number will appear in ATSPGM.***
C!!!         ____
C!! The user MUST include the proper OPEN statement in the third block!
C!!!         ^^^^
C      IOLIST = 13
C      OPEN(IOLIST,FILE='ATOMFT.LST',STATUS='NEW')
C.......................................................................
C---For output to the consol, use IOLIST = 0.
C***This carries over to ATSPGM !!*****
C***If it is specified IOLIST = 0, then it is consol output throughout.
      IOLIST = 0
C-----version numbers.
      NOPRT = 3
      KINDEX = 1
C--------
C Everything is all set to go; so, call the subroutine 'MASTER'.
C--------
      CALL MASTER(DCONS,MTRPL,INOUT,MND,MVAR,MEQU,MINDV)
C--------
C That's all folks.
C--------
C---If desired, use these CLOSE statements.
      CLOSE (IOINPU)
      CLOSE (IOOBJE)
C      CLOSE (IOLIST)
      STOP
      END
C MASTER SUBROUTINE
C******************
      SUBROUTINE MASTER(DCONS,MTRPL,INOUT,MND,MVAR,MEQU,MINDV)
C********
      COMMON/SIZE/NEQUS,NVARS,NOPS,MSTK(200)
      COMMON/MACHIN/DUNIQ,MAXEXP,MAXD,IUNIX,NSDIGS,NDDIGS
      COMMON/IOUNIT/IOINPU,IOLIST,IOOBJE,MAXSIZ,NTYP2
      COMMON/INPUT/NOPRT,KINDEX,IBLOK,ICONV(76)
      COMMON /OUTPUT/LOOPNX,LOPLIM(48),LITNUM,LITKNT,LIMPLI(48)
      COMMON /ATSOPT/KDUMP,LENVAR,KDOBLE,KOMPLX,KFNCT,NCARD
      COMMON /POINTR/NSPACE,NSTMT,INPTR,LAST,INOUTP,LRIGHT,KDELAY
      COMMON/SKELTN/KAFLOT(4),NTWDX(7),NATS(67),LATS,NATT(98),LATT
      COMMON /FLAGS/MRUN,MVCNT
      DIMENSION DCONS(1),MTRPL(1),INOUT(60),MND(1),MVAR(2),MEQU(1),
     A MINDV(1),MWARP(14),MZERO(68),MSAVE(34)
      DOUBLE PRECISION DUNIQ,DCONS
C MSF:
C Remove the comment C only for Microsoft.
C      INTEGER*4 MTEMP1
      CHARACTER*1 IBLOK,ICONV,MS,MD,MC,MZ,MB,M,PM
      DATA MWARP/45,45,45,31,27,45,19,8,9,6,20,45,44,45/
      DATA MZERO/45,45,45,45,45,45,12,18,21,14,45,44,45,38,28,49,
     A 45,45,45,45,45,45,3,1,12,12,45,45,26,5,18,15,20,41,46,2,1,19,5,6,
     A 41,28,42,46,20,13,16,22,46,14,1,13,5,19,46,9,16,1,19,19,46,18,16,
     A 1,19,19,42,50/
      DATA MSAVE/45,45,45,45,45,45,19,1,22,5,45,20,13,16,22,46,4,5,20,
     A 21,14,5,46,9,16,1,19,19,46,18,16,1,19,19/
      DATA MS,MD,MC,MZ,MB/'E','D','C','Z',' '/
      NVAR3 = NVARS*2
      NVAR4 = NVARS*3
      NVAR5 = NVARS*4
      NOP3 = NOPS*2
      NOP4 = NOPS*3
      NOP5 = NOPS*4
      NEQU3 = NEQUS*2
C--------
C Initialize some constants and arrays
C--------
      MXSIZ = MAXSIZ/10
      LRIGHT = 0
      DO 1001 INDEX=1,NEQU3
 1001 MINDV(INDEX) = 0
      DO 1002 INDEX=1,NVAR4
 1002 MEQU(INDEX) = 0
      DO 1003 INDEX=1,NVAR5
 1003 MVAR(INDEX) = 0
      KENDFG = NOPRT
      DO 1004 INDEX=1,NOPS
 1004 MND(INDEX) = 0
      DO 1005 INDEX=1,NOP5
      INOUT(INDEX) = 0
 1005 MTRPL(INDEX) = 0
      DO 1006 INDEX=1,200
 1006 MSTK(INDEX) = 0
      ICONV(48) = IBLOK
      ICONV(49) = IBLOK
      ICONV(50) = IBLOK
C--------
C Print headings on consol unit and object program unit
C--------
      WRITE(IOLIST,1007)KENDFG,KINDEX
 1007 FORMAT(11X,'ATOMFT ver. ',I1,'.',I1,
     A '1, copyright(C) 1979-93, Y. F. Chang.'/11X,53('-')//)
      WRITE(IOOBJE,1008)KENDFG,KINDEX
 1008 FORMAT('C*+*+*+*+*+*'/'C     This program was produced by the  ATO
     AMFT  translator version ',I1,'.',I1,'1'/1HC,33X,'Copyright(c) 1979
     B-93, by Y. F. Chang'/'C*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*
     C+*+*+*+*+*+*+*+*+'/'C This is for the inputs below.'/1HC)
      MVAR(1) = 22453
      MVAR(1+NVARS) = 8760
      MVAR(1+NVAR3) = 3
      MVAR(2) = 5364
      MVAR(2+NVARS) = 15214
      MVAR(2+NVAR3) = 0
      NOPRT = 0
C--------
C Call LEXBOX
C--------
      NCARD = 0
      MRUN = 1
      INTFLG = 0
      CALL LEXBOX(INTFLG,DCONS,MTRPL,INOUT,MVAR)
      IF(MRUN.NE.1) CALL ERRMSG(26,26)
C--------
C Call SYNTAX
C--------
      CALL SYNTAX(DCONS,MTRPL,INOUT,MND,MVAR,MEQU)
      IF(MRUN.NE.1) GO TO 1104
      LRUN = KINDEX
      MEQLIM = MSTK(1)
      NEXT = MSTK(200) - 1
      IF(KDUMP.GT.5 .AND. KDUMP.LT.8)
     A CALL DMPCVC(1,1,1,0,DCONS,MTRPL,INOUT,MND,MVAR,MEQU)
C--------
C EXPAND changes exponent Y**N to Y*Y*Y for N up to 4
C--------
      CALL EXPAND(MEQLIM,DCONS,MTRPL,INOUT,MEQU)
      IF(MRUN.NE.1) GO TO 1104
      NEXT = MSTK(198) - 1
      IF(KDUMP.GT.4 .AND. KDUMP.LT.8)
     A CALL DMPCVC(0,0,1,0,DCONS,MTRPL,INOUT,MND,MVAR,MEQU)
C--------
C Subroutine EQSORT determines the types of variables and expressions
C  and sorts the equations.
C--------
      CALL EQSORT(MEQLIM,DCONS,MINDV,MTRPL,INOUT,MND,MVAR,MEQU)
      IF(MRUN.NE.1) GO TO 1104
      IF(KDUMP.GT.3 .AND. KDUMP.LT.8)
     A CALL DMPCVC(0,1,1,0,DCONS,MTRPL,INOUT,MND,MVAR,MEQU)
C--------
C Looking for linear system of ODE's
C  also finding and loading the maximum DIFF-order
C--------
      INOUT(1) = NEXT
      CALL MULOPT(1,DCONS,MTRPL,INOUT,MND,MVAR,MEQU)
      LINEAR = INOUT(1)
      NORDER = INOUT(2)
C--------
C FORMAT isolates operations which require DO-loops (in object program)
C  for computation, it introduces implied operators and operations.
C--------
      CALL FORMAT(MTRPL,INOUT,MND,MVAR,MEQU)
      IF(MRUN.NE.1) GO TO 1104
      MREQUP = MSTK(200) - 1
      NEXT = MSTK(198) - 1
      IF(KDUMP.GT.2 .AND. KDUMP.LT.8)
     A CALL DMPCVC(0,1,1,MREQUP,DCONS,MTRPL,INOUT,MND,MVAR,MEQU)
C--------
C Subroutine OPTMIZ eliminates redundant variables and expressions.
C--------
      CALL OPTMIZ(MEQLIM,MTRPL,INOUT,MND,MVAR,MEQU)
      IF(MRUN.NE.1) GO TO 1104
      MREQUP = MSTK(200) - 1
      IF(KDUMP.GT.1 .AND. KDUMP.LT.8)
     A CALL DMPCVC(0,1,1,MREQUP,DCONS,MTRPL,INOUT,MND,
     A MVAR,MEQU)
C--------
C Locate the DIFF triplets on the LHS of equal signs
C--------
      INOUT(1) = NEXT
      CALL MULOPT(2,DCONS,MTRPL,INOUT,MND,MVAR,MEQU)
      MDIFFP = INOUT(1)
      MV1 = INOUT(2)
C--------
C Inblok reads and processes the second input block.  If the user has
C  placed a 'SUBROUTINE' line in this input block, then IRETRN = 1.
C--------
      IRETRN = 0
      CALL INBLOK(2,IRETRN)
      IF(KFNCT.EQ.1) IRETRN = 1
      IF(IRETRN .EQ. 0) GO TO 1011
C Write 'SAVE' for a subroutine.
      DO 1009 K=1,34
 1009 INOUT(K) = MSAVE(K)
      INOUTP = 35
      DO 1010 K=3,NVARS
      IF(MVAR(K+NVAR3) .GT. 1 .OR. MVAR(K) .EQ. 0) GO TO 1010
      INOUT(INOUTP) = 46
      INOUTP = INOUTP + 1
      MTEMP2 = K + MAXSIZ
      CALL OTRANS(MTEMP2,0,0,0,DCONS,INOUT,MND,MVAR)
      INOUTP = INOUTP - 1
 1010 CONTINUE
      INOUT(INOUTP) = 50
      CALL OUTLIN(INOUT,IOOBJE)
C--------
C Generate the IPASS and RPASS arrays
C--------
 1011 KTOTAL = LENVAR*MDIFFP + 1
      WRITE(IOOBJE,1012)LENVAR,MDIFFP,KTOTAL
 1012 FORMAT('      DIMENSION TMPS(',I4,1H,,I3,'),TMPV(',I4,1H) /
     A '      DIMENSION IPASS(20),RPASS(20)'/
     A '      EQUIVALENCE (IPASS(1),NUMEQS),(IPASS(2),LENSER),'/
     B '     A (IPASS(3),LENVAR),(IPASS(4),MPRINT),(IPASS(5),LIST),'/
     C '     A (IPASS(6),MSTIFF),(IPASS(7),LRUN),(IPASS(8),KTRDCV),'/
     D '     A (IPASS(9),KNTSTP),(IPASS(10),KTSTIF),(IPASS(11),KXPNUM),'
     E/'     A (IPASS(12),KDIGS),(IPASS(13),KENDFG),(IPASS(14),NTERMS),'
     F/'     A (IPASS(15),KOVER),(RPASS(1),RADIUS),(RPASS(2),H),'/
     G '     A (RPASS(3),HNEW),(RPASS(4),ERRLIM),(RPASS(5),ADJSTF),'/
     H '     A (RPASS(6),XPRINT),(RPASS(7),DLTXPT),(TMPS(1,1),TMPV(1))')
      IF(KOMPLX.EQ.0) WRITE(IOOBJE,1013)
 1013 FORMAT('     A,(RPASS(8),START),(RPASS(9),END),(RPASS(10),ORDER)')
      IF(KOMPLX.EQ.0 .AND. KDOBLE.EQ.0) GO TO 1019
      IF(KOMPLX.EQ.1 .AND. KDOBLE.EQ.1) GO TO 1015
      IF(KDOBLE.EQ.1) GO TO 1017
      WRITE(IOOBJE,1014)
 1014 FORMAT('      COMMON /PATHCM/ POINTS,START,END,ORDER,VECTOR,KPTS,K
     APAST'/'      COMPLEX POINTS(40),START,END,ORDER,VECTOR,CZRO'/
     A '      COMPLEX TMPS,TMPV' )
      GO TO 1019
 1015 WRITE(IOOBJE,1016)
 1016 FORMAT('      COMMON /PATHCM/ POINTS,START,END,ORDER,VECTOR,KPTS,K
     APAST'/'      COMPLEX*16 POINTS(40),START,END,ORDER,VECTOR,CZRO'/
     A '      COMPLEX*16 TMPS,TMPV'/
     B '      DOUBLE PRECISION RADIUS,H,HNEW,ERRLIM,ADJSTF,XPRINT,'/
     C '     A DLTXPT,RPASS,AL')
      GO TO 1019
 1017 WRITE(IOOBJE,1018)
C--------
C If generating a double precision object program, then write this
C  double precision statement, which declares the RPASS variables.
C--------
 1018 FORMAT('      DOUBLE PRECISION RADIUS,H,HNEW,ERRLIM,ADJSTF,'/
     A '     A XPRINT,DLTXPT,RPASS,AL,START,END,ORDER'/
     B '      DOUBLE PRECISION TMPS,TMPV')
 1019 WRITE(IOOBJE,1020)
 1020 FORMAT('      CHARACTER*6 NAMES')
      IF(KFNCT.EQ.1 .AND. KDOBLE.EQ.1) WRITE(IOOBJE,1021)
 1021 FORMAT('      DOUBLE PRECISION PH')
C--------
C DIMGEN generates all the dimension statements
C--------
      CALL DIMGEN(MDIFFP,NORDER,DCONS,MINDV,MTRPL,INOUT,MND,MVAR,MEQU)
      IF(MRUN.NE.1) GO TO 1104
      MCEQUP = MSTK(199) - 1
      MREQUP = MSTK(200) - 1
C--------
C Assign to M the value '1HE' if the object program is in single
C  precision, and '1HD' if it is in double precision.
C--------
      IF(KDOBLE.EQ.1) GO TO 1022
      M = MS
      PM = MB
      IF(KOMPLX.EQ.1) PM = MC
      MTEMP4 = NSDIGS
      GO TO 1023
 1022 M = MD
      PM = MD
      IF(KOMPLX.EQ.1) PM = MZ
      MTEMP4 = NDDIGS
C--------
C Set the character D for double in /SKELTN/.
C--------
 1023 NERR = 6
      IF(KDOBLE.EQ.0) GO TO 1024
      NERR = 12
      NTWDX(4) = 4
 1024 CONTINUE
      IF(KFNCT.EQ.1) WRITE(IOOBJE,1025) M
 1025 FORMAT('      H = 1.',A1,1H0/'      MSTIFF = 0'/
     A '      IF(KTERM.EQ.1) GO TO 30'/'      IF(KEY.EQ.1) GO TO 29'/
     A '      IF(KONTRL.GT.2) GO TO 40'/'      GO TO 31'/
     A '   30 CONTINUE')
C--------
C If there are any constant expressions (MCEQUP.GT.0), they are
C  generated by the subroutine CODGEN.
C--------
      NOTC = KOMPLX
      IF(MCEQUP.EQ.0) GO TO 1027
      WRITE(IOOBJE,1026)
 1026 FORMAT('C--------'/'C Constant expressions'/'C--------')
      NSPACE = 6
      IF(KDOBLE.NE.1) KOMPLX = 0
      LITKNT = 0
      CALL CODGEN(MCEQUP,0,3,DCONS,MTRPL,INOUT,MND,MVAR,MEQU)
C--------
C Write statements to initialize the variables.
C--------
 1027 KPRINT = 4
      KSTEP = 40
      IF(KFNCT.EQ.0) GO TO 1030
      WRITE(IOOBJE,1028)
 1028 FORMAT('      END = BASEF(1)')
      WRITE(IOLIST,1029)
 1029 FORMAT(' You have invoked the user-defined function solver.'/
     A ' Here in diff(FNT___, , ), the FNT___ must be same as in the cal
     Aling program.')
      KPRINT = 0
      KSTEP = 20
 1030 LINEAR = LINEAR*10
      MTEMP3 = LENVAR - MAX0(8,NORDER+7)
      WRITE(IOOBJE,1031) NORDER,KSTEP,KPRINT,IOLIST,MDIFFP,LENVAR,M,
     A NERR,MTEMP3
 1031 FORMAT('C--------'/'C Initialize variables to default values.'/
     A 'C--------'/'      NTERMS =',I2/'      NSTEPS = ',I2/
     A '      MPRINT =',I2/'      LIST =',I2/'      DETUNE = 1.0'/
     A '      NUMEQS =',I3/'      LENVAR =',I3/
     A '      ERRLIM = 1.',A1,'-',I2/'      LENSER = ',I3/
     A '      KTRDCV = 2'/'      ADJSTF = 1.E-2')
      IF(KFNCT.EQ.0) WRITE(IOOBJE,1032) M,M,M,LINEAR
 1032 FORMAT('      H = 1.4131',A1,1H0/'      START = 0.',A1,'0'/
     A '      END = 0.',A1,'0'/'      MSTIFF =',I2)
C      For Microsoft, need to promote * to 32 bits:
      MTEMP1 = MAXD
      MTEMP1 = MTEMP1*10000 + MAXEXP
      WRITE(IOOBJE,1033) KENDFG,LRUN,MTEMP1,MTEMP4,PM
 1033 FORMAT('      KENDFG =',I2/'      LRUN = ',I1/'      KXPNUM =',I9/
     A '      KDIGS = ',I2/
     A '      CALL ',A1,'HEAD(5,TMPV,NAMES,IPASS,RPASS)')
      IF(KOMPLX.EQ.0) WRITE(IOOBJE,1034)M
 1034 FORMAT('      DLTXPT = 0.',A1,1H0)
      IF(KOMPLX.EQ.1 .AND. KDOBLE.EQ.0) WRITE(IOOBJE,1035)
 1035 FORMAT('      CZRO = CMPLX(0.,0.)')
      IF(KOMPLX.EQ.1 .AND. KDOBLE.EQ.1) WRITE(IOOBJE,1036)
 1036 FORMAT('      CZRO = DCMPLX(0.D0,0.D0)')
C--------
C  Read and process the third input block
C--------
      CALL INBLOK(3,IDUMY)
      IF(KFNCT.EQ.1) WRITE(IOOBJE,1037)
 1037 FORMAT('      MSTIFF = 0'/
     A'      IF(KONTRL.EQ.1 .OR. KONTRL.EQ.3) END = BASEF(1)'/'C------'/
     A'C Note to user: END for inverse function must be set at the ends'
     A /'C   of the principal value region.'/'C------')
      IF(MCEQUP.LT.1) GO TO 1038
      LITKNT = 0
      CALL CODGEN(MCEQUP,0,6,DCONS,MTRPL,INOUT,MND,MVAR,MEQU)
      WRITE(IOOBJE,1026)
 1038 KOMPLX = NOTC
      IF(KOMPLX.EQ.1) GO TO 1040
      WRITE(IOOBJE,1039) MDIFFP,LENVAR,PM
 1039 FORMAT('      NUMEQS =',I3/'      LENVAR =',I3/'      KOVER = 1 '
     A /'      CALL ',A1,'HEAD(1,TMPV,NAMES,IPASS,RPASS)')
      GO TO 1042
 1040 WRITE(IOOBJE,1041) MDIFFP,LENVAR,PM,MTEMP4
 1041 FORMAT('      NUMEQS =',I3/'      LENVAR =',I3/'      KOVER = 1 '
     B /'      START = POINTS(1)'/'      END = POINTS(KPTS)'/
     C '      CALL ',A1,'HEAD(1,TMPV,NAMES,IPASS,RPASS)'/
     D 'C More initializations'/'C--------'/
     E '      KPAST = 1'/'      KDIGS = ',I2)
      GO TO 1048
C--------
C  Control stmts and rest of initializations
C--------
 1042 IF(KDOBLE.EQ.1) GO TO 1045
      IF(KFNCT.EQ.0) WRITE(IOOBJE,1043)
 1043 FORMAT('C More initializations'/'C--------'/
     D '      DLTXPT = SIGN(DLTXPT,(END-START))'/
     E '      H = SIGN(H,(END-START))')
      IF(KFNCT.EQ.1) WRITE(IOOBJE,1044)
 1044 FORMAT('C More initializations'/'C--------'/
     E '      H = SIGN(H,(END-START))')
      GO TO 1048
 1045 IF(KFNCT.EQ.0) WRITE(IOOBJE,1046)
 1046 FORMAT('C More initializations'/'C--------'/
     A '      IF(MSTIFF.GE.20) LENSER = MIN0(15,LENSER)'/
     B '      IF(MSTIFF.EQ.21) LENSER = MIN0(10,LENSER)'/
     D '      DLTXPT = DSIGN(DLTXPT,(END-START))'/
     E '      H = DSIGN(H,(END-START))')
      IF(KFNCT.EQ.1) WRITE(IOOBJE,1047)
 1047 FORMAT('C More initializations'/'C--------'/
     E '      H = DSIGN(H,(END-START))')
 1048 MTEMP3 = MAX0(8,NORDER+7)
      IF(KOMPLX.EQ.0 .AND. KFNCT.EQ.0) WRITE(IOOBJE,1049)
 1049 FORMAT('      XPRINT = START + DLTXPT')
      WRITE(IOOBJE,1050) MTEMP3,MTEMP3
 1050 FORMAT('      LRUN = 1'/'      KTSTIF = 0'/
     + '      IF(LENSER.GT.(LENVAR-',I2,')) LENSER = LENVAR -',I2)
      IF(KFNCT.EQ.1) WRITE(IOOBJE,1051)
 1051 FORMAT('      XPRINT = START'/'      HOLD = START')
C--------
C For the DIFF functions which appear on the LHS of the = sign, store
C  the dependent variable in the second column of MEQU and the order of
C  the DIFF in the third column.
C--------
      IF(MDIFFP.LT.1) GO TO 1053
      DO 1052 N=1,MDIFFP
      MTEMP2 = MEQU(N+NVARS)
      MEQU(N+NVARS) = MTRPL(MTEMP2+NOPS) - MAXSIZ
 1052 MEQU(N+NVAR3) = (MTRPL(MTEMP2+NOP3) - MAXSIZ)/MXSIZ
C--------
C Generate the statements which write out the initial conditions for
C  each independent variable.
C--------
 1053 WRITE(IOOBJE,1054)
 1054 FORMAT('C--------'/'C Loop for integration steps.  Inside the loop
     A, print the desired output'/'C--------'/'   17 DO 27 KINTS=1,NSTEP
     AS'/'      KNTSTP = KINTS'/'   19 CONTINUE')
      IF(KOMPLX.EQ.1) WRITE(IOOBJE,1055)
 1055 FORMAT('      VECTOR = POINTS(KPAST+1) - POINTS(KPAST)')
      IF(KOMPLX.EQ.1 .AND. KDOBLE.EQ.0) WRITE(IOOBJE,1056)
 1056 FORMAT('      VECTOR = VECTOR/CABS(VECTOR)')
      IF(IUNIX.EQ.0.AND.KOMPLX.EQ.1.AND.KDOBLE.EQ.1) WRITE(IOOBJE,1057)
 1057 FORMAT('      VECTOR = VECTOR/CDABS(VECTOR)')
      IF(IUNIX.EQ.1.AND.KOMPLX.EQ.1.AND.KDOBLE.EQ.1) WRITE(IOOBJE,1058)
 1058 FORMAT('      VECTOR = VECTOR/ZABS(VECTOR)')
C--------
C INIVAL initializes the independent variables and adjusts the initial
C  values given for the problem to include the H and factorial part of
C  the Taylor series terms.
C--------
      NSTMT = 1000
      INPTR = NOPS
      NSPACE = 6
      CALL INIVAL(MDIFFP,DCONS,MINDV,INOUT,MND,MVAR,MEQU)
      CALL ORDER(2,MREQUP,MTRPL,INOUT,MVAR,MND,MEQU)
      WRITE(IOOBJE,1059)
 1059 FORMAT('C--------'/'C Preliminary series calculations'/
     A 'C--------')
      MSTK(1) = 0
C------
C Testing for the index of constraint problems.
C------
      IF(NCARD.EQ.0) GO TO 1067
      WRITE(IOOBJE,1060)
 1060 FORMAT('      KFGCND = 0')
      IF(NCARD.GT.1) CALL ORDDAE(1,MREQUP,MTRPL,INOUT,MVAR,MEQU)
      CALL ORDER(1,MREQUP,MTRPL,INOUT,MVAR,MND,MEQU)
      IF(NCARD.EQ.1) GO TO 1063
      DO 1062 K=2,NCARD
      WRITE(IOOBJE,1061) K
 1061 FORMAT('      KFGCN',I1,' = 0')
 1062 CONTINUE
 1063 WRITE(IOOBJE,1064)
 1064 FORMAT('   31 CONTINUE')
      NOPRT = 1
      IF(LITNUM.LT.1) GO TO 1066
      LITKNT = 0
 1065 LITKNT = LITKNT + 1
      CALL CODGEN(MREQUP,0,1,DCONS,MTRPL,INOUT,MND,MVAR,MEQU)
      IF(LITKNT.LT.LITNUM) GO TO 1065
 1066 KINDEX = NSPACE - 1
      NSTMT = 1000
      INPTR = NOPS
      NSPACE = 6
      NOPRT = 2
      IF(NCARD.GT.1) CALL ORDDAE(2,MREQUP,MTRPL,INOUT,MVAR,MEQU)
      GO TO 1068
C--------
C The number of Taylor series terms needed to make the recurrence
C  relation(s) valid are generated here.
C--------
 1067 NOPRT = 0
 1068 IF(LITNUM.LT.1) GO TO 1070
      LITKNT = 0
 1069 LITKNT = LITKNT + 1
      CALL CODGEN(MREQUP,0,1,DCONS,MTRPL,INOUT,MND,MVAR,MEQU)
      IF(LITKNT.LT.LITNUM) GO TO 1069
 1070 LOPTOP = INOUTP
      NOPRT = 0
      WRITE(IOOBJE,1071) LOPTOP
 1071 FORMAT('C--------'/'C Loop for series calculations'/
     A 'C--------'/6X,'DO 23 K=',I2,',LENSER')
      CALL NDXSHF(LOOPNX)
C--------
C  Generate the code which computes the rest of the Taylor series
C--------
      NSPACE = 6
      LITKNT = 0
      CALL CODGEN(MREQUP,1,1,DCONS,MTRPL,INOUT,MND,MVAR,MEQU)
C--------
C Generate the statements which check and vary the step-size.
C--------
      WRITE(IOOBJE,1072) PM
 1072 FORMAT('C--------'/
     A 'C Test and adjust H to avoid over/under flow.'/'C--------'/
     B '      CALL ',A1,'HEAD(2,TMPV,NAMES,IPASS,RPASS)'/
     C '      IF(LRUN.EQ.0) GO TO 19'/'   23 CONTINUE'/'C--------'/
     F 'C Calculate radius of convergence and take optimum step.'/
     G 'C--------')
      INOUTP = 1
      WRITE(IOOBJE,1074) PM
 1074 FORMAT('      CALL ',A1,'RDCV(TMPV,NAMES,IPASS,RPASS)')
      IF(KOMPLX.EQ.0) WRITE(IOOBJE,1075) PM
 1075 FORMAT('   24 CALL ',A1,'RSET(TMPV,NAMES,IPASS,RPASS)')
      IF(KFNCT.EQ.0) GO TO 1080
      WRITE(IOOBJE,1076)
 1076 FORMAT('      IF(KONTRL.NE.2) GO TO 25')
      IF(KDOBLE.EQ.1) MZERO(28) = 4
      DO 1077 K=1,34
 1077 INOUT(K) = MZERO(K)
      INOUTP = 35
      CALL OTRANS(MV1,0,0,0,DCONS,INOUT,MND,MVAR)
      INOUTP = INOUTP - 5
      DO 1078 K=35,68
      N = K - 34
 1078 INOUT(INOUTP+N) = MZERO(K)
      CALL OUTLIN(INOUT,IOOBJE)
      MZERO(12) = 45
      WRITE(IOOBJE,1079)
 1079 FORMAT('      IF(LRUN.NE.0) GO TO 25'/'      SHIFT = XPRINT'/
     A '      GO TO 41')
      GO TO 1081
 1080 CALL INBLOK(4,IDUMY)
 1081 IF(KOMPLX.EQ.0) WRITE(IOOBJE,1082)
 1082 FORMAT('   25 GO TO (26,28,24), KENDFG')
      IF(KOMPLX.EQ.1) WRITE(IOOBJE,1083)
 1083 FORMAT('      GO TO (26,28), KENDFG')
      IF(KDOBLE.EQ.0) WRITE(IOOBJE,1084)
 1084 FORMAT('   26 H = SIGN(RADIUS,H)*DETUNE')
      IF(KDOBLE.EQ.1) WRITE(IOOBJE,1085)
 1085 FORMAT('   26 AL = RADIUS*DETUNE'/'      H = DSIGN(AL,H)')
      IF(KOMPLX.EQ.0) WRITE(IOOBJE,1086)
 1086 FORMAT('      START = START + HNEW')
      IF(KOMPLX.EQ.1) WRITE(IOOBJE,1087)
 1087 FORMAT('   24 START = START + HNEW*VECTOR')
      IF(KFNCT.EQ.1) GO TO 1089
      WRITE(IOOBJE,1088) PM
 1088 FORMAT('   27 CONTINUE'/
     A '      CALL ',A1,'HEAD(3,TMPV,NAMES,IPASS,RPASS)'/
     A '   28 CONTINUE')
      GO TO 1097
C--This is the beginning of the 2-D f-array processing.
 1089 WRITE(IOOBJE,1090) PM
 1090 FORMAT('   27 CONTINUE'/'      HNEW = HOLD'/'      CALL ',A1,
     A 'HEAD(4,TMPV,NAMES,IPASS,RPASS)'/'   28 CONTINUE'/
     B '      GO TO 40'/'   31 CONTINUE'/'C------'/
     C 'C Begin processing for secondary independent variable.'/
     D'C------'/'      IF(KTERM.GT.2) GO TO 40'/'      START = BASEF(1)'
     E /'      IF(KONTRL.EQ.2) START = FNTOUT(1)')
      INPTR = NOPS
      NSPACE = 6
      CALL INIVAL(MDIFFP,DCONS,MINDV,INOUT,MND,MVAR,MEQU)
      CALL ORDER(2,MREQUP,MTRPL,INOUT,MVAR,MND,MEQU)
      KDELAY = 0
      DO 1091 LITKNT=1,LITNUM
      CALL CODGEN(MREQUP,0,1,DCONS,MTRPL,INOUT,MND,MVAR,MEQU)
 1091 CONTINUE
      WRITE(IOOBJE,1092) LOPTOP
 1092 FORMAT(6X,'DO 32 K=',I2,',LENSER')
      CALL NDXSHF(LOOPNX)
      LITKNT = 0
      KFNCT = 2
      CALL CODGEN(MREQUP,1,1,DCONS,MTRPL,INOUT,MND,MVAR,MEQU)
      WRITE(IOOBJE,1093)
 1093 FORMAT('   32 CONTINUE')
      DO 1094 K=1,14
 1094 INOUT(K) = MWARP(K)
      INOUTP = 15
      CALL OTRANS(MV1,0,0,0,DCONS,INOUT,MND,MVAR)
      INOUT(INOUTP-3) = 11
      INOUT(INOUTP-2) = 20
      INOUT(INOUTP-1) = 5
      INOUT(INOUTP) = 18
      INOUT(INOUTP+1) = 13
      INOUT(INOUTP+2) = 42
      INOUT(INOUTP+3) = 50
      CALL OUTLIN(INOUT,IOOBJE)
      WRITE(IOOBJE,1095)
 1095 FORMAT('C--------'/'C -Find inverse series-/-Transform derivatives
     A (secondary to primary)-'/'C--------')
      WRITE(IOOBJE,1096) PM
 1096 FORMAT('   41 CALL ',A1,
     A 'SUBFT(KONTRL,SHIFT,KTERM,BASEF,PH,KEY,FNTOUT,IPASS,RPASS,WK)')
C--------
C Generate STOP or RETURN statement.
C--------
 1097 IF(IRETRN.EQ.1) GO TO 1099
      WRITE(IOOBJE,1098)
 1098 FORMAT(10H   29 STOP  /
     A  9H      END  )
      GO TO 1101
 1099 WRITE(IOOBJE,1100)
 1100 FORMAT('   29 RETURN'/'      END')
C--------
C Write termination message on consol unit
C--------
 1101 WRITE(IOLIST,1102)
 1102 FORMAT(10X,'ATOMFT completed')
      IF(INTFLG.EQ.1) WRITE(IOLIST,1103)
 1103 FORMAT(' ********You have used an integer as a variable.********'/
     A ' This may have dire consequences, unless you have declared'/
     B '   the proper type (i.e. REAL, or DOUBLE PRECISION).')
 1104 RETURN
C--------
C end of MASTER
C--------
      END
C BLKDATA
C -------
C This is the data area for the variables in the compiler that are not
C  problem or machine dependent.
C***************
      BLOCK DATA
C***************
      COMMON/ATSOPT/KDUMP,LENVAR,KDOBLE,KOMPLX,KFNCT,NCARD
      COMMON/INPUT/NOPRT,KINDEX,IBLOK,ICONV(76)
      COMMON/OUTPUT/LOOPNX,LOPLIM(48),LITNUM,LITKNT,LIMPLI(48)
      COMMON/FUNCTN/IFN(31,4) /RESWRD/ISW(89,2)
      COMMON/TYPODR/LNL(48),LNL1(3,3,4),KORDJ(48),KRES(48),
     A KRES1(3,3,4), KRES2(3), KITR1(3,3,4), KITR2(3,3)
      COMMON/SKELTN/KAFLOT(4),NTWDX(7),NATS(67),LATS,NATT(98),LATT
      CHARACTER*1 IBLOK,ICONV
C***************
      DATA KDUMP/0/,LENVAR/30/,KDOBLE/0/,KOMPLX/0/,KFNCT/0/
C**********
      DATA ICONV/'A','B','C','D','E','F','G','H','I','J','K','L','M',
     A 'N','O','P','Q','R','S','T','U','V','W','X','Y','Z','0','1',
     B '2','3','4','5','6','7','8','9','+','-','*','/','(',')','''','=',
     C ' ',',','.','$','$','$','a','b','c','d','e','f','g','h','i','j',
     D 'k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z'/
      DATA LOOPNX/ 0 /
      DATA LOPLIM/13*1,2,17*1,0,0,0,0,1,2,2,2,2,0,0,0,2,0,0,0,2/
      DATA LITNUM/ 1 /
      DATA LIMPLI/0,0,0,4,1,0,0,0,0,0,0,0,0,0,0,0,2,4,0,2,0,0,1,4,7,
     A 1,1,0,19*0,3/
C*********
      DATA IFN/0,0,0,31098,5419,0,0,0,0,0,0,0,10180,6766,0,0,
     A -31946,8976,0,-31946,0,0,30774,2095,2095,5419,30774,0,
     B 0,0,0,
     C 0,0,0,-32000,12800,0,0,0,0,0,0,0,0,9600,0,0,
     D 0,0,0,12800,0,0,0,11200,12347,0,12800,24760,0,0,0,
     E 0,0,0,7177,6535,0,0,0,0,0,0,0,0,6766,0,0,
     F 7201,6624,0,7201,0,0,7169,6895,6895,6535,7169,6458,0,0,0,
     G 0,0,0,29600,30720,0,0,0,0,0,0,0,0,9600,0,0,
     H 22400,25600,0,22720,0,0,22400,11200,12347,30400,22720,0,
     I 0,0,0/
      DATA ISW/3*0,-27997,0,0,10163,6*0,7253,23180,5*0,8564,13365,11*0,
     A 2080,9*0,18419,7021,5413,7*0,26209,0,0,19941,28844,2*0,
     B 0,0,6900,2*0,19200,8738,1770,0,0,21458,0,19414,24724,12800,5858,
     C 3*0,19414,0,21580,0,-24942,0,0,3259,0,31201,
     D 3*0,-31382,0,0,-31440,6*0,25600,8659,6*0,-4800,11*0,
     E 10*0,-31634,3685,26104,7*0,23219,0,0,22400,15259,2*0,
     F 0,0,-24940,3*0,19573,31206,2*0,14980,0,-28742,8720,0,24000,
     G 3*0,30618,0,14646,0,14980,0,0,8240,0,29600/
C*********
      DATA LNL/13*1,4,18*1,6*4,1,2,7*4,3/
      DATA LNL1/0,0,0, 0,2,2, 0,2,2, 0,0,0, 2,2,2, 2,2,2,
     A 0,2,2, 2,2,2, 2,2,2, 0,0,0, 0,0,0, 0,0,0/
      DATA KORDJ/13*1,2,29*1,3,4*1/
      DATA KRES/3*9,6,5,3*7,5*9,8,9,9,5,5,9,5,9,7,5,7,7,5,5,7,8*9,
     A 1,1,2,3,9,9,9,10,9,9,9,4/
      DATA KRES1/1,2,3, 2,2,3, 3,3,3, 1,2,3, 2,3,3, 3,3,3,
     A  1,2,3, 3,3,3, 3,3,3, 1,3,3, 3,3,3, 3,3,3/
      DATA KRES2/1,3,3/
      DATA KITR1/1,2,1, 2,2,2, 1,2,1, 1,2,1, 2,3,2, 1,2,1,
     A  1,2,1, 1,2,1, 1,2,1, 1,1,2, 1,2,2, 1,2,2/
      DATA KITR2/1,1,1, 1,2,1, 1,2,2/
C*********
      DATA LATS/67/,LATT/98/
      DATA KAFLOT/41,11,1,42/
      DATA NTWDX/39,32,47,5,38,28,45/
      DATA NATS/27,47,-12,27,49,-1,-2,11,26,45,44,45,28,45,37,45,-3,49,
     A -2,4,15,45,-4,45,14,44,-5,46,45,-3,45,45,45,49,-2,12,45,44,45,
     B 11,26,45,38,45,14,49,45,-17,45,-6,44,45,-7,37,45,-8,41,14,
     C 42,39,-9,41,12,42,49,0,0/
      DATA NATT/27,47,-12,-15,49,-1,-2,11,25,45,44,45,29,45,37,45,-3,
     A 49,-2,4,15,45,-4,45,14,44,-5,46,45,-3,45,45,45,49,-2,12,45,44,
     B 45,11,25,45,38,45,14,45,45,45,49,-2,1,12,45,44,45,41,12,45,38,
     C 45,28,42,49,45,-17,45,-6,44,45,-7,37,45,-8,41,14,42,39,-9,41,12,
     D 42,39,1,12,49,-2,-7,44,45,-7,40,-10,41,-11,42,49,0,0/
C--------
C END BLKDAT
C--------
      END
C LEXBOX SUBROUTINE
C ------ ----------
C This subroutine reads the differential equations specified in the
C  first input block.
C***************
      SUBROUTINE LEXBOX(INTFLG,DCONS,MTRPL,INOUT,MVAR)
C***************
      DIMENSION DCONS(1),MTRPL(1),INOUT(1),MVAR(1),IMOVE(6),ICODE1(80),
     A ICODE2(50),ITEMP(2),IPART(6),IPWD(7),IDUMY(80)
      DIMENSION NDIGIT(6),RNDOFF(4)
      DOUBLE PRECISION DTEMP,DTEMPA,DABS,DUNIQ,AUNIQ,DCONS,DMAXA
      COMMON/SIZE/NEQUS,NVARS,NOPS,MSTK(200)
      COMMON/MACHIN/DUNIQ,MAXEXP,MAXD,IUNIX,NSDIGS,NDDIGS
     B /FUNCTN/IFUNC(31,4) /RESWRD/IRESWD(89,2) /FLAGS/MRUN,MVCNT
     E /ATSOPT/KDUMP,LENVAR,KDOBLE,KOMPLX,KFNCT,NCARD
      COMMON/IOUNIT/IOINPU,IOLIST,IOOBJE,MAXSIZ,NTYP2
      CHARACTER*1 IDUMY
      DATA ICODE2/26*1,10*2,3,4,5,6,7,8,9,10,11,12,13,14,15,16/
      DATA IPART/3*1,3*2/,IMOVE/1600,40,1,1600,40,1/,
     B ISTATE/1/,MPOINT/1/,IPOINT/1/,IPWD/3,15,16,20,9,15,14/,
     C IDUMP/14/,ILENVR/73/,IDUBLE/45/,ICMPLX/46/,IFNCT/7/
      DATA AUNIQ/3.732182882609055888357247958D0/,KOUNT/0/,KGDFLG/0/
      DUNIQ = AUNIQ
      NVAR3 = NVARS*2
      MPT13 = NOPS
      MVCNT = 0
      DO 1201 INDEX=1,NEQUS
 1201 DCONS(INDEX) = DUNIQ
C Start with this as a maximum.  Correct after GETDIG is called.
      DMAXA = 1.D38
C--------
C Read input line.
C--------
 1202 IF(IPOINT.EQ.6) GO TO 1216
 1203 CALL INLINE(ICODE1,IDUMY,1,IJK)
C for a blank line.
      IF(ICODE1(1).EQ.50) GO TO 1203
      IF(ICODE1(1).EQ.3) GO TO 1208
      DO 1204 J=1,72
      IPT = ICODE1(J)
      IF(IPT.EQ.45) GO TO 1204
      IF(IPT.EQ.50) GO TO 1215
      GO TO 1205
 1204 CONTINUE
 1205 IPOINT = ICODE1(1)
      ICODE1(1) = 3
      DO 1206 J=1,72
      IJ = 73 - J
      IF(ICODE1(IJ).NE.45) GO TO 1207
 1206 CONTINUE
 1207 ICODE1(IJ+1) = 50
      CALL OUTLIN(ICODE1,IOOBJE)
      ICODE1(IJ+1) = 45
      ICODE1(1) = IPOINT
C--------
C Determine if line just read is a 'COPTION' card, and set mode.
C--------
 1208 MODE = 0
      LASTOP = 0
      IF(ICODE1(1).NE.3) GO TO 1211
      WRITE(IOLIST,1209) (IDUMY(J),J=1,IJK)
 1209 FORMAT(72A1)
      DO 1210 IPOINT=2,7
      IF(ICODE1(IPOINT).NE.IPWD(IPOINT)) GO TO 1203
 1210 CONTINUE
      ICODE1(73) = 46
      ICODE1(74) = 50
      MODE = 1
      IPOINT = 8
      GO TO 1223
C--------
C Check for line number and issue warning if found
C--------
C no, or passed, coption card; therefore, call GETDIG.
 1211 IF(KGDFLG .EQ. 1) GO TO 1212
      CALL GETDIG(KDUMP,NDIGIT,RNDOFF)
      NSDIGS = - ALOG10(RNDOFF(2))
      NDDIGS = - ALOG10(RNDOFF(4))
      MAXD = MIN0(9000,NDIGIT(6))
      DMAXA = 1.D1**MAXD
      MAXEXP = MIN0(9000,NDIGIT(3))
      KGDFLG = 1
 1212 WRITE(IOLIST,1209) (IDUMY(J),J=1,IJK)
      DO 1213 IPOINT=1,5
      IF(ICODE1(IPOINT).EQ.45) GO TO 1213
      CALL ERRMSG(1,MPOINT)
      GO TO 1214
 1213 CONTINUE
 1214 ICODE1(73) = 49
C--------
C Determine if line just read is a continuation line.
C--------
      IF(ICODE1(6).EQ.45 .OR. ICODE1(6).EQ.27) GO TO 1216
      IPOINT = 7
      GO TO (1224,1261,1273,1277,1281,1287,1231), ISTATE
C--------
C If line just read was non-continuation line and ISTATE = 1, then just
C  output eoln and continue.
C--------
 1215 ICODE1(7) = 50
      WRITE(IOLIST,1209) (IDUMY(J),J=1,IJK)
 1216 IF(ISTATE.GT.1) GO TO 1217
      INOUT(MPOINT) = 49
      MPOINT = MPOINT + 1
      IPOINT = 7
      GO TO 1224
C--------
C If last line was non-continuation, but FSM was not in state 1 then it
C  must go to state left off to do EOLN activity.
C--------
 1217 IJUMP = 16
      IPOINT = 6
      ICODE1(6) = 49
      GO TO (1216,1262,1274,1278,1282,1288,1232), ISTATE
C--------
C Generate 'error on option card' message
C--------
 1218 CALL ERRMSG(3,IPOINT)
 1219 MPOINT = 1
      GO TO 1203
C--------
C  This section passes control to the variable/function section if it
C  is a letter, or to the number section if it is a number.
C--------
 1220 IF(MODE.NE.0) GO TO 1222
 1221 IF(MODE.NE.0) GO TO 1218
      INOUT(MPOINT) = ICODE1(IPOINT)
      MPOINT = MPOINT + 1
 1222 IPOINT = IPOINT + 1
 1223 ISTATE = 1
 1224 JJUMP = ICODE1(IPOINT)
      IF(MPOINT.GT.NOPS*4) GO TO 1293
      IJUMP = ICODE2(JJUMP)
      GO TO (1228,1258,1221,1221,1226,1221,1221,1221,1225,
     A  1221,1222,1220,1271,1225,1202,1227), IJUMP
C--------
C Illegal character encountered--generate error MSG
C--------
 1225 CALL ERRMSG(4,IPOINT)
      GO TO 1293
C--------
C Exponentiation check, look for '**'
C--------
 1226 IF(MODE.NE.0) GO TO 1218
      ITEMPA = IPOINT + 1
      IF(ICODE1(ITEMPA).NE.39) GO TO 1221
      INOUT(MPOINT) = 48
      MPOINT = MPOINT + 1
      IPOINT = IPOINT + 2
      GO TO 1224
C--------
C Encountered block terminator character for 1st block, go to end.
C--------
 1227 IF(MODE.NE.0) GO TO 1219
      IF(IPOINT.LT.9) GO TO 1294
      INOUT(MPOINT) = 49
      MPOINT = MPOINT + 1
      GO TO 1294
C--------
C Function/variable section, state=7
C  this state recognizes variables and functions.  All identifiers are
C   checked for being a reserved word.
C--------
 1228 NCHARS = 1
      IF(MODE.EQ.1) GO TO 1229
      IF(JJUMP.LT.9 .OR. JJUMP.GT.14) GO TO 1229
      IF(KOUNT.EQ.1) GO TO 1229
      KOUNT = 1
      INTFLG = 1
 1229 IF(JJUMP.GT.19) ICODE1(IPOINT) = JJUMP - 40
      ITEMP(1) = ICODE1(IPOINT)*IMOVE(1)
      ITEMP(2) = 0
      IFLAG = 1
 1230 IPOINT = IPOINT + 1
 1231 ISTATE = 7
      IJUMP = ICODE1(IPOINT)
      IJUMP = ICODE2(IJUMP)
 1232 GO TO (1233,1233,1236,1236,1236,1236,1253,1236,1235,
     A  1236,1230,1236,1235,1236,1202,1236), IJUMP
C--------
C Add a character to the identifier.
C--------
 1233 NCHARS = NCHARS + 1
      IF(NCHARS.EQ.4 .AND. ICODE1(IPOINT).GT.19)
     A   ICODE1(IPOINT) = ICODE1(IPOINT) - 40
      IF(NCHARS.GT.6) GO TO 1234
      ITEMPA = IPART(NCHARS)
      ITEMP(ITEMPA) = ITEMP(ITEMPA) + ICODE1(IPOINT)*IMOVE(NCHARS)
      GO TO 1230
C--------
C Identifier longer than 6 characters
C--------
 1234 IF(IFLAG.EQ.0) GO TO 1230
      IFLAG = 0
      CALL ERRMSG(6,IPOINT)
      GO TO 1293
C--------
C Encountered invalid character
C--------
 1235 CALL ERRMSG(4,IPOINT)
      GO TO 1293
C--------
C Identifier found, search reserved word array (IRESWD) for it.
C--------
 1236 IWORD = ITEMP(1)
      IWTOP = IWORD/1600
      IF(IWTOP.EQ.11 .OR. IWTOP.EQ.14 .OR. IWORD.EQ.(-31464) .OR.
     a (IWORD.EQ.30729.AND.ITEMP(2)/40.EQ.260)) GO TO 1242
      INDEX = IABS(IABS(ITEMP(1)) - IABS(ITEMP(2)))
 1237 INDEX = INDEX - (INDEX/89)*89 + 1
      IF(IRESWD(INDEX,1).EQ.0) GO TO 1243
      IF(IRESWD(INDEX,1).NE.ITEMP(1)) GO TO 1237
      IF(IRESWD(INDEX,2).NE.ITEMP(2)) GO TO 1237
C--------
C Identifier is a reserved word.
C--------
      IF(MODE.EQ.0) GO TO 1242
      IF(MODE.EQ.2.OR.LASTOP.EQ.IDUMP .OR. LASTOP.EQ.ILENVR) GO TO 1218
      IF(INDEX.NE.ICMPLX) GO TO 1238
      KOMPLX = 1
      LASTOP = 0
      GO TO 1222
C--------
C Double option
C--------
 1238 IF(INDEX.NE.IDUBLE) GO TO 1239
      KDOBLE = 1
      LASTOP = 0
      GO TO 1222
C--------
C FNCTN option
C--------
 1239 IF(INDEX.NE.IFNCT) GO TO 1240
      KFNCT = 1
      LASTOP = 0
      GO TO 1222
C--------
C DUMP option
C--------
 1240 IF(IJUMP.NE.10) GO TO 1218
      IF(INDEX.NE.IDUMP) GO TO 1241
      LASTOP = IDUMP
      GO TO 1222
C--------
C LENVAR option
C--------
 1241 IF(INDEX.NE.ILENVR) GO TO 1218
      LASTOP = ILENVR
      GO TO 1222
C--------
C Generate 'used reserved word' error message
C--------
 1242 ITEMPA = IPOINT - NCHARS
      CALL ERRMSG(25,ITEMPA)
      GO TO 1293
C--------
C Identifier is not a reserved word, find its position in (MVAR).
C--------
 1243 MVFLAG = 0
 1244 IF(ITEMP(1).NE.5364) go to 1245
      NUMBER = ITEMP(2) - 15214
      IF(NUMBER.EQ.0) GO TO 1248
      IF(NUMBER.LT.15) GO TO 1245
      NUMBER = NUMBER - 13
      IF(NUMBER.GT.9) GO TO 1245
      NCARD = MAX0(NCARD,NUMBER)
 1245 INDEX = IABS(IABS(ITEMP(1)) - IABS(ITEMP(2)))
 1246 INDEX = INDEX - (INDEX/NVARS)*NVARS + 1
      IF(MVAR(INDEX).EQ.0) GO TO 1249
      IF(MVAR(INDEX).NE.ITEMP(1)) GO TO 1246
      IF(MVAR(INDEX+NVARS).NE.ITEMP(2)) GO TO 1246
      IF(MVFLAG.EQ.1) GO TO 1251
C--------
C Output pointer to variable, which is its index in MVAR + MAXSIZ
C--------
 1247 IF(MODE.NE.0) GO TO 1218
      INOUT(MPOINT) = MAXSIZ + INDEX
      MPOINT = MPOINT + 1
      GO TO 1223
C--------
C If the variable was not in (MVAR), add it to (MVAR).
C--------
 1248 INDEX = 2
      NCARD = MAX0(1,NCARD)
C---This turns on the MVAR for CNDITN of a DAE.
      MVAR(2+NVAR3) = 3
      GO TO 1250
 1249 MVAR(INDEX) = ITEMP(1)
      MVAR(INDEX+NVARS) = ITEMP(2)
 1250 MVAR(INDEX+NVAR3) = 1
      MVCNT = MVCNT + 1
      IF(MVFLAG .EQ. 0) GO TO 1252
C---This points MVAR to the function index 13 in the INOUT stream.
 1251 MTRPL(MPT13) = INDEX
      MPT13 = MPT13 -1
      GO TO 1223
 1252 IF(MVCNT.LE.NVARS) GO TO 1247
C--------
C Variable array full -- generate error message
C--------
      CALL ERRMSG(7, NVARS)
      GO TO 1293
C--------
C If the identifier ends with '(', compare it to a function in IFUNC.
C--------
 1253 IF(ITEMP(1).NE.10180) GO TO 1254
      INOUT(MPOINT) = 13
      MPOINT = MPOINT + 1
C---This is for a user defined function.
      MVFLAG = 1
      GO TO 1244
 1254 INDEX = IABS(IABS(ITEMP(1)) - IABS(ITEMP(2)))
 1255 INDEX = INDEX - (INDEX/31)*31 + 1
      IF(IFUNC(INDEX,1).EQ.0) GO TO 1257
      IF(IFUNC(INDEX,1).NE.ITEMP(1)) GO TO 1255
      IF(IFUNC(INDEX,2).NE.ITEMP(2)) GO TO 1255
      IF(MODE.NE.0) GO TO 1218
      IF(IFUNC(INDEX,3).LT.0) GO TO 1256
      MTF = IFUNC(INDEX,3)
      IFUNC(INDEX,3) = - MTF
 1256 INOUT(MPOINT) = INDEX
      MPOINT = MPOINT + 1
      GO TO 1223
C--------
C The function wasn't in IFUNC -- generate error message
C--------
 1257 ITEMPA = IPOINT - NCHARS
      CALL ERRMSG(8,ITEMPA)
      GO TO 1293
C--------
C  Number section, state=2,3,4,5,6
C--------
 1258 INTEXP = 0
      DTEMP = 0.0D0
 1259 DTEMPA = ICODE1(IPOINT) - 27
      DTEMP = DTEMP + DTEMPA
 1260 IPOINT = IPOINT + 1
 1261 ISTATE = 2
      IJUMP = ICODE1(IPOINT)
      IJUMP = ICODE2(IJUMP)
 1262 GO TO(1263,1264,1265,1265,1265,1265,1270,1265,1225,1270,
     A  1260,1265,1272,1225,1202,1265), IJUMP
C--------
C Check for D or E exponent character
C--------
 1263 IF(ICODE1(IPOINT).EQ.4 .OR. ICODE1(IPOINT).EQ.5) GO TO 1276
      GO TO 1270
C--------
C Process digit to left of decimal point
C--------  This is an overflow test.
 1264 IF(DABS(DTEMP).GE.DMAXA) GO TO 1292
      DTEMP = DTEMP*1.0D1
      GO TO 1259
C--------
C Store the constant in the constant array (DCONS)
C--------
 1265 INDEX = 1
 1266 IF(DCONS(INDEX).EQ.DUNIQ) GO TO 1267
      IF(DCONS(INDEX).EQ.DTEMP) GO TO 1268
      INDEX = INDEX + 1
      IF(INDEX.LE.NEQUS) GO TO 1266
C--------
C Constant array full -- generate error message
C--------
      CALL ERRMSG(9, NEQUS)
      GO TO 1293
C--------
C Output pointer (index of DCONS + 2*MAXSIZ) of the constant
C--------
 1267 DCONS(INDEX) = DTEMP
 1268 IF(MODE.EQ.1) GO TO 1269
      INOUT(MPOINT) = 2*MAXSIZ + INDEX
      MPOINT = MPOINT + 1
      GO TO 1223
 1269 ITEMPA = INT(SNGL(DCONS(INDEX)) + 0.1)
      IF(LASTOP.EQ.ILENVR) LENVAR = ITEMPA
      IF(LASTOP.EQ.IDUMP) KDUMP = ITEMPA
      LASTOP = 0
      GO TO 1222
C--------
C Constant not of correct form -- generate error message
C--------
 1270 CALL ERRMSG(10,IPOINT)
      GO TO 1293
C--------
C If decimal is first character in constant, control is sent here
C--------
 1271 DTEMP = 0.0D0
      INTEXP = 0
      IPOINT = IPOINT + 1
      ITEMPA = ICODE1(IPOINT)
      IF(ICODE2(ITEMPA).NE.2) GO TO 1270
      GO TO 1275
C--------
C Decimal encountered
C--------
 1272 IPOINT = IPOINT + 1
 1273 ISTATE = 3
      IJUMP = ICODE1(IPOINT)
      IJUMP = ICODE2(IJUMP)
 1274 GO TO(1263,1275,1265,1265,1265,1265,1270,1265,1225,1270,
     A  1272,1265,1270,1270,1202,1265), IJUMP
C--------
C Process digits on the right of decimal point
C--------
 1275 IF(IABS(INTEXP).GT.MAXEXP) GO TO 1291
      INTEXP = INTEXP - 1
      DTEMPA = ICODE1(IPOINT) - 27
      DTEMP = DTEMP + DTEMPA * 1.0D1**INTEXP
      GO TO 1272
C--------
C Found the D or E exponent character
C--------
 1276 IPOINT = IPOINT + 1
 1277 ISTATE = 4
      IJUMP = ICODE1(IPOINT)
      IJUMP = ICODE2(IJUMP)
 1278 GO TO(1270,1284,1279,1283,1270,1270,1270,1270,1225,1270,
     A  1276,1270,1270,1270,1202,1270), IJUMP
C--------
C Process 1st digit after + or - appearing after D or E
C--------
 1279 ITEMPA = 1
 1280 IPOINT = IPOINT + 1
 1281 ISTATE = 5
      IJUMP = ICODE1(IPOINT)
      IJUMP = ICODE2(IJUMP)
 1282 GO TO(1270,1285,1270,1270,1270,1270,1270,1270,1225,1270,
     A  1280,1270,1270,1270,1202,1270), IJUMP
C--------
C Process '-' appearing after D or E exponent character
C--------
 1283 ITEMPA = -1
      GO TO 1280
C--------
C Process digits in exponent
C--------
 1284 ITEMPA = 1
 1285 INTEXP = ICODE1(IPOINT) - 27
 1286 IPOINT = IPOINT + 1
 1287 ISTATE = 6
      IJUMP = ICODE1(IPOINT)
      IJUMP = ICODE2(IJUMP)
 1288 GO TO(1270,1289,1290,1290,1290,1290,1270,1290,1225,1270,
     A  1286,1290,1270,1270,1202,1290), IJUMP
C--------
C Compute the exponent
C--------
 1289 IF(INTEXP.GT.MAXEXP) GO TO 1291
      INTEXP = INTEXP*10 + ICODE1(IPOINT) - 27
      GO TO 1286
C--------
C Adjust the mantissa by the exponent
C--------
 1290 IF(INTEXP.GT.MAXEXP) GO TO 1291
      INTEXP = INTEXP*ITEMPA
      ITEMPA = INT(ALOG10(SNGL(DTEMP)) + 0.5) + INTEXP
      IF(IABS(ITEMPA).GT.MAXEXP) GO TO 1291
      DTEMP = DTEMP * (1.0D1**INTEXP)
      GO TO 1265
C--------
C Exponent over/underflow -- generate error message
C--------
 1291 ITEMPA = IPOINT - 2
      CALL ERRMSG(11,ITEMPA)
      GO TO 1293
C--------
C Mantissa under/overflow -- generate error message
C--------
 1292 ITEMPA = IPOINT - 2
      CALL ERRMSG(12,ITEMPA)
 1293 MRUN = 0
 1294 INOUT(MPOINT) = 50
      KPOINT = MPOINT/4
      IF(KDUMP.GT.1) WRITE(IOLIST,1295)KPOINT, NOPS
 1295 FORMAT(' NOPS used',I6,', versus limit of',I6)
      IF(MPOINT.GT.NOPS*4) STOP
      RETURN
C--------
C end LEXBOX
C--------
      END
C GETDIG SUBROUTINE
C ------ ----------
C This subroutine calculates all the important parameters of the
C  host computer.
C ATOMFT version 3.11,  copyright (c) 1993, Y. F. Chang
C***************
      SUBROUTINE GETDIG(NCONT,NDIGIT,RNDOFF)
C***************
C  Usage:
C      INTEGER NCONT,NDIGIT(6)
C      SINGLE PRECISION RNDOFF(4)
C      . . .
C      CALL GETDIG(NCONT,NDIGIT,RNDOFF)
C Input
C    NCONT - flag for printing and CDC/Cray.
C Outputs
C single-precision parameters
C   NDIGIT(1) - binary bits in mantissa
C   NDIGIT(2) - binary bits for minimum guaranteed error,
C   NDIGIT(3) - single-precision maximum decimal exponent,
C               1.E(NDIGIT(3)) without the leading zero(s).
C   RNDOFF(1) - roundoff error = 2**(-NDIGIT(1))
C   RNDOFF(2) - minimum guaranteed error = 2**(-NDIGIT(2))
C double-precision parameters
C   NDIGIT(4) - binary bits in mantissa
C   NDIGIT(5) - binary bits for minimum guaranteed error
C   NDIGIT(6) - double-precision maximum decimal exponent,
C               1.E(NDIGIT(6)) without the leading zero(s).
C   RNDOFF(3) - roundoff error = 2**(-NDIGIT(4))
C   RNDOFF(4) - minimum guaranteed error = 2**(-NDIGIT(5))
C***************
      DOUBLE PRECISION D,DA,DB,DC(2),DSA,DSB,DDR,DRR

C MSF:
C     Microsoft Fortran version 5.1 requires the [NEAR] attribute:
C      DIMENSION SSR[NEAR](2),NDIGIT(6),RNDOFF(4)
      DIMENSION SSR(2),NDIGIT(6),RNDOFF(4)

      CHARACTER*6 SGL,DBL,BLK
C MSF:
C Remove the comment C only for Microsoft.
C      INTEGER*4 INTS

      EQUIVALENCE (DRR,INTS),(DDR,SSR(1))
      DATA DC,SGL,DBL,BLK/8.D0,1.18D0,'SINGLE','DOUBLE','      '/
C--------
C log 8 yields roundoff error; log 1.18 yields min guaranteed error.
C--------
      DO 1307 I=1,2
      D = DLOG10(DC(I))
C--------
C Single-precision calculations.
C--------
      SA = D
C--------
C Make the initial roundoff 1.E-4.  This is purposely too large.
C--------
      DA = 1.D-5
 1301 DA = DA*1.D-1
      DO 1302 K=1,10000
C--------
C Adjust SB until it does not match SA minimally.
C--------
      SB = D + K*DA
      IF(SB .NE. SA) GO TO 1303
 1302 CONTINUE
C--------
C If no match on the very first loop, the increment is too large.
C--------
 1303 IF(K .EQ. 1) GO TO 1301
C--------
C NDIGIT(1) is the single-precision mantissa.
C--------
      NDIGIT(I) = - ALOG10((ABS(SB - SA)/SA))/0.30103 + 0.3
C--------
C RNDOFF(1) is the roundoff error.
C RNDOFF(2) is the minimum guaranteed error.
C--------
      RNDOFF(I) = 2.0**(-NDIGIT(I))
C--------
C Single-precision mantissa yields DB, initial double-precision
C roundoff.
C--------
      DB = 1.D1**(-INT(0.60206*NDIGIT(1) - 3.0))
C--------
C Double-precision calculations.
C--------
      DSA = D
      DA = DB*D
 1304 DA = DA*1.D-1
      DO 1305 K=1,10000
C--------
C Adjust DSB until it does not match DSA minimally.
C--------
      DSB = D + K*DA
      IF(DSB .NE. DSA) GO TO 1306
 1305 CONTINUE
C--------
C If no match on the very first loop, the increment is too large.
C--------
 1306 IF(K .EQ. 1) GO TO 1304
C--------
C NDIGIT(4) is the double-precision mantissa.
C--------
      NDIGIT(I+3) = - DLOG10(DABS(DSB - DSA)/DSA)/0.30103D0 + 0.3D0
C--------
C RNDOFF(3) is the roundoff error.
C RNDOFF(4) is the minimum guaranteed error.
C--------
 1307 RNDOFF(I+2) = 2.D0**(-NDIGIT(I+3))
C--------
C Adjust the (roundoff/min error) gap for exponent calculations.
C--------
      NBAS = NDIGIT(1) - NDIGIT(2)
C--------
C Use log 2 to find the maximum integer length, NBINT.
C--------
      DRR = DLOG10(2.D0)
      DA = INTS
      NBINT = DLOG10(DA)/0.30103D0 + 0.3D0
C--------
C NBW is the word length, except for two special cases.
C--------
      NBW = 4*(NBINT/4 + 1)
C--------
C Adjust the exponent lengths for computers with squeezed exponents.
C--------
      NBXFLG = 0
C--------
C Adjust for non-HEX computers.
C--------
      IF((MAX(32,NBW)-NDIGIT(1)).LT.9 .AND. NBAS.LT.4) NBXFLG = 1
C--------
C (Special cases) The word lengths for Burroughs 5/6/7700 and CDC.
C--------
      IF(NBW.GT.39 .AND. NBXFLG.EQ.1) NBW = 4*((NDIGIT(1)*6)/40 + 1)
C--------
C Adjust the exponent length for Burroughs 1700
C--------
      IF(NBW.LT.60 .AND. (NBW-NDIGIT(1)).GT.11) NBXFLG = -2
C--------
C Adjust the exponent lengths for CDC and Cray.
C--------
      IF(NBW .LT. 60) GO TO 1309
      NBXFLG = NBXFLG - 1
      IF(NCONT .LT. 8) THEN
        WRITE(*,1308)
 1308 FORMAT(' The host computer is either Cray or CDC.'/
     A ' If it is a Cray, set COPTION DUMP=8 in Block #1 of ODEINP.'/
     A ' If it is a CDC, set COPTION DUMP=9 in Block #1 of ODEINP.')
        STOP
      ELSE
        IF(NCONT .EQ. 8) NBW = 64
      ENDIF
C--------
C Determine whether double and single have the same exponent.
C--------
 1309 NBDFLG = 0
      SSR(1) = 10.0**(37)
      SSR(2) = SSR(1)*2.0**(-48)
C--------
C NBDFLG is a flag for the number of bits in double vs single.
C 1 = not same.
C--------
      IF(DDR .GT. (8.D0*SSR(1))) NBDFLG = 1
C--------
C Here is the log of the base for the computer real numbers.
C--------
      BASL = ALOG10(2.0**(NBAS))
      IF(NBW.EQ.48 .AND. NDIGIT(1).EQ.39) GO TO 1310
C--------
C Calculate the single-precision maximum decimal exponent.
C--------
      NDIGIT(3) = (2**(MAX(32,NBW)-NDIGIT(1)-2+NBXFLG)-1)*BASL
C--------
C Round down to mod 100.
C--------
      IF(NDIGIT(3) .GT. 1000) NDIGIT(3) = (NDIGIT(3)/100)*100
      NDIGIT(6) = NDIGIT(3)
C--------
C Calculate the double-precision maximum decimal exponent, if different.
C--------
      IF(NBDFLG.EQ.1) NDIGIT(6) = (2**(2*NBW-NDIGIT(4)-2+NBXFLG)-1)*BASL
      GO TO 1311
C--------
C Burroughs 5/6/7700.
C--------
 1310 NDIGIT(3) = 68
      NDIGIT(6) = 68 + NBDFLG*29500
C--------
C Round down to mod 100.
C--------
 1311 IF(NDIGIT(6) .GT. 1000) NDIGIT(6) = (NDIGIT(6)/100)*100
C--------
C Don't print the results if the no-print flag is up.
C--------
      IF(NCONT .GT. 0 .AND. NCONT .LT. 8) RETURN
      WRITE(*,1312)SGL,NDIGIT(1),RNDOFF(1),RNDOFF(2),SGL,NDIGIT(3),BLK,
     A NBW
 1312 FORMAT(1X,A6,'-precision mantissa has',I3,' binary bits,'/15X,
     A 'round-off error',1PE11.2/6X,'minimum guaranteed error',1PE11.2/
     A A8,'-precision max value, 10**(',I5,'), approximately.'/
     A A7,'The real number unit is',I3,' binary bits long.')
      WRITE(*,1312)DBL,NDIGIT(4),RNDOFF(3),RNDOFF(4),DBL,NDIGIT(6)
      RETURN
C--------
C end GETDIG
C--------
      END
C SYNTAX SUBROUTINE
C ------ ----------
C This subroutine checks the output from LEXBOX for syntax errors.
C***************
      SUBROUTINE SYNTAX(DCONS,MTRPL,INOUT,MND,MVAR,MEQU)
C***************
      DIMENSION DCONS(1),MTRPL(1),INOUT(1),MND(1),MVAR(1),MEQU(1)

C MSF:
C     Microsoft Fortran version 5.1 requires the [NEAR] attribute:
c      DIMENSION JDIF(10),JB[NEAR](18,18),JBA[NEAR](162),JBB[NEAR](162)
      DIMENSION JDIF(10),JB(18,18),JBA(162),JBB(162)

      DOUBLE PRECISION DCONS
      COMMON/SIZE/NEQUS,NVARS,NOPS,MSTK(200)
      COMMON/OUTPUT/LOOPNX,LOPLIM(48),LITNUM,LITKNT,LIMPLI(48)
     B /FLAGS/MRUN,MVCNT /IOUNIT/IOINPU,IOLIST,IOOBJE,MAXSIZ,NTYP2
     E /ATSOPT/KDUMP,LENVAR,KDOBLE,KOMPLX,KFNCT,NCARD
      EQUIVALENCE (JB(1,1),JBA(1)),(JB(1,10),JBB(1))
      DATA INOUTP,MTRPLP,MSTKP,MEQUP,MNDP / 5*1 /
      DATA JDIF/-14,10,4,14,0,3,14,0,3,9/
      DATA JBA/21,21,22,23,21,7,24,12,26,27,28,29,15,30,28,19,31,32,
     A 3,5,22,23,6,7,24,12,26,27,28,29,15,30,28,20,31,32,
     B 3,4,2,23,6,7,24,12,26,27,28,29,15,30,28,18,31,32,
     C 21,21,22,2,21,7,24,12,26,27,28,29,15,30,28,18,31,32,
     D 21,21,22,23,21,8,10,25,26,27,1,29,25,30,1,25,31,32,
     E 21,21,22,23,21,9,11,25,26,27,1,29,25,30,1,25,31,32,
     F 21,21,22,23,21,24,24,25,26,27,13,29,25,30,1,25,31,32,
     G 21,21,22,23,21,24,24,25,26,27,14,29,25,30,1,25,31,32,
     H 21,21,22,23,21,7,24,12,2,27,28,29,15,30,28,17,31,32/
      DATA JBB/21,21,22,23,21,24,1,25,26,2,1,29,25,30,1,25,31,32,
     J 21,21,22,23,21,24,24,25,26,27,28,29,25,30,28,25,31,32,
     K 21,21,22,23,21,24,24,25,26,27,28,2,25,30,28,25,31,32,
     L 21,21,22,23,21,24,24,25,26,27,28,29,25,30,28,25,31,32,
     M 21,21,22,23,21,24,24,25,26,27,28,29,25,2,28,25,31,32,
     N 21,21,22,23,21,24,24,25,26,27,28,29,25,30,28,25,31,32,
     O 21,21,22,23,21,24,24,25,26,27,28,29,25,30,16,25,31,32,
     P 21,21,22,23,21,24,1,25,26,27,1,29,25,30,1,25,2,32,
     Q 21,21,22,23,1,24,24,25,26,27,28,29,25,30,28,25,31,33/
      NVAR3 = NVARS*2
      NVAR4 = NVARS*3
      NOP3 = NOPS*2
      NOP4 = NOPS*3
      MPT13 = NOPS
C--------
C Start parse
C--------
      MXSIZ = MAXSIZ/10
      MSTK(1) = 1
      GO TO 1433
C-------
C Postfix -> triplet
C--------
 1401 MTEMP1 = - MTEMP1
      MTRPL(MTRPLP) = MTEMP1
      MTRPL(MTRPLP+NOP4) = 21
      MTEMP2 = MNDP - 1
      IF(LOPLIM(MTEMP1).EQ.2) GO TO 1402
      MTRPL(MTRPLP+NOPS) = MND(MTEMP2)
      MTRPL(MTRPLP+NOP3) = 0
      MND(MTEMP2) = MTRPLP
      MTRPLP = MTRPLP + 1
      IF(MTEMP1.NE.13) GO TO 1410
      MV = MTRPL(MPT13)
      MPT13 = MPT13 - 1
      MINUS = MTRPLP - 1
      MTRPL(MINUS+NOP3) = MV + MAXSIZ
      MVAR(MV+NVAR3) = 3
      MVAR(MV+NVAR4) = 0
      GO TO 1410
 1402 MTEMP1 = MNDP - 2
      MTRPL(MTRPLP+NOPS) = MND(MTEMP1)
      MTRPL(MTRPLP+NOP3) = MND(MTEMP2)
      MND(MTEMP1) = MTRPLP
      MNDP = MTEMP2
      IF(MTRPL(MTRPLP).NE.44) GO TO 1404
      MTEMP1 = MTRPL(MTRPLP+NOPS)
      IF(MTEMP1.GT.MAXSIZ) GO TO 1403
      MTEMP2 = MTRPL(MTEMP1+NOP3)/MAXSIZ
      MTEMP2 = MTRPL(MTEMP1+NOP3) - MTEMP2*MAXSIZ
      IF(MEQU(MTEMP2+NVAR3).EQ.(-1)) GO TO 1405
      IF(MEQU(MTEMP2+NVAR3).EQ.0) MEQU(MTEMP2+NVAR3) = -2
      MTEMP1 = MTRPL(MTEMP1+NOPS)
 1403 MTEMP1 = MTEMP1 - MAXSIZ
      IF(MEQU(MTEMP1+NVAR3).NE.0) GO TO 1405
      MEQU(MTEMP1+NVAR3) = - 1
      MEQU(MEQUP) = MTRPLP
      MEQUP = MEQUP + 1
 1404 MTRPLP = MTRPLP + 1
      IF(MEQUP.GT.NEQUS) GO TO 1406
      GO TO 1410
C--------
C Redefined variable
C--------
 1405 CALL ERRMSG(30,MEQUP)
      GO TO 1438
C--------
C Too many equations
C--------
 1406 WRITE(IOLIST,1407) NEQUS
 1407 FORMAT(47H  The number of equations exceeds the limit of ,I4)
      GO TO 1438
C--------
C Pop, retain
C--------
 1408 JRETRN = 1
      GO TO 1410
C--------
C Pop advance
C--------
 1409 JRETRN = 2
 1410 MSTKP = MSTKP - 1
      MTEMP1 = MSTK(MSTKP)
      IF(MTEMP1.GT.0) GO TO (1437,1433), JRETRN
      IF(MTEMP1.GT.(-49)) GO TO 1401
      MND(MNDP) = - MTEMP1
      MNDP = MNDP + 1
      GO TO 1410
C--------
C PROD #1  -> <2> <5> 18 -50
C--------
 1411 MSTK(MSTKP) = 18
      MSTKP = MSTKP + 1
      MSTK(MSTKP) = 5
      MSTKP = MSTKP + 1
      MSTK(MSTKP) = 2
      GO TO 1437
C--------
C PROD #2  -> 3 -1000 12 -44 <6> 17 -49
C--------
 1412 MND(MNDP) = INOUT(INOUTP)
      MNDP = MNDP + 1
      MSTK(MSTKP) = 17
      MSTKP = MSTKP + 1
      MSTK(MSTKP) = - 44
      MSTKP = MSTKP + 1
      MSTK(MSTKP) = 6
      MSTKP = MSTKP + 1
      MSTK(MSTKP) = 12
      GO TO 1433
C--------
C PROD #3  -> 2 9 3 -1000 14 3 14 4 -2000 10 -34 12 -44 <6> -3000
C--------
 1413 MSTK(MSTKP) = 17
      MSTKP = MSTKP + 1
      MSTK(MSTKP) = - 44
      MSTKP = MSTKP + 1
      MSTK(MSTKP) = - 39
      MSTKP = MSTKP + 1
      INDEX = INOUTP + 6
      INDEX = INOUT(INDEX) - 2*MAXSIZ
      INDEX = INT(SNGL(DCONS(INDEX)) + 0.01)
      INDX = INDEX
      IF(INDEX.EQ.0) INDEX = 9
      MSTK(MSTKP) = - (INDEX + 3*MAXSIZ)
      MSTKP = MSTKP + 1
      MSTK(MSTKP) = 6
      MSTKP = MSTKP + 1
      MSTK(MSTKP) = 12
      GO TO 1428
C--------
C PROD #4  -> <2> <5>
C--------
 1414 MSTKP = MSTKP + 1
      MSTK(MSTKP) = 2
      GO TO 1437
C--------
C PROD #6  -> <8> <7>
C--------
 1415 MSTK(MSTKP) = 7
      MSTKP = MSTKP + 1
      MSTK(MSTKP) = 8
      GO TO 1437
C--------
C PROD #7  -> 5 <8> <7>
C--------
 1416 MSTK(MSTKP) = 7
      GO TO 1419
C--------
C PROD #8  -> 6 <8> -36 <7>
C--------
 1417 MSTK(MSTKP) = 7
      INOUT(INOUTP) = 36
C--------
C PRODS #9, #10  -> 6 <8> -38 <7>
C--------
 1418 MSTKP = MSTKP + 1
      MSTK(MSTKP) = - INOUT(INOUTP)
 1419 MSTKP = MSTKP + 1
      MSTK(MSTKP) = 8
      GO TO 1433
C--------
C PROD #12  -> <13> <11>
C--------
 1420 MSTK(MSTKP) = 11
      MSTKP = MSTKP + 1
      MSTK(MSTKP) = 13
      GO TO 1437
C--------
C PRODS #13, #14  -> 8 <13> -40 <11>
C--------
 1421 MSTKP = MSTKP + 1
      MSTK(MSTKP) = - INOUT(INOUTP)
      MSTKP = MSTKP + 1
      MSTK(MSTKP) = 13
      GO TO 1433
C--------
C PROD #16  -> <16> <15>
C--------
 1422 MSTK(MSTKP) = 15
      MSTKP = MSTKP + 1
      MSTK(MSTKP) = 16
      GO TO 1437
C--------
C PROD #17  -> 16 <16> -48 <15>
C--------
 1423 MSTKP = MSTKP + 1
      MSTK(MSTKP) = - 48
      MSTKP = MSTKP + 1
      MSTK(MSTKP) = 13
      GO TO 1433
C--------
C PROD #19  -> 9 <6> 10
C--------
 1424 MSTK(MSTKP) = 10
      MSTKP = MSTKP + 1
      MSTK(MSTKP) = 6
      GO TO  1433
C--------
C PRODS #20, #21  -> 4 -2000
C--------
 1425 MND (MNDP) = INOUT(INOUTP)
      MNDP = MNDP + 1
      GO TO 1409
C--------
C PROD #22  -> 1 9 <6> 10 -33
C--------
 1426 MSTK(MSTKP) = - INOUT(INOUTP)
      MSTKP = MSTKP + 1
      MSTK(MSTKP) = 10
      MSTKP = MSTKP + 1
      MSTK(MSTKP) = 6
      MSTKP = MSTKP + 1
      MSTK(MSTKP) = 9
      GO TO 1433
C--------
C PROD #23  -> 2 9 3 -1000 14 3 14 4 -2000 10 -34 -3000 -40
C--------
 1427 MSTK(MSTKP) = - 40
      MSTKP = MSTKP + 1
      INDEX = INOUTP + 6
      INDEX = INOUT(INDEX) -  2*MAXSIZ
      INDEX = INT(SNGL(DCONS(INDEX)) + 0.1)
      INDX = INDEX
      IF(INDEX.EQ.0) INDEX = 9
      MSTK(MSTKP) = - (INDEX + 3*MAXSIZ)
 1428 IF(INDX.LT.0 .OR. INDX.GT.8) GO TO 1431
      MTEMP1 = INOUTP + 2
      JDIF(8) = - INOUT(MTEMP1)
      MTEMP1 = INOUTP + 4
      JDIF(5) = - (INOUT(MTEMP1) + INDX*MXSIZ)
      DO 1429 INDEX=1,10
      MSTKP = MSTKP + 1
      MSTK(MSTKP) = JDIF(INDEX)
 1429 CONTINUE
      GO TO 1433
C--------
C Calls to the syntax error messages
C--------
 1430 JERRNO = JUMP - 8
      GO TO 1432
C--------
C DIFF-order error
C--------
 1431 JERRNO = 27
 1432 CALL ERRMSG(JERRNO,INPUT)
      CALL ERRMSG(32,MEQUP)
      GO TO 1438
C--------
C This is the transition section.  The top stack element and the input
C  determines which section of code is to handle them.
C--------
 1433 INOUTP = INOUTP + 1
      INPUT = INOUT(INOUTP)
      JUMP = INPUT/MAXSIZ + 1
      GO TO (1434,1435,1436), JUMP
 1434 IF(INPUT.EQ.14) INPUT = 34
      IF(INPUT.LT.33) INPUT = 33
      INPUT = INPUT - 32
      GO TO 1437
 1435 INPUT = 3
      GO TO 1437
 1436 INPUT = 4
 1437 JUMP = MSTK(MSTKP)
      JUMP = JB(JUMP,INPUT)
      GO TO (1408,1409,1411,1412,1413,1414,1415,1416,1417,1418,
     A 1418,1420,1421,1421,1422,1423,1424,1425,1426,1427,
     B 1430,1430,1430,1430,1430,1430,1430,1430,1430,1430,
     C 1430,1430,1439), JUMP
 1438 MRUN = 0
 1439 MSTK(1) = MEQUP - 1
      MSTK(200) = MTRPLP
      MTRPL(MTRPLP) = 50
      MTRPLP = MTRPLP + NOPS - MPT13
      IF(KDUMP.GT.1) WRITE(IOLIST,1440)MTRPLP, NOPS
 1440 FORMAT(' NOPS used',I6,', versus limit of',I6)
      IF(MTRPLP.GT.NOPS) STOP
      RETURN
C--------
C end SYNTAX
C--------
      END
C EXPAND SUBROUTINE
C ------ ----------
C This subroutine expands the multiplications.
C***************
      SUBROUTINE EXPAND(MEQL,DCONS,MTRPL,INOUT,MEQU)
C***************
      DIMENSION DCONS(1),MTRPL(1),INOUT(1),MEQU(1)
      DOUBLE PRECISION DCONS,DSET,DTEST
      COMMON/SIZE/NEQUS,NVARS,NOPS,MSTK(200)
      COMMON/IOUNIT/IOINPU,IOLIST,IOOBJE,MAXSIZ,NTYP2
      NOP3 = NOPS*2
      NOP4 = NOPS*3
      MXSIZ = MAXSIZ/10
      DSET = 1.D0 + 1.D-14
      MSTKP = 0
      NEXT = MSTK(200)
      MTEMP1 = NEXT - 1
      LREQP = MEQL
C Move all triplets to INOUT for the expansion of  Y**3 to Y*Y*Y.
      DO 1502 INDEX=1,MTEMP1
      IND = NEXT - INDEX
      MTEMP2 = MTRPL(IND)
      INOUT(IND) = MTEMP2
      INOUT(IND+NOPS) = MTRPL(IND+NOPS)
      INOUT(IND+NOP3) = MTRPL(IND+NOP3)
      IF(MTEMP2.NE.14) GO TO 1501
      MTEMP3 = MTRPL(IND+NOP3)/MXSIZ
      NTYP2 = MTRPL(IND+NOP3) - MTEMP3*MXSIZ
      GO TO 1502
 1501 IF(MTEMP2.NE.48) GO TO 1502
      MSTKP = MSTKP + 1
C Store position of ** operation.
      MSTK(MSTKP) = IND
 1502 CONTINUE
C The DO-1507 tests **N and converts it to multiplication for N<5.
      IF(MSTKP.EQ.0) GO TO 1511
      DO 1507 IND=1,MSTKP
      MTEMP2 = MSTK(IND)
      MTEMP3 = INOUT(MTEMP2+NOP3)
      IF(MTEMP3.LT.2*MAXSIZ) GO TO 1507
      MTEMP3 = MTEMP3 - 2*MAXSIZ
      ITEST = DCONS(MTEMP3)*DSET
      DTEST = ITEST
      IF(DCONS(MTEMP3).GT.DTEST .OR. ITEST.GT.4) GO TO 1507
      MTEMP6 = INOUT(MTEMP2+NOPS)
      IF(ITEST-2) 1503,1505,1506
 1503 INOUT(MTEMP2) = 0
      DO 1504 MTEMP5=1,mtemp1
      IF(INOUT(MTEMP5+NOPS).EQ.MTEMP2) INOUT(MTEMP5+NOPS) = MTEMP6
      IF(INOUT(MTEMP5+NOP3).EQ.MTEMP2) INOUT(MTEMP5+NOP3) = MTEMP6
 1504 CONTINUE
      GO TO 1507
 1505 INOUT(MTEMP2) = 39
      INOUT(MTEMP2+NOP3) = INOUT(MTEMP2+NOPS)
      GO TO 1507
C Operation #49 is used to indicate **N.
 1506 INOUT(MTEMP2) = 49
      MTEMP4 = INOUT(MTEMP2+NOPS)
      IF(ITEST.EQ.4) MTEMP4 = -1
      INOUT(MTEMP2+NOP3) = MTEMP4
 1507 CONTINUE
      LREQP = 1
      KT = 0
C DO-1510 adds the extra multiplication needed for **N.
C  It also adds triplets for functions of expressions.
      DO 1510 IND=1,MTEMP1
      MTEMP2 = INOUT(IND)
      IF(MTEMP2.EQ.49) GO TO 1509
      IF(MTEMP2.EQ.0) GO TO 1510
      IF(MTEMP2.NE.44) GO TO 1508
      MEQU(LREQP) = KT + 1
      LREQP = LREQP + 1
 1508 KT = KT + 1
      MTRPL(KT) = INOUT(IND)
      LCOL2 = INOUT(IND+NOPS)
      LCOL3 = INOUT(IND+NOP3)
      INOUT(IND+NOP4) = KT
      IF(LCOL2.lt.MAXSIZ) LCOL2 = INOUT(LCOL2+NOP4)
      MTRPL(KT+NOPS) = LCOL2
      IF(LCOL3.lt.MAXSIZ) LCOL3 = INOUT(LCOL3+NOP4)
      MTRPL(KT+NOP3) = LCOL3
      MTRPL(KT+NOP4) = 21
      GO TO 1510
 1509 MTEMP4 = INOUT(IND+NOPS)
      KT = KT + 1
      MTRPL(KT) = 39
      MTRPL(KT+NOPS) = MTEMP4
      MTRPL(KT+NOP3) = MTEMP4
      mtrpl(kt+NOP4) = 21
      KT = KT + 1
      MTRPL(KT) = 39
      MTRPL(KT+NOP3) = KT - 1
      MTRPL(KT+NOPS) = MTEMP4
      MTRPL(KT+NOP4) = 21
      MTEMP4 = INOUT(IND+NOP3)
      IF(MTEMP4.LT.0) MTRPL(KT+NOPS) = KT - 1
      INOUT(IND+NOP4) = KT
 1510 CONTINUE
      NEXT = KT + 1
      MTRPL(NEXT) = 50
      MSTK(1) = MEQL
 1511 MSTK(198) = NEXT
      MSTK(200) = LREQP
C------
C end EXPAND
C------
      RETURN
      END
C OPTMIZ SUBROUTINE
C ------ ----------
C This subroutine optimizes the input triplets in (MTRPL).
C***************
      SUBROUTINE OPTMIZ(MEQL,MTRPL,INOUT,MND,MVAR,MEQU)
C***************
      DIMENSION MTRPL(1),INOUT(1),MND(1),MVAR(1),MEQU(1)
      DIMENSION MOCNT(48,2),LCOLX(4),KCHG(5)
      LOGICAL FLAG1,FLAG2,FLAG3,FLAG4,LCHNGE
      COMMON/SIZE/NEQUS,NVARS,NOPS,MSTK(200)
      COMMON/OUTPUT/LOOPNX,LOPLIM(48),LITNUM,LITKNT,LIMPLI(48)
     D /FLAGS/MRUN,MVCNT
      COMMON/IOUNIT/IOINPU,IOLIST,IOOBJE,MAXSIZ,NTYP2
      DATA LCOLX/1,2,3,2/,KCHG/37,38,40,39,40/
      NVAR3 = NVARS*2
      NOP3 = NOPS*2
      NOP4 = NOPS*3
      LREQP = MSTK(200)
      NEXT  = MSTK(198)
      DO 1601 INDEX=1,48
      MOCNT(INDEX,1) = 0
 1601 CONTINUE
      MTEMP1 = LREQP - 1
      DO 1607 INDEX=1,MTEMP1
      MSTKP = 1
      MTRPLP = MEQU(INDEX)
C DO-1607 locates and counts all operations by their code numbers.
C  This count is stored in MOCNT.
      LAST = MTRPLP
      LCOL = 2
 1602 LOP = MTRPL(MTRPLP)
      MOCNT(LOP,1) = MOCNT(LOP,1) + 1
      MTEMP2 = 1
      IF(MTRPL(MTRPLP+NOPS).LT.MAXSIZ) MTEMP2 = 2
      IF(LOPLIM(LOP).LT.2) GO TO 1603
      IF(MTRPL(MTRPLP+NOP3).LT.MAXSIZ) MTEMP2 = MTEMP2 + 2
 1603 LCOL = LCOLX(MTEMP2)
      GO TO (1604,1606,1606,1605), MTEMP2
 1604 IF(MSTKP.LT.4) GO TO 1607
      MSTKP = MSTKP - 3
      LCOL = MSTK(MSTKP)
      LAST = MSTK(MSTKP+1)
      MTRPLP = MSTK(MSTKP+2)
      GO TO 1606
 1605 MSTK(MSTKP) = 3
      MSTK(MSTKP+1) = LAST
      MSTK(MSTKP+2) = MTRPLP
      MSTKP = MSTKP + 3
 1606 LAST = MTRPLP
      MTP = MTRPLP + NOPS*(LCOL - 1)
      MTRPLP = MTRPL(MTP)
      GO TO 1602
 1607 CONTINUE
      MOCNT(44,1) = MOCNT(44,1) + NOPS - NEXT
      MOCNT(1,2) = 1
      DO 1608 INDEX=2,48
      MTEMP1 = INDEX - 1
      MOCNT(INDEX,2) = MOCNT(MTEMP1,1) + MOCNT(MTEMP1,2)
      MOCNT(MTEMP1,1) = 0
 1608 CONTINUE
      MOCNT(48,1) = 0
      MTEMP1 = LREQP - 1
C DO-1614 catalogs (lists) all the operations counted in DO-1607.
C  Counting and cataloging cannot be done in a single loop, because
C  only one stack is used and overlapping must be avoided.
      DO 1614 INDEX=1,MTEMP1
      MTRPLP = MEQU(INDEX)
      LAST = MTRPLP
      LCOL = 2
 1609 LOP = MTRPL(MTRPLP)
      MTEMP2 = MOCNT(LOP,1) + MOCNT(LOP,2)
      INOUT(MTEMP2) = LAST
      IF(LCOL.EQ.2) INOUT(MTEMP2) = -INOUT(MTEMP2)
      INOUT(MTEMP2+NOPS) = INDEX
      MOCNT(LOP,1) = MOCNT(LOP,1) + 1
      MTEMP2 = 1
      IF(MTRPL(MTRPLP+NOPS).LT.MAXSIZ) MTEMP2 = 2
      IF(LOPLIM(LOP).LT.2) GO TO 1610
      IF(MTRPL(MTRPLP+NOP3).LT.MAXSIZ) MTEMP2 = MTEMP2 + 2
 1610 LCOL = LCOLX(MTEMP2)
      GO TO (1611,1613,1613,1612), MTEMP2
 1611 IF(MSTKP.LT.4) GO TO 1614
      MSTKP = MSTKP - 3
      LCOL = MSTK(MSTKP)
      LAST = MSTK(MSTKP+1)
      MTRPLP = MSTK(MSTKP+2)
      GO TO 1613
 1612 MSTK(MSTKP) = 3
      MSTK(MSTKP+1) = LAST
      MSTK(MSTKP+2) = MTRPLP
      MSTKP = MSTKP + 3
 1613 LAST = MTRPLP
      MTP = MTRPLP + NOPS*(LCOL - 1)
      MTRPLP = MTRPL(MTP)
      GO TO 1609
 1614 CONTINUE
      MOCNT(47,1) = 0
 1615 LCHNGE = .FALSE.
C DO-1648 searches for matching operations by code numbers
C  starting with one and ending with 48.
      DO 1648 INDEX=1,48
      MTEMP4 = MOCNT(INDEX,1) - 1
      IF(MTEMP4.LT.1) GO TO 1648
      MTEMP1 = MOCNT(INDEX,2)
      MTEMP4 = MTEMP1 + MTEMP4
      DO 1616 MTEMP3=1, NOPS
 1616 INOUT(MTEMP3+NOP3) = 0
      FLAG1 = INDEX.NE.44
      FLAG2 = LOPLIM(INDEX).EQ.2
      FLAG3 = INDEX.EQ.37 .OR. INDEX.EQ.39
      FLAG4 = INDEX.NE.48
      DO 1647 INDEX1=MTEMP1, MTEMP4
      LPTR2 = INOUT(INDEX1)
      IF(LPTR2.EQ.0) GO TO 1647
      LCOL2 = 3
      IF(LPTR2.GT.0) GO TO 1617
      LCOL2 = 2
      LPTR2 = - LPTR2
 1617 LPTRB = LPTR2
      MTP = LPTR2 + NOPS*(LCOL2 - 1)
      IF(FLAG1) LPTRB = MTRPL(MTP)
      IF(LPTRB.GT.MAXSIZ) GO TO 1647
      IF(MTRPL(LPTRB).EQ.0) GO TO 1647
      MTEMP5 = MTRPL(LPTRB+NOPS)
      MTEMP6 = MTRPL(LPTRB+NOP3)
C The line below is for the function that has only one operand.
      IF(.NOT. FLAG2) MTEMP6 = 0
C ISUM is a hashing function so that we can save time on the matchings.
C  This is 1000 times faster than a pair-pair comparison for an array
C  of 1000.
      ISUM = MTEMP5 - (MTEMP5/MAXSIZ)*MAXSIZ + MTEMP6 -
     A (MTEMP6/MAXSIZ)*MAXSIZ
 1618 ISUM = ISUM - (ISUM/NOPS)*NOPS + 1
      IF(INOUT(ISUM+NOP3).EQ.0) GO TO 1646
C Bring back the old attributes.
      LPTRA = INOUT(ISUM+NOP3)
      LPTR1 = INOUT(ISUM+NOP4)
      INDEX0 = MND(ISUM)
      LCOL1 = 3
      IF(LPTR1.GT.0) GO TO 1619
      LCOL1 = 2
      LPTR1 = - LPTR1
C Comparison
 1619 IF(LPTR1.EQ.LPTR2 .AND. LPTRA.EQ.LPTRB) GO TO 1647
      IF(FLAG2) GO TO 1620
C For functions with only one operand.  Do not match FNT's.
      IF(MTRPL(LPTRA+NOP3).EQ.MTRPL(LPTRB+NOP3)) GO TO 1622
      IF(MTRPL(LPTRA) .EQ. 13) GO TO 1618
      IF(MTRPL(LPTRA+NOPS).EQ.MTRPL(LPTRB+NOPS)) GO TO 1622
      GO TO 1618
 1620 IF(MTRPL(LPTRA+NOPS).EQ.MTRPL(LPTRB+NOPS) .AND.
     A MTRPL(LPTRA+NOP3).EQ.MTRPL(LPTRB+NOP3)) GO TO 1622
      IF(FLAG3 .AND. MTRPL(LPTRA+NOPS).EQ.MTRPL(LPTRB+NOP3) .AND.
     A MTRPL(LPTRA+NOP3).EQ.MTRPL(LPTRB+NOPS)) GO TO 1622
      IF(FLAG4 .OR. MTRPL(LPTRA+NOPS).GT.MAXSIZ .OR.
     A MTRPL(LPTRB+NOPS).GT.MAXSIZ .OR.
     B MTRPL(LPTRA+NOP3).NE.MTRPL(LPTRB+NOP3)) GO TO 1618
C Extra ** comparison
      MTEMP5 = MTRPL(LPTRA+NOPS)
      MTEMP6 = MTRPL(LPTRB+NOPS)
      IF(MTRPL(MTEMP5).NE.47 .OR. MTRPL(MTEMP6).NE.47) GO TO 1618
      IF(MTRPL(MTEMP5+NOPS).GT.MAXSIZ) GO TO 1621
      IF(MTRPL(MTEMP6+NOPS).GT .MAXSIZ .OR.
     A     MTRPL(MTEMP5+NOP3).NE.MTRPL(MTEMP6+NOP3)) GO TO 1618
      GO TO 1622
 1621 IF(MTRPL(MTEMP6+NOPS).LT.MAXSIZ .OR.
     A     MTRPL(MTEMP5+NOPS).NE.MTRPL(MTEMP6+NOPS)) GO TO 1618
 1622 LCHNGE = .TRUE.
      IF(MTRPL(LPTRA).NE.14) GO TO 1623
      MTP = LPTR1 + NOPS*(LCOL1 - 1)
      MTP2 = LPTR2 + NOPS*(LCOL2 - 1)
      MTRPL(MTP2) = MTRPL(MTP)
      GO TO 1644
 1623 IF(MTRPL(LPTR1).EQ.44 .AND. MTRPL(LPTR2).EQ.44) GO TO 1635
      IF(MTRPL(LPTR1).EQ.44 .OR. MTRPL(LPTR2).EQ.44) GO TO 1627
C No = triplets
      LEQID = INOUT(INDEX0+NOPS)
      IF(LEQID.GT.INOUT(INDEX1+NOPS)) LEQID = INOUT(INDEX1+NOPS)
      LREQP = LREQP + 1
      MTEMP5 = LREQP - LEQID
      DO 1624 MTEMP6=1,MTEMP5
      MTEMP7 = LREQP - MTEMP6
      MEQU(MTEMP7+1) = MEQU(MTEMP7)
 1624 CONTINUE
      MEQU(MTEMP7) = NEXT
      DO 1626 MTEMP5=1,48
      IF(MOCNT(MTEMP5,1).LT.1) GO TO 1626
      MTEMP6 = MOCNT(MTEMP5,2)
      MTEMP7 = MTEMP6 + MOCNT(MTEMP5,1) - 1
      DO 1625 MTEMP8=MTEMP6, MTEMP7
      IF(INOUT(MTEMP8+NOPS).GE.LEQID)
     A INOUT(MTEMP8+NOPS) = INOUT(MTEMP8+NOPS) + 1
 1625 CONTINUE
 1626 CONTINUE
      MTEMP6 = MTRPL(LPTRA+NOP4)/16
      CALL VARGEN(LGVAR,MTEMP6,MVAR)
      IF(MRUN.NE.1) GO TO 1664
      MTP = LPTR1 + NOPS*(LCOL1 - 1)
      MTP2 = LPTR2 + NOPS*(LCOL2 - 1)
      MTRPL(MTP) = LGVAR
      MTRPL(MTP2) = LGVAR
      MTEMP6 = MTEMP6*21
      CALL TRPGEN(NEXT,44,LGVAR,LPTRA,MTEMP6,MTRPL)
      INOUT(INDEX0) = NEXT - 1
      INOUT(INDEX0+NOPS) = LEQID
      MTEMP5 = MOCNT(44,1) + MOCNT(44,2)
      INOUT(MTEMP5) = - NEXT + 1
      INOUT(MTEMP5+NOPS) = LEQID
      MOCNT(44,1) = MOCNT(44,1) + 1
      INOUT(ISUM+NOP4) = NEXT - 1
      GO TO 1644
C 1 = triplet
 1627 IF(MTRPL(LPTR1).EQ.44) GO TO 1628
      MTEMP5 = LPTR2
      MTEMP6 = LPTR1
      MTEMP7 = INDEX1
      MTEMP8 = INDEX0
      MTEMPE = LCOL1
      GO TO 1629
 1628 MTEMP5 = LPTR1
      MTEMP6 = LPTR2
      MTEMP7 = INDEX0
      MTEMP8 = INDEX1
      MTEMPE = LCOL2
 1629 IF(INOUT(MTEMP7+NOPS).LE.INOUT(MTEMP8+NOPS)) GO TO 1634
      DO 1630 MTEMP9=1, LREQP
      MEQU(MTEMP9+NVARS) = MTEMP9
 1630 CONTINUE
      MTEMPD = INOUT(MTEMP7+NOPS)
      MTEMPC = MEQU(MTEMPD)
      MTEMP9 = MTEMPD - INOUT(MTEMP8+NOPS)
      DO 1631 MTEMPA=1, MTEMP9
      MTEMPB = MTEMPD - MTEMPA
      MEQU(MTEMPB+1) = MEQU(MTEMPB)
      MEQU(MTEMPB+NVARS) = MEQU(MTEMPB+NVARS) + 1
 1631 CONTINUE
      MEQU(MTEMPB) = MTEMPC
      MEQU(MTEMPD+NVARS) = INOUT(MTEMP8+NOPS)
      DO 1633 MTEMP9=1, 48
      IF(MOCNT(MTEMP9,1).LT.1) GO TO 1633
      MTEMPA = MOCNT(MTEMP9,2)
      MTEMPB = MOCNT(MTEMP9,1) + MTEMPA - 1
      DO 1632 MTEMPC=MTEMPA, MTEMPB
      MTEMPD = INOUT(MTEMPC+NOPS)
 1632 INOUT(MTEMPC+NOPS) = MEQU(MTEMPD+NVARS)
 1633 CONTINUE
 1634 MTP = MTEMP6 + NOPS*(MTEMPE - 1)
      MTRPL(MTP) = MTRPL(MTEMP5+NOPS)
      IF(MTEMP7.EQ.INDEX1) GO TO 1645
      GO TO 1644
C Two = triplets
 1635 IF(FLAG2) GO TO 1636
      IF(LPTR1.LT.LPTR2) GO TO 1637
C To re-order two functions so that the right one will be eliminated.
      MTEMP5 = MTRPL(LPTR1+NOPS)
      MTRPL(LPTR1+NOPS) = MTRPL(LPTR2+NOPS)
      MTRPL(LPTR2+NOPS) = MTEMP5
      GO TO 1637
 1636 IF(INOUT(INDEX0+NOPS).LT.INOUT(INDEX1+NOPS)) GO TO 1637
      MTEMP5 = INDEX0
      MTEMP6 = MTRPL(LPTR1+NOPS)
      MTEMP7 = MTRPL(LPTR2+NOPS)
      MTRPL(LPTR1) = 0
      GO TO 1638
 1637 MTEMP5 = INDEX1
      MTEMP6 = MTRPL(LPTR2+NOPS)
      MTEMP7 = MTRPL(LPTR1+NOPS)
      MTRPL(LPTR2) = 0
 1638 LEQID = INOUT(MTEMP5+NOPS)
      LREQP = LREQP - 1
      DO 1639 MTEMP8=LEQID, LREQP
      MEQU(MTEMP8) = MEQU(MTEMP8+1)
 1639 CONTINUE
      IF(MTEMP6.EQ.MTEMP7) GO TO 1641
      MTEMP9 = NEXT - 1
      DO 1640 MTEMP8=1, MTEMP9
      IF(MTRPL(MTEMP8+NOPS).EQ.MTEMP6) MTRPL(MTEMP8+NOPS) = MTEMP7
      IF(MTRPL(MTEMP8+NOP3).EQ.MTEMP6) MTRPL(MTEMP8+NOP3) = MTEMP7
 1640 CONTINUE
      MTEMP6 = MTEMP6 - MAXSIZ
      MVAR(MTEMP6) = 0
      MVAR(MTEMP6+NVAR3) = 0
      MVCNT = MVCNT - 1
 1641 DO 1643 MTEMP6=1, 48
      IF(MOCNT(MTEMP6,1).LT.1) GO TO 1643
      MTEMP7 = MOCNT(MTEMP6,2)
      MTEMP8 = MOCNT(MTEMP6,1) + MTEMP7 - 1
      DO 1642 MTEMP9=MTEMP7, MTEMP8
      IF(LEQID.GT.INOUT(MTEMP9+NOPS)) GO TO 1642
      INOUT(MTEMP9+NOPS) = INOUT(MTEMP9+NOPS) - 1
 1642 CONTINUE
 1643 CONTINUE
      IF(MTEMP5.EQ.INDEX0) GO TO 1645
 1644 INOUT(INDEX1) = 0
      IF(LPTRB.EQ.LPTRA) GO TO 1647
      MTRPL(LPTRB) = 0
      GO TO 1647
 1645 INOUT(INDEX0) = 0
      IF(LPTRB.EQ.LPTRA) GO TO 1646
      MTRPL(LPTRA) = 0
C Store the present attributes for future matching.
 1646 INOUT(ISUM+NOP3) = LPTRB
      IF(LCOL2 .EQ.2) LPTR2 = - LPTR2
      INOUT(ISUM+NOP4) = LPTR2
      MND(ISUM) = INDEX1
 1647 CONTINUE
 1648 CONTINUE
      IF(LCHNGE) GO TO 1615
      MTRPL(NEXT) = 50
      MSTK(1) = MEQL
      MSTK(200) = LREQP
      KEQU = 1
      MEQL = LREQP - 1
C This section puts the arithmetic operations into groups so that all
C  multiplications are grouped together.  In combination with CODGEN,
C  this reduces the size of the object code by reducing the number of
C  DO-loops for multiplication.
C
C DO-1649 and DO-1650 set all flags to zero and flip those flags where
C  the variables are known (independent and dependent ones).
      DO 1649 IND=1, NVARS
      INOUT(IND+NOP4) = 0
      IF(MVAR(IND+NVAR3).LT.2) INOUT(IND+NOP4) = 1
 1649 CONTINUE
      MTEMP1 = NEXT - 1
      DO 1650 IND=1,MTEMP1
      KOP = MTRPL(IND)
      IF(KOP.NE.14) GO TO 1650
      MV = MTRPL(IND+NOPS) - MAXSIZ
      INOUT(MV+NOP4) = 1
 1650 CONTINUE
C DO-1654 searches for add, subtract, and divide operations.
C  It separates them in groups, stores pointers to them in a temporary
C  stack, and flips up the flags to indicate an evaluated variable.
      DO 1654 NOP=1,3
      KOP = KCHG(NOP)
      DO 1653 IND=1, MEQL
      MTRPLP = MEQU(IND)
      IF(MTRPLP.EQ.0) GO TO 1653
      MV = MTRPL(MTRPLP+NOPS)
      IF(MV.LT.MAXSIZ) GO TO 1653
      MPTR = MTRPL(MTRPLP+NOP3)
      IF(MPTR.GT.MAXSIZ) GO TO 1653
      NT0 = MTRPL(MPTR)
      IF(KOP.NE.NT0) GO TO 1653
      NT1 = MTRPL(MPTR+NOPS)
      NT2 =  MTRPL(MPTR+NOP3)
      IF(NT1.LT.MAXSIZ .OR. NT2.LT.MAXSIZ) GO TO 1653
      NT1 = NT1 - MAXSIZ
      IF(NT1.GT.MAXSIZ) GO TO 1651
      IF(INOUT(NT1+NOP4).NE.1) GO TO 1653
 1651 NT2 = NT2 - MAXSIZ
      IF(NT2.GT.MAXSIZ) GO TO 1652
      IF(INOUT(NT2+NOP4).NE.1) GO TO 1653
 1652 INOUT(MV-MAXSIZ+NOP4) = 1
      INOUT(KEQU+NOPS) = MEQU(IND)
      MEQU(IND) = 0
      KEQU = KEQU + 1
 1653 CONTINUE
 1654 CONTINUE
C DO-1660 searches for multiplications and group them all together,
C  while being careful to order them for proper evaluation as indicated
C  by flipped flags.
      DO 1660 NOP=1,5
      MQTOP = 1
      DO 1657 IND=1, MEQL
      MTRPLP = MEQU(IND)
      IF(MTRPLP.EQ.0) GO TO 1657
      MV = MTRPL(MTRPLP+NOPS) - MAXSIZ
      IF(MV.LT.0) GO TO 1657
      MPTR = MTRPL(MTRPLP+NOP3)
      IF(MPTR.GT.MAXSIZ) GO TO 1657
      NT0 = MTRPL(MPTR)
      IF(39.NE.NT0) GO TO 1657
      NT1 = MTRPL(MPTR+NOPS)
      NT2 = MTRPL(MPTR+NOP3)
      IF(NT1.LT.MAXSIZ .OR. NT2.LT.MAXSIZ) GO TO 1657
      NT1 = NT1 - MAXSIZ
      IF(NT1.GT.MAXSIZ) GO TO 1655
      IF(INOUT(NT1+NOP4).NE.1) GO TO 1657
 1655 NT2 = NT2 - MAXSIZ
      IF(NT2.GT.MAXSIZ) GO TO 1656
      IF(INOUT(NT2+NOP4).NE.1) GO TO 1657
 1656 INOUT(MV+NOP4) = 1
      INOUT(KEQU+NOPS) = MEQU(IND)
      MEQU(IND) = 0
      KEQU = KEQU + 1
      MQTOP = IND
 1657 CONTINUE
      DO 1659 IND=1, MEQL
      MTRPLP = MEQU(IND)
      IF(MTRPLP.EQ.0) GO TO 1659
      MPTR = MTRPL(MTRPLP+NOP3)
      IF(MPTR.GT.MAXSIZ) GO TO 1659
      MV = MTRPL(MTRPLP+NOPS)
      NT0 = MTRPL(MPTR)
      IF(NT0.EQ.39 .AND. MV.GT.MAXSIZ .AND. IND.GT.MQTOP) GO TO 1660
      IF(MV.GT.MAXSIZ) GO TO 1658
      NT1 = MTRPL(MV)
      IF(NT1.NE.14) GO TO 1659
      MV = MTRPL(NT1+NOPS)
      IF(MV.LT.MAXSIZ) MV = MV + MAXSIZ
 1658 INOUT(MV-MAXSIZ+NOP4) = 1
      INOUT(KEQU+NOPS) = MEQU(IND)
      MEQU(IND) = 0
      KEQU = KEQU + 1
 1659 CONTINUE
      IF(KEQU.GT.MEQL) GO TO 1662
 1660 CONTINUE
C DO-1661 transfers all the left-over equations onto the temporary
C stack.
C And DO-1663 transfers all the equations back to MEQU.
      DO 1661 IND=1,MEQL
      IF(MEQU(IND).EQ.0) GO TO 1661
      INOUT(KEQU+NOPS) = MEQU(IND)
      KEQU = KEQU + 1
 1661 CONTINUE
 1662 DO 1663 IND=1, MEQL
 1663 MEQU(IND) = INOUT(IND+NOPS)
 1664 RETURN
C---------
C end OPTMIZ
C--------
      END
