C  File rclib1.for                     30-DEC-1993
C
C  Contents:
C      SUBROUTINE RDCV(Y,NAMES,IPASS,RPASS)
C      SUBROUTINE RSET(Y,NAMES,IPASS,RPASS)
C      SUBROUTINE HEAD(KEY,Y,NAMES,IPASS,RPASS)
C      SUBROUTINE TRITA(KTERMS,ATS,H,RCREAL,ORDER,ERR)
C      SUBROUTINE FORTA(KTERMS,ATS,H,RCREAL,RCIMAG,ORDER,ERR)
C      SUBROUTINE SEVTA(KTERMS,ATS,H,RADIUS,RCREAL,RCIMAG,ORDER,ERR)
C      SUBROUTINE TOPLN(KTERMS,ATS,H,NORDER,RADTL,MSTIFF)


      SUBROUTINE RDCV(Y,NAMES,IPASS,RPASS)
C********
C  ATOMFT Subroutine-Library, version 3.11, completed (7/23/93).
C    Copyright (C) 1979-93, Y. F. Chang.
C********
      CHARACTER*6 NAMES,LABEL
      DIMENSION Y(1),NAMES(1),IPASS(20),RPASS(20),ATS(101),WORK(100)
C IPASS(16) = KFINAL
C IPASS(17) = KENOLD
C RPASS(11) = SAVEDP
C RPASS(12) = HNWOLD
C For HEAD
C IPASS(18) = KOUNT
C For HEAD and ZEROT
C RPASS(13) = TESTB
C RPASS(14) = TESTT
C For ZEROT
C RPASS(15) = SIZE
C RPASS(16) = old HNEW
C For RDCV, HEAD, and SEEK
C RPASS(17) = ERRTOP, DMINM
      NUMEQS = IPASS(1)
      LENSER = IPASS(2)
      LENVAR = IPASS(3)
      MPRINT = IPASS(4)
      LIST   = IPASS(5)
      MSTIFF = IPASS(6)
      KTRDCV = IPASS(8)
      INTSTP = IPASS(9)
      H      = RPASS(2)
      HNEW   = RPASS(3)
      ERRLIM = RPASS(4)
      START  = RPASS(8)
      ORDERC = RPASS(10)
      NTOP = LENVAR*NUMEQS + 1
      IF(KTRDCV.EQ.0) THEN
         WRITE(LIST,50)
   50 FORMAT(' KTRDCV must not be zero.')
         STOP
      ENDIF
C-------- Initialize
      ERROR = 1.E29
      RERTOL = 0.01
      HMIN = ERROR
      RADLOW = ERROR
      IF(INTSTP .GT. 1) GO TO 100
      IF(MSTIFF .EQ. 1) THEN
         KTRDCV = NUMEQS
         IPASS(8) = NUMEQS
      ENDIF
      IF(MSTIFF.EQ.1 .AND. ERRLIM.LE.RPASS(17)) WRITE(LIST,51)
   51 FORMAT(' This solution will be limited by the machine roundoff.')
      IF(MSTIFF .GT. 19) THEN
         MSTIFF = 0
         WRITE(LIST,52)
   52 FORMAT(' Stiff problems are solved in double precision only.')
      ENDIF
C Use ORDER to pass the stepsize back from ZEROT.
  100 IF(ORDERC .GT. 49.0) THEN
         HNEW = SIGN((ORDERC-50.0),H)
         RPASS(3) = HNEW
      ENDIF
C Find the maximum series length with non-zero terms.
      LENGTH = LENSER
      DO 166 II=1,NUMEQS
      IL = (II-1)*LENVAR
C------
C Bring back the singularity location along the real axis.
      Y(LENVAR-3+IL) = Y(LENVAR-6+IL)
C The purpose is to detect if the infinite-series method is valid.
C------
      LENY = Y(LENVAR+IL) + 0.3
      LENGTH = MIN0(LENGTH,LENY,100)
      DO 161 K=1,LENGTH
      LENSIN = LENGTH + 1 - K
      IF(Y(LENSIN+IL) .NE. 0.0) GO TO 162
  161 CONTINUE
C Save it in Y(LENVAR).
  162 Y(LENVAR+IL) = LENSIN + 0.3
C Find the first non-zero term.
      DO 163 K=1,LENSIN
      IF(Y(K+IL) .NE. 0.0) GO TO 164
  163 CONTINUE
  164 LOWEND = K
      IF(LENSIN .LT. LENGTH-5) THEN
C Mark those that are too short so to skip processing.
         IF(MSTIFF .EQ. 1) THEN
C This stops the infinite-series method.
            WRITE(LIST,1322)
 1322 FORMAT(' The infinite-series method cannot be applied here.')
            STOP
         ENDIF
         Y(LENVAR-6+IL) = ERROR
      ELSE
C Find the Rc size indicator, and save it in Y(LENVAR-6)
         TEMP1 = AMAX1(ABS(Y(LOWEND+IL)),ABS(Y(LOWEND+1+IL)),
     A     ABS(Y(LOWEND+2+IL)))
         TEMP2 = SQRT(ABS(Y(LENSIN+IL)))*SQRT(ABS(Y(LENSIN-1+IL)))
         IF(Y(LENSIN-1+IL) .EQ. 0.0) TEMP2 = ABS(Y(LENSIN+IL))
         Y(LENVAR-6+IL) = (TEMP1/TEMP2)**(1.0/LENSIN)
      ENDIF
  166 CONTINUE
      IF(MSTIFF .EQ. 1) GO TO 170
      KTOP = MIN0(NUMEQS,KTRDCV)
      DO 168 K=1,KTOP
      RADMIN = ERROR
      DO 167 II=1,NUMEQS
      IL = (II-1)*LENVAR
      TEMP1 = Y(LENVAR-6+IL)
C Pick out the smallest estimated Rc.
      IF(TEMP1.LT.0.0 .OR. TEMP1.GE.RADMIN) GO TO 167
      RADMIN = TEMP1
      KMAX = II
  167 CONTINUE
C Mark the short Rc by its negative.
      IL = (KMAX-1)*LENVAR
      IF(Y(LENVAR-6+IL).GT.0.0) Y(LENVAR-6+IL) = - Y(LENVAR-6+IL)
  168 CONTINUE
C Begin main loop.
  170 DO 590 II=1,NUMEQS
      IL = (II-1)*LENVAR
      LENSIN = Y(LENVAR+IL)
      NLABEL = Y(LENVAR-5+IL)
      LORDER = 10.0*(Y(LENVAR-5+IL) - NLABEL)
      LABEL = NAMES(NLABEL)
      KFLAG = 0
      IF(MSTIFF .EQ. 1) GO TO 172
      IF(Y(LENVAR-6+IL).GT.0.0 .AND. MSTIFF.LT.20) GO TO 580
  172 DO 180 K=1,LENSIN
  180 ATS(K) = Y(K+IL)
      IF(INTSTP .GT. 1) GO TO 210
      Y(LENVAR-1+IL) = 7.0
      Y(LENVAR-2+IL) = 500.0
      Y(LENVAR-4+IL) = -2.0
      IF(IPASS(10) .NE. 0) GO TO 210
C******** Test inputs
      IPASS(10) = 1
C--------  Is the series long enough to compute any estimates?
      IF(LENSIN.GE.15) GO TO 210
      WRITE(LIST,11) LENSIN
   11 FORMAT(' LENSER =',I4,' is too short.')
      STOP
  210 IF(MSTIFF .EQ. 10) GO TO 410
C********  Locate singularities.
C Bring back old RCIMAG; skip 7TA if 3TA (RCI2 = -1.0) is active.
C------
      RCI2 = Y(LENVAR-4+IL)
      IF(RCI2 .EQ. -1.0) GO TO 310
C********  Complex singularities.
      KFLAG = 1
C------
C First, retreave a previous order; use it if good.
C------
  221 TEMP1 = Y(LENVAR-2+IL)
      IF(TEMP1 .LT. 8.E2) GO TO 225
      TEMP1 = TEMP1 - 1.E3
      GO TO 230
C------
C Second, call Seven-term Analysis for the pole position and order.
C------
  225 CALL SEVTA(LENSIN,ATS,H,RC,BX,RCIMAG,ORDER,ERR)
      IF(ERR .GT. 1.0) GO TO 310
      KOK = 0
C------
C Use the previous order if Rc error is high.
C------
      IF(ERR .LT. 3.E-2) GO TO 235
  230 IF(TEMP1 .GT. 9.0) GO TO 310
      ORDER = TEMP1
      KOK = 1
      GO TO 240
C------
C Third, rationalize the order and account for the non-positive
C   integer orders.
C------
  235 KORD = 2.0*SIGN((ABS(ORDER) + 0.25),ORDER)
      ORDER = 0.5*KORD
      IF(MSTIFF .NE. 1) GO TO 240
      IF(KORD.EQ.0.OR.KORD.EQ.-2.OR.KORD.EQ.-4) ORDER = ORDER + 0.05
C------
C Fourth, perform Four-term Analysis for the pole position.
C********  Four-term Analysis
  240 CALL FORTA(LENSIN,ATS,H,BX,RCIMAG,ORDER,ERR)
      IF(ERR .GT. 2.E-3) GO TO 310
      IF(ERR .LT. 1.E-4) Y(LENVAR-2+IL) = ORDER + 1.E3
      IF(KOK .EQ. 1) GO TO 250
      IF(ERR .GE. 1.E-3) THEN
         Y(LENVAR-2+IL) = ORDER
      ELSE
         Y(LENVAR-2+IL) = ORDER + 1.E3
      ENDIF
  250 RC = SQRT(BX*BX + RCIMAG*RCIMAG)
      THETA = ACOS(BX/RC)
      IF(MSTIFF .NE. 1) GO TO 270
C------
C Infinite-series not valid if the pole moves without passing top-line.
C------
      TEMP1 = SQRT(Y(LENVAR-3+IL)*Y(LENVAR-3+IL) + RCI2*RCI2)
      TEMP3 = ABS((TEMP1-RC)/RC)
      IF(RCI2.LT.-1.5 .OR. TEMP3.LT.6.E-2) GO TO 280
      WRITE(LIST,1321)2,TEMP3
C------
C Usual processing here.
C------
  270 IF(ERR .GT. RERTOL) GO TO 310
  280 Y(LENVAR-1+IL) = 7.0
      Y(LENVAR-4+IL) = RCIMAG
      RCREAL = BX + START
      IF(MPRINT.GT.5) WRITE(LIST,12) INTSTP,LABEL,RC,ERR,NAMES(1),
     A START,RCREAL,RCIMAG,ORDER
   12 FORMAT(/' Step',I4,' for',A6,' by (7/4)TA, Rc =',1PE9.2,
     A '  error',E10.2/'   At',A6,9X,'RCREAL',6X,'RCIMAG',8X,'Order'/
     A 1X,1PE12.4,3X,2E12.4,3X,E10.3)
      GO TO 500
C********  Real singularity.
C Examine old RCIMAG; skip 3TA when 7TA (RCI2 = positive) is active.
C------
  310 IF(RCI2 .GT. 0.0) GO TO 410
C********  Three-term Analysis
      CALL TRITA(LENSIN,ATS,H,BX,ORDER,ERR)
      IF(ERR .GT. 1.0) GO TO 410
      TEMP1 = ABS(ORDER) + 0.25
      IF(ERR.GT.RERTOL .OR. TEMP1.GT.2.7) GO TO 410
      IF(MSTIFF .NE. 1) GO TO 340
C------
C Rationalize the order.
C------
      KORD = 2.0*SIGN(TEMP1,ORDER)
      ORDER = 0.5*KORD
      KORD = 1 - KORD
      IF(KORD.GT.6 .OR. KORD.LT.1) KORD = 6
C------
C Infinite-series not valid if the pole moves without passing top-line.
C------
      TEMP3 = AMIN1(BX,BX+START)
      TEMP1 = ABS((Y(LENVAR-3+IL)-BX)/TEMP3)
      IF(RCI2.LT.-1.5 .OR. TEMP1.LT.1.E-2) GO TO 340
      WRITE(LIST,1321)1,TEMP1
 1321 FORMAT(' This solution may have errors. Check it.',I2,1PE12.4)
C********  Two-term Analysis
  340 BX = (LENSIN-2+ORDER)*ATS(LENSIN-1)/(ATS(LENSIN)*(LENSIN-1))
      TEMP1 = (LENSIN-3+ORDER)*ATS(LENSIN-2)/(ATS(LENSIN-1)*(LENSIN-2))
      ERR = ABS((BX - TEMP1)/BX)
      BX = H*BX
      IF(ERR .GT. RERTOL) GO TO 410
      IF(ERR.LT.1.E-6 .OR. Y(LENVAR-1+IL).LT.7.0) GO TO 350
      IF(ERR .LT. RERTOL) Y(LENVAR-1+IL) = 6.0
      GO TO 410
  350 Y(LENVAR-1+IL) = 3.0
      Y(LENVAR-2+IL) = ORDER
      IF(ERR.GT.1.E-3 .AND. (H*BX).GT.0.0) THEN
         IF(KFLAG .EQ. 0) GO TO 221
         GO TO 410
      ENDIF
      Y(LENVAR-4+IL) = -1.0
      RCREAL = BX + START
      RC = ABS(BX)
      IF(MPRINT.GT.5) WRITE(LIST,13) INTSTP,LABEL,RC,ERR,NAMES(1),
     A START,RCREAL,ORDER
   13 FORMAT(/' Step',I4,' for',A6,' by (3/2)TA, Rc =',1PE9.2,
     A ' with error',E10.2/'   At',A6,8X,'Singularity',4X,'Order'/
     A 1X,1PE12.4,2X,E12.4,4X,E10.3)
      GO TO 500
C********  Top line analysis
  410 CALL TOPLN(LENSIN,ATS,H,LORDER,RC,mstiff)
      Y(LENVAR-4+IL) = ATS(101)
C------
C Top-line passes the order unchanged.
C------
      IF(MPRINT.GT.5) WRITE(LIST,14) INTSTP,LABEL,NAMES(1),START,RC
   14 FORMAT(/' Step',I4,' for',A6,' estimated by TOP-LINE analysis'/
     A '   At',A6,8X,'Rc'/1X,1PE12.4,1X,E12.4)
  500 RPASS(10) = ORDER
      IF(MSTIFF.NE.1 .OR. Y(LENVAR-4+IL).LT.-1.0) GO TO 560
      HSQ = H*H
      WORK(LENSIN) = ATS(LENSIN)
      IF(Y(LENVAR-4+IL) .GT. 0.0) GO TO 540
C------
C Process the infinite-series method for real-axis singularity.
C------
      JLEN = LENSIN - 1
      GO TO (522,521,523,521,524,521), KORD
  521 MMTOP = JLEN
      GO TO 525
  522 MMTOP = JLEN - 1
      GO TO 525
  523 MMTOP = JLEN - 2
      GO TO 525
  524 MMTOP = JLEN - 3
C------ Generate the series for a real-axis pole backwards.
C            (m-1) p
C F(m-1)  = --------- F(m)
C           (m+s-2) h
C------
  525 DO 526 MM=1,MMTOP
      M = LENSIN + 1 - MM
      IXZ = M - 1
      TEMP1 = IXZ/(ORDER + IXZ - 1.0)
C-----  TEMP1 = (m-1)/(m+s-2).
  526 WORK(IXZ) = TEMP1*WORK(M)*BX/H
      GO TO (532,531,533,531,534,531), KORD
C------ For all orders, except non-positive integers.
C f(x) = A/ r^s
C------
  531 AK1 = WORK(1)*ABS(BX)**ORDER
      GO TO 555
C------ for order=zero.
C f(x) = - A ln(p - x)
C f'(x) = A/ r  h
C------
  532 AK1 = WORK(2)*BX/H
      WORK(1) = - AK1*ALOG(ABS(BX))
      GO TO 555
C------ for order = -1.
C f(x) = A (p-x) ln(p - x)
C f'(x) = - A ln(p - x) - A    h
C f"(x) = A/ r  hsq/2
C------
  533 AK1 = 2.0*WORK(3)*BX/HSQ
      TEMP1 = ALOG(ABS(BX))
      WORK(1) = AK1*BX*TEMP1
      WORK(2) = - AK1*H*(TEMP1 + 1.0)
      GO TO 555
C------ for order = -2.
C                   2
C f(x) = - A/2 (p-x) ln(p - x)
C f'(x) = A (p-x) ln(p - x) + A (p-x)/2   h
C f"(x) = - A ln(p - x) - A 3/2   hsq/2
C f'"(x) = A/ r   hcube/6
C------
  534 AK1 = 6.0*WORK(4)*BX/(H*HSQ)
      TEMP1 = ALOG(ABS(BX))
      WORK(1) = - 0.5*AK1*BX*BX*TEMP1
      WORK(2) = AK1*H*BX*(TEMP1 + 0.5)
      WORK(3) = - AK1*HSQ*(TEMP1 + 1.5)/2.0
      GO TO 555
C------
C Process the infinite-series method for complex poles.
C------
  540 WORK(LENSIN-1) = ATS(LENSIN-1)
      JLEN = LENSIN - 2
C------ Generate the pole-series backwards.
C             m-2   [       2b      (m-1)      csq]
C F(m-2)  = ------- [F(m-1) ---  - -------F(m) ---]
C           (m+s-3) [        h     (m+s-2)     hsq]
C------
      CSQ = RC*RC/HSQ
      TEMP3 = 2.0*BX/H
      DO 546 MM=1,JLEN
      M = LENSIN + 1 - MM
      IXZ = M - 1
      IXY = M - 2
      TEMP1 = IXY + ORDER
      TEMP2 = IXY/(TEMP1-1.0)
      TEMP1 = IXZ/TEMP1
C-----  temp1 = (m-1)/(m+s-2), temp2 = (m-2)/(m+s-3).
  546 WORK(IXY) = TEMP2*(WORK(IXZ)*TEMP3 - TEMP1*WORK(M)*CSQ)
C------ For all orders, except non-positive integers.
C f(x) = 2 A cos(t s + ph)/ r^s
C f'(x) =  2 A s cos(t (s+1) + ph)/ r^(s+1)  h
C                     RC*WORK(2)
C ak1  = cot t - -------------------------
C                H*order*WORK(1)sin(theta)
C                ak1 - tan angle
C ph = arctan  -------------------
C              (1 + ak1 tan angle)
C------
      ANGLE = THETA*ORDER
      TEMP2 = RC**ORDER
      IF(ABS(WORK(1))*1.E10 .LT. ABS(WORK(2))) THEN
        PH = ATAN(1.0/TAN(ANGLE))
        AK1 = WORK(2)*TEMP2*RC/(2.0*H*ORDER*COS(ANGLE+THETA+PH))
      ELSE
        TEMP1 = RC*WORK(2)/(H*ORDER*WORK(1))
        AK1 = (COS(THETA) - TEMP1)/SIN(THETA)
        AK2 = (AK1 - TAN(ANGLE))/(1.0 + AK1*TAN(ANGLE))
        PH = ATAN(AK2)
        AK1 = WORK(1)*TEMP2/(2.0*COS(ANGLE+PH))
      ENDIF
      Y(LENSER-1+IL) = PH
C------
C Subtract the pole-function from ATS.
C------
  555 DO 556 M=1,JLEN
      WORK(M) = ATS(M) - WORK(M)
C------
C This is the de-poled series; store it.
C------
  556 Y(M+IL) = WORK(M)
C------
C The previous analyses were based on the assumption that the highest
C   order terms have no accuracy at all.
C Or rather, the last term counted is assumed to be equal to the missing
C   part of the series.
C
C For infinite-series calculation, there is nothing missing.
C The terms to infinity are accurate to the indicated error of the
C   pole-function.
C So, I can reduce the accuracy requirement by the pole-function error.
C------
      ERR = AMAX1(ERR,RPASS(17))
      HNEWIN = RC*(ERRLIM/ERR)**(1.0/(LENSIN-LORDER))
      IF(Y(LENVAR-4+IL).LT.0.0 .AND. HNEWIN.GT.RC) HNEWIN = RC
      LENSIN = JLEN
C------
C There are two storage spaces for the passing of constants.
C------
      Y(LENSER+IL) = AK1
      Y(LENVAR+IL) = LENSIN + 0.3
      Y(LENVAR-3+IL) = BX
      HMIN = AMIN1(HNEWIN,HMIN)
      IF(INTSTP .GT. 1) HMIN = AMIN1(HMIN,2.0*ABS(HNEW))
      GO TO 570
C------
C This is the usual constant-order method.
C------
  560 TEMP1 = 1.0
      IF(Y(LENVAR-4+IL) .GT. -2.0)
     A TEMP1 = AMAX1(1.0,LENSIN**(ORDER-2.0+LORDER))
      IF(Y(LENVAR-4+IL) .LT. -10.) THEN
        HNEWIN = RC*(ERRLIM/TEMP1)**(1.0/(8-LORDER))
        Y(LENVAR+IL) = 8.3
        Y(LENVAR-3+IL) = BX
        HMIN = AMIN1(HNEWIN,HMIN)
      ELSE
        HNEWIN = RC*(ERRLIM/TEMP1)**(1.0/(LENSIN-LORDER))
        Y(LENVAR+IL) = LENSIN + 0.3
        Y(LENVAR-3+IL) = BX
        HMIN = AMIN1(HNEWIN,HMIN)
        IF(INTSTP .GT. 1) HMIN = AMIN1(HMIN,2.0*ABS(HNEW))
      ENDIF
  570 IF(RADLOW .LE. RC) GO TO 580
C------
C Select the lowest radius variable.
C------
      RADLOW = RC
      IPASS(15) = II
  580 IF(MPRINT .LT. 9) GO TO 590
      ADJT = RC/H
      IF(MPRINT .EQ. 10) ADJT = 1.0
      HP = H*ADJT
      WRITE(LIST,16) LABEL,START,HP
   16 FORMAT(/' series for',A6,', at',1PE12.4,', Rc or h =',E10.2)
      PROD = 1.0
      DO 582 J=1,LENSIN
      WORK(J) = PROD*ABS(ATS(J))
  582 PROD = PROD*ADJT
      LP = LENSIN/5
      NP = LENSIN - 5*LP
      MP = LP + 1
      M = LENSIN - LP*(4 - NP)
      DO 585 I=1,LP
      IF(M .LT. LENSIN) GO TO 583
      IF(NP .EQ. 4) LP = MP
      WRITE(LIST,17)(K,WORK(K),K=I,LENSIN,LP)
      GO TO 585
  583 IP = I + M
      WRITE(LIST,17)(K,WORK(K),K=I,M,MP),(L,WORK(L),L=IP,LENSIN,LP)
  585 CONTINUE
      IF(NP.GT.0) WRITE(LIST,17)(K,WORK(K),K=MP,M,MP)
   17 FORMAT(1X,I4,1PE10.3,I4,E10.3,I4,E10.3,I4,E10.3,I4,E10.3)
  590 CONTINUE
      HNEXT = HMIN
      IF(INTSTP.EQ.1 .OR. Y(LENVAR-4+IL).LT.-10.) GO TO 591
      RPASS(1) = 2.*RPASS(1)
      IF(RPASS(1) .LT. RADLOW) GO TO 592
  591 RPASS(1) = RADLOW
  592 HNEW = SIGN(HNEXT,H)
      RPASS(3) = HNEW
C********  ROUND HNEW DOWN
      HNEWSP = HNEW
      NSHIFT = 30000.0 + ALOG10(ABS(HNEWSP))
      NSHIFT = 30001 - NSHIFT
      TEMP2 = 10.**NSHIFT
      TEMP1 = (START + HNEW)*TEMP2 + 0.0005
      IF(TEMP1 .GT. 2.E10) GO TO 2401
      IF(TEMP1 .GT. 2.E9) THEN
        TEMP1 = TEMP1*0.1
        TEMP2 = TEMP2*0.1
      ENDIF
      NEXT = TEMP1
      HNEW = NEXT/TEMP2 - START
      RPASS(3) = HNEW
      IF(HNEW .NE. 0.0) GO TO 2404
 2401 WRITE(LIST,2402)
 2402 FORMAT(' **** The solution is hard against a singularity.  STOP!')
      STOP
C******** Handle reaching end of interval
 2404 IPASS(13) = 1
      RPASS(16) = HNEW
      IF(Y(NTOP) .NE. 0.0) THEN
        IF(ABS(HNEW/Y(NTOP)) .GT. 1.0) THEN
          HNEW = Y(NTOP)
          Y(NTOP) = 0.0
          RPASS(3) = HNEW
        ENDIF
      ENDIF
      ENDSTA = RPASS(9) - START
      IF(HNEW*HNEW .LT. ENDSTA*ENDSTA) RETURN
      RPASS(3) = 0.99999*ENDSTA
      IPASS(13) = 4
      RETURN
C********
C end SRDCV
C********
      END
      SUBROUTINE RSET(Y,NAMES,IPASS,RPASS)
C**********
C  ATOMFT Subroutine-Library, version 3.11, completed (7/23/93).
C    Copyright (C) 1979-93, Y. F. Chang.
C**********
      CHARACTER*6 NAMES(1)
      DIMENSION Y(1),IPASS(20),RPASS(20),YNEXT(8),XSER(8)
C      SAVE KFINAL,KENOLD,SAVEDP,HNWOLD
C IPASS(16) = KFINAL
C IPASS(17) = KENOLD
C RPASS(11) = SAVEDP
C RPASS(12) = HNWOLD
      NUMEQS = IPASS(1)
      LENSER = IPASS(2)
      LENVAR = IPASS(3)
      MPRINT = IPASS(4)
      LIST   = IPASS(5)
      MSTIFF = IPASS(6)
      INTSTP = IPASS(9)
      KENDFG = IPASS(13)
      KOVER  = IPASS(15)
      H      = RPASS(2)
      HNEW   = RPASS(3)
      ERRLIM = RPASS(4)
      ADJSTF = RPASS(5)
      XPRINT = RPASS(6)
      DLTXPT = RPASS(7)
      START  = RPASS(8)
      END    = RPASS(9)
      NTOP = LENVAR*NUMEQS + 1
      IF(KOVER .GT. 0) GO TO 5000
      JUMP = - KOVER
      GO TO (101,201,301,5000), JUMP
C This is the first call from ZEROT.
  101 DO 150 II=1,NUMEQS
      IL = (II-1)*LENVAR
      NLABEL = Y(LENVAR-5+IL)
      LORDER = 10.*(Y(LENVAR-5+IL) - NLABEL)
C Cancel the storing done previously.
      IPRINT = MAX0(1,LORDER)
      DO 140 I=1,IPRINT
      LMI = LENSER + I
      DUMMY = Y(LMI+IL)
      Y(LMI+IL) = Y(I+IL)
  140 Y(I+IL) = DUMMY
  150 CONTINUE
      RETURN
C This is the second call from ZEROT.
  201 DO 250 II=1,NUMEQS
      IL = (II-1)*LENVAR
      NLABEL = Y(LENVAR-5+IL)
      LORDER = 10.*(Y(LENVAR-5+IL) - NLABEL)
C Restore the results of analytic continuation.
      IPRINT = MAX0(1,LORDER)
      DO 240 I=1,IPRINT
      LMI = LENSER + I
      DUMMY = Y(I+IL)
      Y(I+IL) = Y(LMI+IL)
  240 Y(LMI+IL) = DUMMY
  250 CONTINUE
      RETURN
C This is the third call from ZEROT that requires printing.
  301 RATIO  = HNEW/H
      IF(KENDFG.NE.3) GO TO 302
      RPASS(11) = XPRINT
      IF(ABS(HNEW).GT.ABS(XPRINT-START)) RPASS(11) = RPASS(11) + DLTXPT
  302 KENDFG = 1
      IPASS(13) = 1
      HNEWIN = HNEW
      XPRINT = START + HNEW
      RPASS(6) = XPRINT
      GO TO 5501
C Start of the normal procedures.
 5000 KOUNT = 0
      IF(INTSTP.EQ.1 .AND. KENDFG.NE.3) RPASS(11) = XPRINT
      IF(KENDFG.NE.3 .AND. DLTXPT.NE.0.0) THEN
         XPRINT = RPASS(11)
         RPASS(6) = RPASS(11)
      ENDIF
      NOPRT = 0
      IF(KENDFG.EQ.3) THEN
         XPRINT = XPRINT + DLTXPT
         RPASS(6) = XPRINT
      ENDIF
      IF(KENDFG.EQ.4) IPASS(16) = 1
C********  Initialize
      XPTSTA = XPRINT - START
C********  Is it necessary to produce user requested print?
      IF((DLTXPT.EQ.0.0) .OR. (MPRINT.LT.1) .OR.
     +  (HNEW*HNEW.LT.XPTSTA*XPTSTA)) GO TO 5200
C--------  Initialize for print
      RATIO = XPTSTA/H
      HNEWIN = XPTSTA
      KENDFG = 3
      IPASS(13) = 3
      GO TO 5501
 5200 IF(IPASS(16).EQ.0) GO TO 5300
      IPASS(16) = 0
      KENDFG = 2
      IPASS(13) = 2
C-------- Initialize for last step to reach end
      RATIO = (END - START)/H
      XPRINT = END
      RPASS(6) = XPRINT
      HNEW = XPRINT - START
      RPASS(3) = HNEW
      HNEWIN = HNEW
      GO TO 5501
C--------  Initialize for normal step
 5300 RATIO  = HNEW/H
      KOUNT = KOUNT + 1
      HNEWIN = HNEW
      KENDFG = 1
      IPASS(13) = 1
      RPASS(11) = XPRINT
      XPRINT = START + HNEW
      RPASS(6) = XPRINT
C This is the re-entry from ZEROT.
 5501 TEMP3 = RPASS(13)
      LENSIN = LENSER
C******** Summation and store
      DO 8200 II=1,NUMEQS
      IL = (II-1)*LENVAR
      NLABEL = Y(LENVAR-5+IL)
      LORDER = 10.0*(Y(LENVAR-5+IL) - NLABEL)
      KTOP = Y(LENVAR+IL)
      DLOOP = 1.0
      IF(Y(LENVAR-4+IL).LT.-1.0 .OR. MSTIFF.NE.1) THEN
         IF(LORDER .GT. 2) GO TO 8031
         IF(LORDER .EQ. 2) GO TO 8021
         YNEXT(1) = Y(1+IL)
         IF(LORDER .EQ. 0) GO TO 8034
         DO 8012 J=2,KTOP
         DLOOP = DLOOP*RATIO
         TEMP1 = DLOOP*Y(J+IL)
 8012    YNEXT(1) = YNEXT(1) + TEMP1
         TEMP1 = 2.0*TEMP1
c Magnitude of remainder.
         IF(YNEXT(1) .NE. 0.0) TEMP3 = AMAX1(TEMP3,ABS(TEMP1/YNEXT(1)))
         GO TO 8034
 8021    YNEXT(1) = Y(1+IL)
         YNEXT(2) = 0.0
         DO 8022 J=2,KTOP
         YNEXT(2) = YNEXT(2) + DLOOP*Y(J+IL)*((J-1)/H)
         DLOOP = DLOOP*RATIO
         TEMP1 = DLOOP*Y(J+IL)
 8022    YNEXT(1) = YNEXT(1) + TEMP1
         TEMP1 = 2.0*TEMP1
c Magnitude of remainder.
         IF(YNEXT(1) .NE. 0.0) TEMP3 = AMAX1(TEMP3,ABS(TEMP1/YNEXT(1)))
         GO TO 8034
 8031    DUMMY = 1.0
         DO 8032 I=1,LORDER
         IBOT = I + 1
         DLOOP = 1.0
         YNEXT(I) = Y(I+IL)*DUMMY
         DO 8030 J=IBOT,KTOP
         DLOOP = DLOOP*RATIO*(J-1)/(J-IBOT+1)
         TEMP1 = DLOOP*Y(J+IL)*DUMMY
 8030    YNEXT(I) = YNEXT(I) + TEMP1
 8032    DUMMY = DUMMY*I/H
         TEMP1 = 2.0*TEMP1
c Magnitude of remainder.
         IF(YNEXT(1) .NE. 0.0) TEMP3 = AMAX1(TEMP3,ABS(TEMP1/YNEXT(1)))
 8034    CONTINUE
C--------
      ELSE
         XSTEP = RATIO*H
         ORDER = Y(LENVAR-2+IL)
         IF(ORDER .GT. 501.0) ORDER = ORDER - 1.E3
         TEMP1 = ABS(ORDER) + 0.1
         KORD = 2.0*SIGN(TEMP1,ORDER)
         KORD = 1 - KORD
         IF(KORD.GT.6 .OR. KORD.LT.1) KORD = 6
         BX = Y(LENVAR-3+IL)
         CONSTA = Y(LENSER+IL)
         TEMP1 = BX - XSTEP
         IF(Y(LENVAR-4+IL) .LT. 0.0) THEN
            GO TO (522,521,523,521,524,521), KORD
C------ For all orders, except non-positive integers.
C            A
C f(x) =  ---------
C         (p - x)^s
C------
  521       XSER(1) = CONSTA/(ABS(TEMP1)**ORDER)
            KBOT = 2
            GO TO 525
C------For order=zero.
C                                   A
C f(x) = - A ln|p - x|, f'(x) =  -------
C                                (p - x)
C------
  522       XSER(1) = - CONSTA*ALOG(ABS(TEMP1))
            XSER(2) = CONSTA/TEMP1
            KBOT = 3
            GO TO 525
C------ for order = -1.
C f(x) = A (p-x) ln(p - x),  f'(x) = - A ln(p - x) - A
C
C f"(x) = A/(p - x)
C------
  523       TEMP2 = ALOG(ABS(TEMP1))
            XSER(1) = CONSTA*TEMP1*TEMP2
            XSER(2) = - CONSTA*(TEMP2 + 1.0)
            XSER(3) = CONSTA/TEMP1
            KBOT = 4
            GO TO 525
C------ for order = -2.
C                   2
C f(x) = - A/2 (p-x) ln(p - x), f'(x) = A (p-x) ln(p - x) + A (p-x)/2
C
C f"(x) = - A ln(p - x) - A 3/2,  f'"(x) = A/(p - x)
C------
  524       TEMP2 = ALOG(ABS(TEMP1))
            XSER(1) = - 0.5*CONSTA*TEMP1*TEMP1*TEMP2
            XSER(2) = CONSTA*TEMP1*(TEMP2 + 0.5)
            XSER(3) = - CONSTA*(TEMP2 + 1.5)
            XSER(4) = CONSTA/TEMP1
            KBOT = 5
  525       IF((KBOT-1) .LT. LORDER) THEN
C------ Generate additional terms if needed.
C        (k+s-2)
C f(k) = ------- f(k-1)
C           p
C------
               DO 526 K=KBOT,LORDER
               TEMP2 = K + ORDER - 2.0
  526          XSER(K) = XSER(K-1)*TEMP2/TEMP1
            ENDIF
         ELSE
C------
C This is for complex poles.
C------
            CSQ = TEMP1*TEMP1 + Y(LENVAR-4+IL)*Y(LENVAR-4+IL)
            RC = SQRT(CSQ)
            THETA = ACOS(TEMP1/RC)
            PH = Y(LENSER-1+IL)
C------ For all orders, except non-positive integers.
C f(x) =  2 A cos(t s + ph)/ r^s
C
C f'(x) = 2 A s cos(t (s+1) + ph)/ r^(s+1)
C------
            ANGLE = THETA*ORDER + PH
            TEMP2 = RC**ORDER
            TEMP3 = 2.0*CONSTA/TEMP2
            XSER(1) = TEMP3*COS(ANGLE)
            XSER(2) = TEMP3*ORDER*COS(ANGLE+THETA)/RC
C------ Generate additional terms if needed.
C        (k+s-2)
C f(k) = ------- [f(k-1) 2b  -  f(k-2) (k+s-3)]
C          csq
C------
            IF(LORDER .GT. 2) THEN
               DO 546 K=3,LORDER
               TEMP2 = K + ORDER - 2.0
               TEMP3 = TEMP2 - 1.0
  546          XSER(K) = TEMP2/CSQ*(2.0*BX*XSER(K-1) - TEMP3*XSER(K-2))
            ENDIF
         ENDIF
C------
C Bring back and sum the de-poled series.
C------
         IF(LORDER .GT. 2) GO TO 8131
         IF(LORDER .EQ. 2) GO TO 8121
 8111    YNEXT(1) = Y(1+IL) + XSER(1)
         DO 8112 J=2,KTOP
         DLOOP = DLOOP*RATIO
 8112    YNEXT(1) = YNEXT(1) + DLOOP*Y(J+IL)
         GO TO 8134
 8121    YNEXT(1) = Y(1+IL) + XSER(1)
         YNEXT(2) = XSER(2)
         DO 8122 J=2,KTOP
         YNEXT(2) = YNEXT(2) + DLOOP*Y(J+IL)*((J-1)/H)
         DLOOP = DLOOP*RATIO
 8122    YNEXT(1) = YNEXT(1) + DLOOP*Y(J+IL)
         GO TO 8134
 8131    DUMMY = 1.0
         DO 8132 I=1,LORDER
         IBOT = I + 1
         DLOOP = 1.0
         YNEXT(I) = Y(I+IL)*DUMMY + XSER(I)
         DO 8130 J=IBOT,KTOP
         DLOOP = DLOOP*RATIO*(J-1)/(J-IBOT+1)
 8130    YNEXT(I) = YNEXT(I) + DLOOP*Y(J+IL)*DUMMY
 8132    DUMMY = DUMMY*I/H
 8134    CONTINUE
      ENDIF
C--------
      IPRINT = MAX0(1,LORDER)
      IF(KENDFG.EQ.1 .AND. MPRINT.LT.4) GO TO 8050
C------
C Store the YNEXT into the top part of dependent variables.
C------
      DO 8047 I=1,IPRINT
      LMI = LENSER + I
 8047 Y(LMI+IL) = YNEXT(I)
      IF(KENDFG .EQ. 3) GO TO 8200
C******** Place the analytic continuation back into Y(1).
 8050 DO 8080 I=1,IPRINT
      LMI = LENSER + I
      Y(LMI+IL) = Y(I+IL)
 8080 Y(I+IL) = YNEXT(I)
C------
C Update the singularity location along the real axis.
C The purpose is to detect if the infinite-series method is valid.
C------
      Y(LENVAR-6+IL) = Y(LENVAR-3+IL) - HNEW
      LENSIN = MIN0(KTOP,LENSIN)
 8200 CONTINUE
C Infinite-series cannot correct for a large remainder.
      IF(MSTIFF.EQ.1 .OR. MSTIFF.GT.19 .OR. KOVER.LT.0) GO TO 8400
      IF(TEMP3.LT.ERRLIM .OR. KENDFG.EQ.2) GO TO 8400
      IF(MPRINT .GT. 5) WRITE(LIST,8202)TEMP3,ERRLIM
 8202 FORMAT(' Adjusting the stepsize in RSET.'/
     A ' The remainder vs error limit',1P2E12.4)
      IF(KOUNT .GT. 1) GO TO 8400
      HNEW = HNEWIN/(2.0*TEMP3/ERRLIM)**(1.0/(LENSIN-1))
      RPASS(3) = HNEW
      IF(IPASS(17).EQ.3 .AND. ABS(HNEW).LT.ABS(RPASS(12))) THEN
         HNEW = RPASS(12)
         RPASS(3) = HNEW
         NOPRT = 1
      ENDIF
      IF(KENDFG .EQ. 3) GO TO 5300
      XPRINT = RPASS(11)
      RPASS(6) = XPRINT
      DO 8300 II=1,NUMEQS
      IL = (II-1)*LENVAR
      NLABEL = Y(LENVAR-5+IL)
      LORDER = 10.0*(Y(LENVAR-5+IL) - NLABEL)
      IPRINT = MAX0(1,LORDER)
      DO 8201 I=1,IPRINT
      LMI = LENSER + I
 8201 Y(I+IL) = Y(LMI+IL)
 8300 CONTINUE
      GO TO 5300
 8400 RPASS(12) = HNEWIN
      IPASS(17) = KENDFG
      IF(NOPRT .EQ. 1) RETURN
      IF(KENDFG.EQ.1 .AND. MPRINT.LT.4) RETURN
      IF((KENDFG.EQ.3.AND.MPRINT.EQ.1) .OR. MPRINT.EQ.0) RETURN
      DO 8500 II=1,NUMEQS
      IL = (II-1)*LENVAR
      NLABEL = Y(LENVAR-5+IL)
      LORDER = 10.0*(Y(LENVAR-5+IL) - NLABEL)
C******** Print at user's request
      IF(II .EQ. 1) WRITE(LIST,1010) INTSTP,NAMES(1),XPRINT
 1010 FORMAT(/5X,'Step number',I6,' at',A6,' = ',1PE12.5)
      IPRINT = MAX0(1,LORDER)
      IF(KENDFG .EQ. 3) THEN
         WRITE(LIST,4) NAMES(NLABEL),(Y(K+IL),K=LENSER+1,LENSER+IPRINT)
      ELSE
         WRITE(LIST,4) NAMES(NLABEL),(Y(K+IL),K=1,IPRINT)
      ENDIF
    4 FORMAT(1X,A6,(1P4E13.5))
 8500 CONTINUE
      RETURN
C********
C end RSET
C********
      END
      SUBROUTINE HEAD(KEY,Y,NAMES,IPASS,RPASS)
C********
C  ATOMFT Subroutine-Library, version 3.11, completed (5/31/93).
C    Copyright (C) 1979-93, Y. F. Chang.
C********
      DIMENSION IPASS(20),RPASS(20),Y(1)
      CHARACTER*6 NAMES(1)
      SAVE NOPRT
      DATA NOPRT/1/
C IPASS(18) = KOUNT
C RPASS(13) = TESTB
C RPASS(14) = TESTT
      NUMEQS = IPASS(1)
      LENSER = IPASS(2)
      LENVAR = IPASS(3)
      MPRINT = IPASS(4)
      LIST   = IPASS(5)
      MSTIFF = IPASS(6)
      INTSTP = IPASS(9)
      KTSTIF = IPASS(10)
      GO TO (1000,2000,3000,4000,5000), KEY
 1000 IF(NOPRT .EQ. 0) GO TO 1010
      NOPRT = 0
      IF(MSTIFF.EQ.1) WRITE(LIST,17)
   17 FORMAT(' Results calculated by an infinite-series method.'/
     A       ' ------------------------------------------------')
C for independent variable name.
 1010 IF(MPRINT.EQ.0) RETURN
      WRITE(LIST,11) NAMES(1),RPASS(8)
   11 FORMAT(/5X,'Step number     0 at',A6,' = ',1PE12.5)
      DO 1100 II=1,NUMEQS
      IL = (II-1)*LENVAR
      NLABEL = Y(LENVAR-5+IL)
      LORDER = 10.0*(Y(LENVAR-5+IL) - NLABEL)
      IPRINT = MAX0(1,LORDER)
      WRITE(LIST,12) NAMES(NLABEL),(Y(I+IL),I=1,IPRINT)
   12 FORMAT(1X,A6,(1P4E13.5))
 1100 CONTINUE
      RETURN
 2000 IL = (IPASS(15)-1)*LENVAR
      LENSIN = Y(LENVAR+IL) + 0.1
      TMP = ABS(Y(LENSIN+IL))
      IF(KTSTIF.GT.1 .AND. TMP.LT.1.0) GO TO 2500
      IF(TMP.EQ.0.0) GO TO 2500
      IF(TMP.LT.RPASS(14) .AND. TMP.GT.RPASS(13)) GO TO 2500
      IPASS(18) = IPASS(18) + 1
      IF(IPASS(18) .LT. 5) GO TO 2200
      WRITE(LIST,16) NAMES(1),RPASS(8)
   16 FORMAT(1X,A6,1PE8.1,', the trial H adjustment needs some help.')
      STOP
 2200 H = RPASS(2)
      TOP = 0.6
      IF(TMP .GT. 1.0) TOP = 1.2
      HNEW = RPASS(2)*TMP**(TOP/(1-LENSIN))
      RPASS(2) = HNEW
      IF(MPRINT.GT.3) WRITE(LIST,13) NAMES(1),RPASS(8),HNEW,LENSIN
   13 FORMAT(1X,A6,1PE8.1,', H adjusted to',1PE12.5,' at term #',I4)
      DO 2300 II=1,NUMEQS
      IL = (II-1)*LENVAR
      NLABEL = Y(LENVAR-5+IL)
      LORDER = 10.*(Y(LENVAR-5+IL) - NLABEL)
      IF(LORDER .LT. 2) GO TO 2300
      TMP = H
      DLOOP = 1.0
      DO 2250 K=2,LORDER
      Y(K+IL) = Y(K+IL)*DLOOP/TMP
      DLOOP = DLOOP*K
 2250 TMP = TMP*H
 2300 CONTINUE
      IPASS(7) = 0
      RETURN
 2500 IPASS(7) = 1
      IPASS(18) = 0
      RETURN
 3000 WRITE(LIST,14) INTSTP
   14 FORMAT(/5X,'The solution stopped normally after',I4,
     A ' steps as set by NSTEPS.')
      RETURN
 4000 WRITE(LIST,15) RPASS(3),RPASS(9)
   15 FORMAT(/' The ODE-generating portion of the subroutine for your'/
     A ' User-Defined function has failed to converge.  Your initial'/
     B ' point',1PE9.2,' is too far away from the desired'/
     C ' point',E12.4,'  This solution is aborted.')
      STOP
 5000 IF(NOPRT .EQ. 0) GO TO 5010
      WRITE(LIST,10)IPASS(13),IPASS(7)
   10 FORMAT(' ATOMFT  ver. ',I1,'.',I1,'1, copyright (C) 1979-93, Y. F.
     A Chang; Solution results.'/' ******')
 5010 RPASS(17) = 10.0**(-IPASS(12))
      IPASS(18) = 0
      KXPMAX = IPASS(11) - (IPASS(11)/10000)*10000
      KEXP = KXPMAX*7/10
      RPASS(13) = 0.1**(KEXP)
      RPASS(14) = 10.0**(KEXP)
      RPASS(15) = 1.0
      DO 5100 II=1,NUMEQS
      IL = (II-1)*LENVAR
      DO 5100 K=1,LENSER
      Y(K+IL) = 0.0
 5100 CONTINUE
      NTOP = LENVAR*NUMEQS + 1
      Y(NTOP) = 0.0
      IPASS(16) = 0
      IPASS(17) = 0
      RPASS(12) = 0.0
      RETURN
C********
C end HEAD
C********
      END
      SUBROUTINE TRITA(KTERMS,ATS,H,RCREAL,ORDER,ERR)
C********
C  ATOMFT Subroutine-Library, version 3.11, completed (1/31/93).
C    Copyright (C) 1979-93, Y. F. Chang.
C
C Given a series called ATS, of length KTERMS, this subroutine
C   will attempt to find a singularity on the real axis.
C This code is due to G. F. Corliss.
C
C  KTERMS  input length of the series.
C  ATS     input Taylor series.
C  H       input stepsize.
C  RCREAL  output singularity position along the real axis, from
C            the point of the Taylor expansiion.
C  ORDER   output order of the singularity.
C  ERR     output estimated error in this calculation.
C          1. ERR=2 indicates that this calculation cannot
C              find a pair of conjugate singularities.
C          2. Results with ERR > 0.01 should not be used in
C              precise computations.
C
C See
C 1. Y. F. Chang, "Automatic solution of differential equations,"
C    Lecture Notes in Math., vol. 430, Springer-Verlag, New York,
C    1974, pp. 61-94.
C 2. Y. F. Chang & G. F. Corliss, "Three and Five Term Convergence
C    Tests," Proc. 6th Manitoba Conf. Num. Math., 1976, pp. 135-153.
C 3. Y. F. Chang & G. F. Corliss, "Ratio-like and Recurrence Relation
C    Tests for Convergence of Series," J. Inst. Math. Appl., v. 25,
C    1980, pp. 349-359.
C********
      DIMENSION ATS(1)
C------
C Abortive exit, if any of the top terms of the series is zero.
C------
      IF(ATS(KTERMS-1).EQ.0.0 .OR. ATS(KTERMS-2).EQ.0.0 .OR.
     A ATS(KTERMS-3).EQ.0.0 .OR. ATS(KTERMS-4).EQ.0.0) GO TO 9999
C********  Three-term analysis
      TEMP2 = (KTERMS-3)*ATS(KTERMS-2)/ATS(KTERMS-3)
      TEMP1 = (KTERMS-2)*ATS(KTERMS-1)/ATS(KTERMS-2)
      HRC1 = TEMP1 - TEMP2
      IF(HRC1 .EQ. 0.0) GO TO 9999
      TEMP2 = (KTERMS-1)*ATS(KTERMS)/ATS(KTERMS-1)
      HOVERC = TEMP2 - TEMP1
      IF(HOVERC .EQ. 0.0) GO TO 9999
      ERR = ABS((HOVERC - HRC1)/HOVERC)
C------
C Compute ORDER and singularity position.
C------
      ORDER = TEMP2/HOVERC - (KTERMS-2)
      RCREAL = H/HOVERC
C------
C Normal exit.
C------
      RETURN
C------
C Abortive exit.
C------
 9999 ERR = 2.0
      RCREAL = 0.0
      ORDER = 0.0
      RETURN
C********
C end TRITA
C********
      END
      SUBROUTINE FORTA(KTERMS,ATS,H,RCREAL,RCIMAG,ORDER,ERR)
C********
C  ATOMFT Subroutine-Library, version 3.11, completed (1/31/93).
C    Copyright (C) 1979-93, Y. F. Chang.
C
C Given a series called ATS, of length KTERMS, this subroutine
C   will attempt to find a singularity on the real axis.
C
C  KTERMS  input length of the series.
C  ATS     input Taylor series.
C  H       input stepsize.
C  RCREAL  output singularity position along the real axis, from
C            the point of the Taylor expansiion.
C  RCIMAG  output singularity position in the imaginary direction.
C  ORDER   input order of the singularity.
C  ERR     output estimated error in this calculation.
C          1. ERR=2 indicates that this calculation cannot
C              find a pair of conjugate singularities.
C          2. Results with ERR > 0.4 should not be used in
C              precise computations.
C
C See
C 1. Y. F. Chang, "Automatic solution of differential equations,"
C    Lecture Notes in Math., vol. 430, Springer-Verlag, New York,
C    1974, pp. 61-94.
C 2. Y. F. Chang & G. F. Corliss, "Ratio-like and Recurrence Relation
C    Tests for Convergence of Series," J. Inst. Math. Appl., v. 25,
C    1980, pp. 349-359.
C********
      DIMENSION ATS(1)
C********  Four-term analysis.
      FM = ATS(KTERMS)
      FM1 = ATS(KTERMS-1)
      FM2 = ATS(KTERMS-2)
      FM3 = ATS(KTERMS-3)
      TM1 = (KTERMS-1)
      TM2 = (KTERMS-2)
      TM3 = (KTERMS-3)
      TMS2 = (KTERMS+ORDER-2)
      TMS3 = (KTERMS+ORDER-3)
      TMS4 = (KTERMS+ORDER-4)
      IF(ABS(FM) .LT. ABS(FM1)) GO TO 50
      TMTOP = TM2*TM3*(TM1*TMS3*FM2 - TM2*TMS2*FM1/FM*FM1)
      TMBOT = TMS2*TMS3*(TM2*TMS4*FM1/FM*FM3 - TM3*TMS3*FM2/FM*FM2)
      GO TO 60
   50 TMTOP = TM2*TM3*(TM1*TMS3*FM/FM1*FM2 - TM2*TMS2*FM1)
      TMBOT = TMS2*TMS3*(TM2*TMS4*FM3 - TM3*TMS3*FM2/FM1*FM2)
   60 TEMP1 = TMTOP/TMBOT
      IF(TEMP1 .LT. 0.0) GO TO 9999
      HOVERC = SQRT(TEMP1)
C This is the cosine of the angle.
      IF(FM1 .EQ. 0.0) GO TO 103
      IF(ABS(FM1) .LT. ABS(FM2)) GO TO 102
      COSIN = (TM1*FM/(HOVERC*TMS2) + HOVERC*TMS3*FM2/TM2)/(2.0*FM1)
      GO TO 104
C For better accuracy.
  102 COSIN = (TM2*FM1/(HOVERC*TMS3) + HOVERC*TMS4*FM3/TM3)/(2.0*FM2)
      GO TO 104
  103 COSIN = HOVERC*TMS4*FM3/TM3/(2.0*FM2)
  104 IF(ABS(COSIN) .GT. 1.01) GO TO 9999
      RC = H/HOVERC
      RCREAL = RC*COSIN
      RC = ABS(RC)
      RCIMAG = RC*SQRT(ABS(1.0 - COSIN*COSIN))
      LTERMS = KTERMS - 1
C To avoid a 90-degree pole.
      IF(FM2 .EQ. 0.0) LTERMS = LTERMS - 1
      FM = ATS(LTERMS)
      FM1 = ATS(LTERMS-1)
      FM2 = ATS(LTERMS-2)
      FM3 = ATS(LTERMS-3)
      TM1 = (LTERMS-1)
      TM2 = (LTERMS-2)
      TM3 = (LTERMS-3)
      TMS2 = (LTERMS+ORDER-2)
      TMS3 = (LTERMS+ORDER-3)
      TMS4 = (LTERMS+ORDER-4)
      IF(ABS(FM) .LT. ABS(FM1)) GO TO 150
      TMTOP = TM2*TM3*(TM1*TMS3*FM2 - TM2*TMS2*FM1/FM*FM1)
      TMBOT = TMS2*TMS3*(TM2*TMS4*FM1/FM*FM3 - TM3*TMS3*FM2/FM*FM2)
      GO TO 160
  150 TMTOP = TM2*TM3*(TM1*TMS3*FM/FM1*FM2 - TM2*TMS2*FM1)
      TMBOT = TMS2*TMS3*(TM2*TMS4*FM3 - TM3*TMS3*FM2/FM1*FM2)
  160 TEMP1 = TMTOP/TMBOT
      IF(TEMP1 .LT. 0.0) GO TO 9999
      TEMP2 = SQRT(TEMP1)
      ERR = ABS(HOVERC - TEMP2)/HOVERC
C------
C Normal exit.
C------
      RETURN
C------
C Abortive exit.
C------
 9999 ERR = 2.0
      RETURN
C********
C end FORTA
C********
      END
      SUBROUTINE SEVTA(KTERMS,ATS,H,RADIUS,RCREAL,RCIMAG,ORDER,ERR)
C********
C  ATOMFT Subroutine-Library, version 3.11, completed (1/31/93).
C    Copyright (C) 1979-93, Y. F. Chang.
C
C Given a series called ATS, of length KTERMS, this subroutine
C   will attempt to find a pair of conjugate singularities in the
C   complex plane.
C This code is partially due to G. F. Corliss.
C
C  KTERMS  input length of the series.
C  ATS     input Taylor series.
C  H       input stepsize.
C  RADIUS  output radius of convergence.
C  RCREAL  output singularity position along the real axis, from
C            the point of the Taylor expansiion.
C            In my other calculations, I refer to this as BX.
C  RCIMAG  output singularity position in the imaginary direction.
C  ORDER   output order of the singularity.
C  ERR     output error flag.
C          1. normal ERR; the solution is accepted.
C          2. ERR = 2, this calculation cannot find the singularities.
C
C See
C 1. Y. F. Chang, "The Automatic Taylor Series Method of Analysis."
C********
      DIMENSION ATS(1),COEF(6,6),X(5),IPVT(5)
      JUMP = 1
      LTERMS = KTERMS
      IF(ATS(LTERMS-1).NE.0.0) GO TO 2300
C********  Seven-term Analysis
 1300 DO 1330 MM=1,3
         M = LTERMS + 2 - MM*2
         M1 = M - 1
         IF (ATS(M2) .EQ. 0.0) GO TO 9999
         M2 = M - 2
         M3 = M - 3
C------
C Define the matrix coefficients.  Use TEMP1 to scale the system.
C------
         X(1) = - (M2*M3)*ATS(M2)
         X(2) = - (M2+M3)*ATS(M2)
         X(3) = - ATS(M2)
         TEMP1 = 3.0/(ABS(X(1)) + ABS(X(2)) + ABS(X(3)))
         COEF(MM,1) = X(1)*TEMP1
         COEF(MM,2) = X(2)*TEMP1
         COEF(MM,3) = X(3)*TEMP1
 1330 COEF(MM,4) = (M1*M2)*ATS(M)*TEMP1
C------
C Solve by Gaussian elimination.
C------
      DO 1340 M=1,3
 1340 IPVT(M) = M
      DO 1350 M=1,2
C------
C Find the pivot element.
C------
         TEMP2 = 0.0
         DO 1341 MM=M,3
            M1 = IPVT(MM)
            TEMP1 = ABS(COEF(M1,M))
            IF(TEMP1 .GT. TEMP2) THEN
               IMAX = MM
               TEMP2 = TEMP1
            ENDIF
 1341    CONTINUE
C------
C Exchange rows IMAX and M.
C------
         M1 = IPVT(IMAX)
         IPVT(IMAX) = IPVT(M)
         IPVT(M) = M1
C------
C Eliminate the rest of column M.
C------
         M1 = M + 1
         DO 1348 MM=M1,3
            IMM = IPVT(MM)
            IM  = IPVT(M)
C------
C Abortive exit if the denominator is zero.
C------
            IF(COEF(IM,M) .EQ. 0.0) GO TO 9999
            TEMP1 = COEF(IMM,M)/COEF(IM,M)
            COEF(IMM,M) = TEMP1
            DO 1346 I=M1,4
 1346       COEF(IMM,I) = COEF(IMM,I) - TEMP1*COEF(IM,I)
 1348    CONTINUE
 1350 CONTINUE
C------
C Back substitution.
C------
      IM =IPVT(3)
C------
C Abortive exit if the denominator is zero.
C------
      IF(COEF(IM,3) .EQ. 0.0) GO TO 9999
      X(3) = COEF(IM,4)/COEF(IM,3)
      IM = IPVT(2)
      TEMP1 = COEF(IM,4) - COEF(IM,3)*X(3)
      IF(COEF(IM,2) .EQ. 0.0) GO TO 9999
      X(2) = TEMP1/COEF(IM,2)
      IM = IPVT(1)
      TEMP1 = COEF(IM,4) - COEF(IM,2)*X(2) - COEF(IM,3)*X(3)
      IF(COEF(IM,1) .EQ. 0.0) GO TO 9999
      X(1) = TEMP1/COEF(IM,1)
C------
C Abortive exit if the square is negative.
C------
      IF(X(1) .LE. 0.0) GO TO 9999
      IF(JUMP .EQ. 2) GO TO 1400
      HOVERC = SQRT(X(1))
      ORDER = X(2)/X(1)
      IF(ABS(ORDER) .GT. 10.0) GO TO 9999
      RADIUS = ABS(H/HOVERC)
      RCIMAG = RADIUS
      JUMP = 2
      LTERMS = KTERMS - 2
      GO TO 1300
 1400 TEMP1 =  SQRT(X(1))
      ERR = ABS((HOVERC - TEMP1)/HOVERC)
      RETURN
C********  Seven-term Analysis
 2300 DO 2330 MM=1,5
         M = LTERMS + 1 - MM
         M1 = M - 1
         M2 = M - 2
         IF (ATS(M2) .EQ. 0.0) GO TO 9999
         M3 = M - 3
C------
C Define the matrix coefficients.  Use TEMP1 to scale the system.
C------
         X(1) = - (M2+M3)*ATS(M2)
         X(2) = - ATS(M2)
         X(3) = - (M2*M3)*ATS(M2)
         X(4) = (2*M2*M2)*ATS(M1)
         X(5) = (2*M2)*ATS(M1)
         TEMP1 = 5.0/(ABS(X(1)) + ABS(X(2)) + ABS(X(3)) + ABS(X(4)) +
     A     ABS(X(5)))
         COEF(MM,1) = X(1)*TEMP1
         COEF(MM,2) = X(2)*TEMP1
         COEF(MM,3) = X(3)*TEMP1
         COEF(MM,4) = X(4)*TEMP1
         COEF(MM,5) = X(5)*TEMP1
 2330 COEF(MM,6) = (M1*M2)*ATS(M)*TEMP1
C------
C Solve by Gaussian elimination.
C------
      DO 2340 M=1,5
 2340 IPVT(M) = M
      DO 2350 M=1,4
C------
C Find the pivot element.
C------
         TEMP2 = 0.0
         DO 2341 MM=M,5
            M1 = IPVT(MM)
            TEMP1 = ABS(COEF(M1,M))
            IF(TEMP1 .GT. TEMP2) THEN
               IMAX = MM
               TEMP2 = TEMP1
            ENDIF
 2341    CONTINUE
C------
C Exchange rows IMAX and M.
C------
         M1 = IPVT(IMAX)
         IPVT(IMAX) = IPVT(M)
         IPVT(M) = M1
C------
C Eliminate the rest of column M.
C------
         M1 = M + 1
         DO 2348 MM=M1,5
            IMM = IPVT(MM)
            IM  = IPVT(M)
C------
C Abortive exit if the denominator is zero.
C------
            IF(COEF(IM,M) .EQ. 0.0) GO TO 9999
            TEMP1 = COEF(IMM,M)/COEF(IM,M)
            COEF(IMM,M) = TEMP1
            DO 2346 I=M1,6
 2346       COEF(IMM,I) = COEF(IMM,I) - TEMP1*COEF(IM,I)
 2348    CONTINUE
 2350 CONTINUE
C------
C Back substitution.
C------
      IM =IPVT(5)
C------
C Abortive exit if the denominator is zero.
C------
      IF(COEF(IM,5) .EQ. 0.0) GO TO 9999
      X(5) = COEF(IM,6)/COEF(IM,5)
      IM = IPVT(4)
      TEMP1 = COEF(IM,6) - COEF(IM,5)*X(5)
      IF(COEF(IM,4) .EQ. 0.0) GO TO 9999
      X(4) = TEMP1/COEF(IM,4)
      IM = IPVT(3)
      TEMP1 = COEF(IM,6) - COEF(IM,4)*X(4) - COEF(IM,5)*X(5)
      IF(COEF(IM,3) .EQ. 0.0) GO TO 9999
      X(3) = TEMP1/COEF(IM,3)
C------
C Abortive exit if the square is negative.
C------
      IF(X(3) .LE. 0.0) GO TO 9999
      IF(JUMP .GT. 1) GO TO 2400
      HOVERC = SQRT(X(3))
      COSINE = X(4)/HOVERC
      IF(ABS(COSINE) .LT. 1.E-2) THEN
C------
C When the cosine is less than 1.E-2, perform the 3x3.
C Then, the series will have alternating large terms; so,
C   pick out the highest-order large term.
C------
         TEMP1 = ABS(ATS(LTERMS-1)*HOVERC/ATS(LTERMS))
         IF(TEMP1 .GT. 1.0) LTERMS = LTERMS - 1
         GO TO 1300
      ENDIF
C------
C Abortive exit if the cosine is too big.
C------
      IF(COSINE*COSINE .GT. 1.0) GO TO 9999
      ORDER = X(5)/X(4)
      RADIUS = H/HOVERC
      IF(ABS(ORDER) .GT. 10.0) GO TO 9999
      BX = RADIUS*COSINE
      RADIUS = ABS(RADIUS)
      RCIMAG = RADIUS*SQRT(ABS(1.0 - COSINE*COSINE))
      JUMP = 2
      LTERMS = KTERMS - 1
      GO TO 2300
 2400 TEMP1 =  SQRT(X(3))
      ERR = ABS((HOVERC - TEMP1)/HOVERC)
C------
C Normal exit.
C------
      RETURN
C------
C Abortive exit.
C------
 9999 ERR = 2.D0
      RADIUS = 0.0
      BX = 0.0
      RCIMAG = 0.0
      ORDER = 0.0
      RETURN
C********
C end SEVTA
C********
      END
      SUBROUTINE TOPLN(KTERMS,ATS,H,NORDER,RADTL,MSTIFF)
C********
C  ATOMFT Subroutine-Library, version 3.11, completed (5/31/93).
C    Copyright (C) 1979-93, Y. F. Chang.
C
C This is an improved version with no GOTO's.
C
C Given a series called ATS, of length KTERMS, this subroutine
C   will find the slope of the top envelope to Log{ |ATS(K)| }
C   between the 5-th term and KTERMS.
C The inverse of this slope is a good estimate for the Radius
C   of Convergence.
C
C  KTERMS  input length of the series.
C  ATS     input Taylor series.
C  H       input stepsize.
C  NORDER  input ODE order.
C  RADTL   output Radius of Convergence, Rc.
C
C See Y. F. Chang, "Automatic solution of differential equations",
C    Lecture Notes in Math., vol. 430, Springer-Verlag, New York,
C    1974, pp. 61-94.
C********
      DIMENSION WORK(100),WORK2(100),ATS(101)
      LENSIN = KTERMS
      HMAG = ABS(H)
C------
C Transfer to the local array.
C------
      LOWEND = 0
      DO 100 K=1,LENSIN
         TEMP1 = ABS(ATS(K))
         IF(ATS(K) .NE. 0.0) THEN
C Find the first non-zero term.
            IF(LOWEND .EQ. 0) LOWEND = K
         ELSE
            TEMP1 = 1.E-35
         ENDIF
         WORK(K) = TEMP1
  100 WORK2(K) = TEMP1
      LOWD = LOWEND + NORDER
      IF(NORDER .LT. 2) GO TO 118
C------
C Shift the series by the order of the ODE.
C This is to account for derivatives.
C------
      DO 110 I=2,NORDER
         LENSIN = LENSIN - 1
         DO 109 K=1,LENSIN
  109    WORK2(K) = WORK2(K+1)*K/HMAG
  110 CONTINUE
  118 RADTL = HMAG
      IF(MSTIFF .EQ. 10) LENSIN = LENSIN/2
      DO 400 KOUNT=1,5
        DMAXL = AMAX1(WORK2(LOWD+1),WORK2(LOWD+2),WORK2(LOWD+3),
     A  WORK2(LOWD+4),WORK2(LOWD+5))
        DMAXH = AMAX1(WORK2(LENSIN),WORK2(LENSIN-1),WORK2(LENSIN-2),
     A  WORK2(LENSIN-3),WORK2(LENSIN-4),WORK2(LENSIN-5),WORK2(LENSIN-6))
        SLOPE = (DMAXL/DMAXH)**(1.0/(LENSIN-6))
C------
        RADTL = RADTL*SLOPE
        IF(ABS(1.0 - SLOPE) .LT. 1.E-3) GO TO 401
        DLOOP = 1.0
        DO 330 J=2,LENSIN
          DLOOP = DLOOP*SLOPE
  330   WORK2(J) = DLOOP*WORK2(J)
  400 CONTINUE
  401 ATS(101) = -2.0
      IF(MSTIFF .EQ. 10) RETURN
      LENSIN = KTERMS
C Test for last-pole situations.
      DLOOP = 1.0
      RATIO = RADTL/HMAG
      DO 500 J=2,LENSIN
C Adjust the original series by the 0.7*Rc.
        DLOOP = DLOOP*RATIO
  500 WORK2(J) = DLOOP*WORK(J)
C Search backwards for a viable term.
      DO 600 I=1,LENSIN
      J = LENSIN - I + 1
C Is there a last-pole situation?
      IF(WORK2(J) .GT. WORK2(LOWEND)*1.E-5) GO TO 601
  600 CONTINUE
C Yes.  Artificially use just 8 terms of the Taylor series.
  601 IF(J .GT. 5) RETURN
      ATS(101) = -20.
      RADTL = (WORK(LOWEND)/WORK(8))**(1.43E-1)*HMAG
      RETURN
C********
C end TOPLN
C********
      END
