C  File rclib14.for                     21-DEC-1993
C
C  Contents:
C      SUBROUTINE DBVP(KOUNT,VALUE,BVAL,GUESS,IP,RP)
C      SUBROUTINE DMTRIX(KOUNT,GUESS,VALUE,AK)

      SUBROUTINE DBVP(KOUNT,VALUE,BVAL,GUESS,IP,RP)
C********
C  ATOMFT Subroutine-Library, version 3.11, completed (1/31/93).
C    Copyright (C) 1979-93, Y. F. Chang.
C This subroutine is used to solve two-point boundary-value problems.
C
C Inputs:-
C KOUNT is the number of attempts.
C VALUE is the solution value, an attempt to match the boundary value.
C BVAL is the desired boundary value.
C GUESS is the initial value guess.
C
C Outputs:-
C GUESS is the next guess for the initial values.
C********
      DOUBLE PRECISION VALUE,BVAL,GUESS,TEMP1,TEMP2,TEMP3,TOP,
     A BOT1,BOT2,HOLD(10),G(10),V(10),AK(10),RTR(9),RTI(9),SIZE,IP(20),
     A RP(20)
      SAVE KDELTA,JUMPOT,V,HOLD,SIZE
      DATA SIZE/1.D0/,KDELTA/0/
      LIST = IP(5)
      IF(BVAL-VALUE.EQ.0.D0 .OR. JUMPOT.EQ.1) STOP
      IF(DABS((BVAL-VALUE)/SIZE) .LT. 5.D0*RP(4)) STOP
      NOUNT = KOUNT - KDELTA
      IF(NOUNT .GT. 10) THEN
        DO 100 I=1,9
          V(I) = V(I+1)
  100   HOLD(I) = HOLD(I+1)
        NOUNT = 10
      ENDIF
      SIZE = DMAX1(SIZE,DABS(VALUE),DABS(GUESS))
      V(NOUNT) = VALUE
      HOLD(NOUNT) = GUESS
      IF(NOUNT .GT. 1) GO TO 102
      GUESS = 0.5D0*GUESS
      GO TO 290
  102 IF(NOUNT .GT. 2) GO TO 103
      TOP = HOLD(2) - HOLD(1)
      BOT1 = V(2)/HOLD(2) - V(1)/HOLD(1)
      TEMP1 = (V(2)/HOLD(2) - BVAL)*TOP/BOT1
      TEMP3 = HOLD(2) - TEMP1
      BOT2 = V(2) - V(1)
      TEMP2 = (V(2) - BVAL)*TOP/BOT2
      BOT2 = HOLD(2) - TEMP2
      IF(BOT2*HOLD(1).LT.0.D0 .AND. TEMP3*HOLD(1).LT.0.D0) GO TO 313
      IF(BOT2*HOLD(1).GT.0.D0 .AND. TEMP3*HOLD(1).GT.0.D0) THEN
          GUESS = BOT2
      ELSE
        IF(BOT2*HOLD(1) .LT. 0.D0) THEN
          GUESS = TEMP3
        ELSE
          GUESS = BOT2
        ENDIF
      ENDIF
C Reject if too small or too large.
      IF(DABS(GUESS).GT.2.D1*DABS(HOLD(1)) .OR. DABS(GUESS).LT.
     A 0.2D0*DABS(HOLD(2))) THEN
        WRITE(LIST,10)
   10 FORMAT(' The initial guess is out of range.')
        GO TO 313
      ENDIF
      GO TO 290
  103 ITOP = NOUNT - 1
      DO 200 I=1,ITOP
  200 G(I) = HOLD(I) - GUESS
      G(NOUNT) = 0.D0
      CALL DMTRIX(NOUNT,G,V,AK)
      IF(AK(1) .EQ. 0.D0) GO TO 313
      TEMP2 = AK(1) - BVAL
      IF(NOUNT .GT. 3) GO TO 400
      TEMP3 = AK(2)*AK(2) - 4.D0*AK(3)*TEMP2
C The solution does not exist if TEMP1 is less than zero.
C So, back up and try again.
      IF(TEMP3 .LE. 0.D0) THEN
        NOUNT = NOUNT - 1
        KDELTA = KDELTA + 1
C Give up after five tries.
        IF(KDELTA .GT. 10) GO TO 313
        HOLD(1) = HOLD(2)
        V(1) = V(2)
        HOLD(2) = HOLD(3)
        V(2) = V(3)
        GO TO 102
      ENDIF
      TEMP1 = GUESS + (DSQRT(TEMP3) - AK(2))/(2.D0*AK(3))
      TEMP2 = GUESS + (- DSQRT(TEMP3) - AK(2))/(2.D0*AK(3))
      IF(TEMP1*HOLD(1).LT.0.D0 .AND. TEMP2*HOLD(1).LT.0.D0) GO TO 313
      IF(TEMP1*HOLD(1).GT.0.D0 .AND. TEMP2*HOLD(1).GT.0.D0) THEN
C Accept the next guess closest to the previous guess.
        TEMP3 = HOLD(3)
        IF(DABS(TEMP3-TEMP1) .LT. DABS(TEMP3-TEMP2)) THEN
          GUESS = TEMP1
        ELSE
          GUESS = TEMP2
        ENDIF
      ELSE
        IF(TEMP1*HOLD(1) .GT. 0.D0) THEN
          GUESS = TEMP1
        ELSE
          GUESS = TEMP2
        ENDIF
      ENDIF
  290 IF(IP(4) .NE. 0) WRITE(LIST,300) KOUNT,GUESS
  300 FORMAT(/' For trial',I2,', next guess =',1PD22.14)
      IF(DABS((GUESS-HOLD(NOUNT))/GUESS) .LT. 1.D-11) THEN
        JUMPOT = 1
      ELSE
        JUMPOT = 0
      ENDIF
      RETURN
  400 AK(1) = TEMP2
      CALL DRTPLY(NOUNT,AK,RTR,RTI,LIST,RP)
      KTOP = NOUNT - 1
      MARK = 0
      BOT1 = 1.D32
      DO 410 K=1,KTOP
      TEMP1 = RTR(K)
      TEMP2 = RTI(K)
      IF(TEMP2 .EQ. 0.D0) THEN
        IF(DABS(TEMP1) .LT. BOT1) THEN
          BOT1 = DABS(TEMP1)
          MARK = K
        ENDIF
      ENDIF
  410 CONTINUE
      IF(MARK .EQ. 0) GO TO 313
      GUESS = GUESS + RTR(MARK)
      GO TO 290
C No solution message.
  313 WRITE(LIST,315)
  315 FORMAT(' ATOMFT cannot find the boundary value solution.')
      STOP
C******
C end DBVP
C******
      END
      SUBROUTINE DMTRIX(KOUNT,GUESS,VALUE,AK)
C********
C  ATOMFT Subroutine-Library, version 3.11, completed (1/31/93).
C    Copyright (C) 1979-93, Y. F. Chang.
C This subroutine is used to generate a polynomial from the boundary
C   values calculated.
C
C Inputs:-
C KOUNT is the number of guesses made.
C VALUE contains the solution values, the attempts to match the
C         boundary value.
C GUESS contains the initial value guesses.
C
C Outputs:-
C AK    contains the polynomial terms, constant term first.
C********
      DOUBLE PRECISION GUESS(1),VALUE(1),AK(1),TEMP1,TEMP2,COEF
      DIMENSION IPVT(10),COEF(11,11)
      JTOP = KOUNT - 1
      LTOP = KOUNT + 1
      DO 110 MM=1,KOUNT
C------
C Define the matrix coefficients.
C------
         COEF(MM,1) = 1.D0
         DO 100 II=2,KOUNT
  100    COEF(MM,II) = COEF(MM,II-1)*GUESS(MM)
  110 COEF(MM,LTOP) = VALUE(MM)
C------
C Solve by Gaussian elimination.
C------
      DO 120 M=1,KOUNT
  120 IPVT(M) = M
      DO 160 M=1,JTOP
C------
C Find the pivot element.
C------
         TEMP2 = 0.D0
         DO 130 MM=M,KOUNT
            M1 = IPVT(MM)
            TEMP1 = DABS(COEF(M1,M))
            IF(TEMP1 .GT. TEMP2) THEN
               IMAX = MM
               TEMP2 = TEMP1
            ENDIF
  130    CONTINUE
C------
C Exchange rows IMAX and M.
C------
         M1 = IPVT(IMAX)
         IPVT(IMAX) = IPVT(M)
         IPVT(M) = M1
C------
C Eliminate the rest of column M.
C------
         M1 = M + 1
         DO 150 MM=M1,KOUNT
            IMM = IPVT(MM)
            IM  = IPVT(M)
C------
C Abortive exit if the denominator is zero.
C------
            IF(COEF(IM,M) .EQ. 0.D0) GO TO 9999
            TEMP1 = COEF(IMM,M)/COEF(IM,M)
            COEF(IMM,M) = TEMP1
            DO 140 I=M1,LTOP
  140       COEF(IMM,I) = COEF(IMM,I) - TEMP1*COEF(IM,I)
  150    CONTINUE
  160 CONTINUE
C------
C Back substitution.
C------
      DO 180 II=1,KOUNT
         IJ = LTOP - II
         IM = IPVT(IJ)
         IF(COEF(IM,IJ) .EQ. 0.D0) GO TO 9999
         TEMP1 = COEF(IM,LTOP)
         IF(II .EQ. 1) GO TO 180
         ITOP = II - 1
         DO 170 I=1,ITOP
           IK = IJ + I
  170    TEMP1 = TEMP1 - COEF(IM,IK)*AK(IK)
  180 AK(IJ) = TEMP1/COEF(IM,IJ)
      RETURN
C------
C Error return
C------
 9999 AK(1) = 0.D0
C------
C end DMTRIX
C------
      RETURN
      END
