C  File rclib2.for                     30-DEC-1993

      SUBROUTINE ZEROT(Y,ROOT,TMPV,NAMES,IPASS,RPASS)
C**********
C  ATOMFT Subroutine-Library, version 3.11, completed (7/23/93).
C    Copyright (C) 1979-93, Y. F. Chang.
C  This ZEROT(3.11) can be used with a non-zero DLTXPT.
C********
      CHARACTER*6 NAMES(1)
      DIMENSION Y(1),TMPV(1),TMPB(70),ROOTR(30),ROOTI(30),IPASS(20),
     A RPASS(20)
C RPASS(13) = TESTB
C RPASS(15) = SIZE
C RPASS(16) = old HNEW
      NUMEQS = IPASS(1)
      LENSER = IPASS(2)
      LENVAR = IPASS(3)
      MPRINT = IPASS(4)
      LIST   = IPASS(5)
      MSTIFF = IPASS(6)
      KENDFG = IPASS(13)
      H      = RPASS(2)
      XPRINT = RPASS(6)
      START  = RPASS(8)
C******** Initialize
      NTOP = LENVAR*NUMEQS + 1
      KSUBFT = IPASS(7)
      IPASS(7) = 1
      LKOVER = IPASS(15)
      IF(IPASS(9) .GT. 1) GO TO 120
      ZSTEP = START - 10.0*H
      KC = LENSER/2
      DO 110 II=1,NUMEQS
      IL = (II-1)*LENVAR
      IF(Y(KC).EQ.TMPV(KC+IL) .AND. Y(KC-1).EQ.TMPV(KC-1+IL)) GO TO 111
  110 CONTINUE
      IPASS(19) = 0
      GO TO 112
C It is a dependent variable.
  111 IPASS(19) = II
  112 IF(MSTIFF.EQ.1 .AND. IPASS(19).NE.0) THEN
C------
C I can do superfast.  But, not the dependent variables.
C------
         WRITE(LIST,8)
    8 FORMAT(' For MSTIFF=1,'/
     A ' ZEROT can only work with NON-dependent variables.'/
     A ' For a dependent variable, say F, use a dummy variable TEST.'/
     A ' Then, place'/
     A '      TEST = F , in the first data block in ODEINP, and'/
     A '      CALL DZEROT(TEST,ROOT,TMPV,NAMES,IPASS,RPASS)'/
     A ' in the fourth data block.')
         STOP
      ENDIF
      IF(MSTIFF.NE.1 .AND. IPASS(19).EQ.0) WRITE(LIST,12)
   12 FORMAT(' ZEROT is not as accurate for a variable that is not'/
     A ' a dependent variable.'/
     A ' You may wish to declare an auxiliary variable as follows.'/
     A '      DIFF(AUX,T,0) = WHATEVER , in ODEINP, and then'/
     C '      CALL ZEROT(AUX,ROOT,TMPV,NAMES,IPASS,RPASS)')
  120 UNDER = AMAX1((2.0*RPASS(17)),RPASS(4))
      IF(KENDFG.EQ.3) GO TO 130
      RPASS(15) = SQRT(RPASS(15)*ABS(Y(1)))
C Call RSET to cancel the storing for KENDFG=1 or 2.
      IPASS(15) = -1
      CALL RSET(TMPV,NAMES,IPASS,RPASS)
C Look for the series length.  This must be done every call,
  130 DO 150 I=1,LENSER
      J = LENSER + 1 - I
      TMPC = ABS(Y(J))
      IF(TMPC .GT. RPASS(13)) GO TO 151
  150 CONTINUE
  151 LENSIN = J
C The analysis is now done on every call.
C Transfer the series to TMPB.
      DO 160 J=1,LENSIN
  160 TMPB(J) = Y(J)
      HNEWIN = RPASS(3)
C For KENDFG=3.
      IF(KENDFG.EQ.3) HNEWIN = XPRINT - START
      TMPB(1) = TMPB(1) - ROOT
      IF(ABS(TMPB(1)) .GT. UNDER) GO TO 430
C For subft, KSUBFT=-1.  Otherwise, it is +1.
      IF(KSUBFT .LT. 0) THEN
        HADJ = 0.0
        ZSTEP = START
        GO TO 6800
      ENDIF
C Remove a near-zero root.
  419 DO 420 J=2,LENSIN
  420 TMPB(J-1) = TMPB(J)
      IF(ABS(TMPB(1)) .LE. UNDER) GO TO 419
  430 CALL SRTPLY(8,TMPB,ROOTR,ROOTI,LIST,RPASS)
      RRMIN = 5000.0
      NPOS = 0
      DO 480 K=1,7
      IF(ROOTR(K).LT.0.0 .OR. ROOTI(K).NE.0.0) GO TO 480
C..Look only for zeros in the positive direction.
      IF(ROOTR(K) .LT. RRMIN) THEN
        RRMIN = ROOTR(K)
        NPOS = K
      ENDIF
  480 CONTINUE
      IF(NPOS .EQ. 0) GO TO 9000
C We have a positive root.
 6000 HADJ = RRMIN*H
      IF(ABS(HADJ) .GT. 3.0*RPASS(16)) GO TO 9000
      DO 6550 KNT=1,7
      ZSTEP = START + HADJ
C Stop if beyond END.
      IF((ZSTEP-RPASS(9))*H .GT. 0.0) GO TO 9000
      ROOTR(KNT) = HADJ
      RATIO = HADJ/H
      DLOOP = 1.0
      TEMP1 = Y(1)
      DO 6510 J=2,LENSIN
      DLOOP = DLOOP*RATIO
 6510 TEMP1 = TEMP1 + DLOOP*Y(J)
      TEMP2 = ABS(TEMP1 - ROOT)/RPASS(15)
      IF(TEMP2 .LT. UNDER) GO TO 6600
      IF(TEMP2 .GT. 0.1) GO TO 9000
      ROOTI(KNT) = TEMP1 - ROOT
      IF(KNT .EQ. 1) THEN
C Set the limit for the next HNEW.
        TEMP1 = HADJ + START
        TEMP3 = ABS(TEMP1 - XPRINT)*(1.0 - TEMP2)
        IF(TMPV(NTOP).EQ.0.0.OR.TMPV(NTOP).GT.TEMP3)
     A      TMPV(NTOP) = TEMP3 * 9.6E-1
        HADJ = HADJ + 1.1*SIGN(TEMP2,TEMP2*(Y(1)-ROOT))
      ELSE
        DN = ROOTI(KNT) - ROOTI(KNT-1)
        IF(DN .EQ. 0.0) GO TO 9000
        HADJ = ROOTR(KNT-1) - ROOTI(KNT-1)*(ROOTR(KNT)-ROOTR(KNT-1))/DN
        DUMMY = ABS((HADJ - ROOTR(KNT))/HADJ)
        IF(DUMMY .LT. UNDER) GO TO 6600
      ENDIF
 6550 CONTINUE
C If KNT=7, the point is too far away.
      GO TO 9000
C Set the limit for the next HNEW.
 6600 TMPV(NTOP) = ABS(HADJ + START - XPRINT) * 0.99
C Take an extra step if root is beyond old HNEW, RPASS(16).
      IF(ABS(HADJ) .GT. RPASS(16)) GO TO 9000
C This root is valid; stop and print.
      IF(MPRINT.GT.3 .AND. ABS(HADJ).LT.ABS(HNEWIN)) WRITE(LIST,411)
  411 FORMAT(' *****--------Throw away the above step.--------*****')
 6800 IPASS(7) = 0
      IF(MPRINT.GT.1) THEN
        ZSTEP = START + HADJ
        WRITE(LIST,15) NAMES(1),ZSTEP
   15 FORMAT(/' There is a root at',A6,' =',1PE13.6)
      ENDIF
      RPASS(15) = 1.0
      ORDER = 50.0 + RPASS(1)
      TMPV(NTOP) = 0.0
C Use ORDER to pass back to RDCV the fact that HNEW should
C  be the un-forced HNEW.
      RPASS(10) = ORDER
      RPASS(3) = HADJ
      IPASS(15) = -3
      KPRINT = IPASS(4)
      IF(KPRINT.GT.0 .AND. KPRINT.LT.4) IPASS(4) = 4
      GO TO 9100
 9000 IF(KENDFG.EQ.3) GO TO 9999
      IPASS(15) = -2
      KPRINT = IPASS(4)
 9100 CALL RSET(TMPV,NAMES,IPASS,RPASS)
      IPASS(4) = KPRINT
 9999 IPASS(15) = LKOVER
      RETURN
C********
C end ZEROT
C********
      END
