C  File rclib4.for                     30-DEC-1993

      SUBROUTINE SEEK(KOFSET,KC,KFLAG,F,C,Y,NAMES,IPASS,RPASS)
C********
C  ATOMFT Subroutine-Library, version 3.11, completed (1/31/93).
C    Copyright (C) 1979-93, Y. F. Chang.
C   This is used in DAE problems to iterate for the constraint.
C
C  (2/20/89) Caution!  Do not attempt to make any modification to
C  this code.  It has reversed communications with the main ATSPGM
C  program.  There are some complex inter-dependencies between the
C  parameters here and in ATSPGM that must be understood.
C
C  The arguments are defined in the user manual.
C
C  The important pointers are KC, and KFLAG.
C  KC - order of the CND-term (the condition) being set to zero.
C       All CND-terms are iterated to be zero.
C  KFLAG - the iteration status flag.  It is used to count the
C          number of times the loop is used.
C       When iteration is completed, KFLAG=90000.
C********
      CHARACTER*6 NAMES(1)
      DIMENSION Y(1),F(1),C(1),G(20),TMP(2,500),IPASS(20),RPASS(20)
      SAVE NYES,J,II,IIJ,IOLD,IITOP,IJTOP,NPT,BSIZE,G1,G2,R1,R2,
     A TMP,RATIO,IL
      DATA NYES/0/
      NUMEQS = IPASS(1)
      LENSER = IPASS(2)
      LENVAR = IPASS(3)
      MPRINT = IPASS(4)
      LIST   = IPASS(5)
      INTSTP = IPASS(9)
      NTERMS = IPASS(14)
      H      = RPASS(2)
      START  = RPASS(8)
      IF(KC.GT.KOFSET) GO TO 5000
C Adjust initial conditions to meet constraint, KC = 1,2,etc.
C Kflag=90000 for the final loop of iteration, to calculate the c's.
      IF(KFLAG.NE.90000) GO TO 200
      KFLAG = 0
      TEMP = ABS(C(KC))
      IF(TEMP .EQ. 0.0) GO TO 1910
      IF(TEMP .LT. 5.0*RPASS(17)) GO TO 1910
      DO 100 II=1,IJTOP
      IF(TMP(2,II).NE.0.0) TMP(1,II) = 0.0
  100 CONTINUE
      GO TO 1100
  200 IF(KFLAG.GT.0) GO TO 1200
C Go to the re-entry point at 1200.
      IF(KC.GT.1) GO TO 1100
C Jump over the TMP=0.  It must then be processed at least once.
      IF(NYES.NE.0) GO TO 1000
C Skip forward pass these initializations.
      IITOP = NUMEQS
      IJTOP = IITOP*NTERMS
      BSIZE = 0.0
C Find a base SIZE for use in iteration.  Only on first entry.
      DO 900 II=1,IITOP
      IL = (II-1)*LENVAR
      DO 900 JJ=1,NTERMS
      SIZE = ABS(Y(JJ+IL))
      IF(SIZE.GT.BSIZE) BSIZE = SIZE
  900 CONTINUE
      IF(MPRINT.EQ.4) THEN
         MPRINT = 3
         IPASS(4) = 3
      ENDIF
 1000 DO 1010 KK=1,LENSER
C Set initial guess array to zero, on every first step.
 1010 F(KK) = 0.0
      NPT = 0
C Setup TMP-array.
      DO 1020 II=1,IJTOP
 1020 TMP(1,II) = 0.0
 1100 DO 1111 II=1,IJTOP
 1111 TMP(2,II) = 0.0
      R1 = C(KC)
      IF(ABS(R1).GT.4.0*RPASS(17)) GO TO 1120
C Must iterate on first entry.
      IF(NYES.EQ.0 .AND. KFLAG.EQ.0 .AND. KC.EQ.1) GO TO 1120
C DO not iterate if close enough.
      KFLAG = 0
      GO TO 1909
 1120 KFLAG = 1
C Start at the first variable.
      II = 1
      J = 0
      IOLD = 0
C**********************************************
C This is the top of the iteration DO-loop.
C**********************************************
C Within this loop, each initial condition will be tested for its
C   effect on the CNDITN=0.  Those dependent variables with a one (1)
C   in its 30-th term will be assumed to be exact, and therefore they
C   will not be iterated.
C The variable TMP(1 is used to hold the values of the iterated
C   initial conditions.  Also, once TMP(1 is non-zero, the dependent
C   variable will not be iterated on this CNDITN (in this pass), or a
C   higher-order CNDITN (on a later pass).  Of course, TMP(1 is reset
C   by the first pass through SEEK on subsequent integration steps.
C The space-shuttle problem needs this.
C In this way, we avoid the unnecessary and/or duplicate iteration
C   of any initial condition.  This means that the TMP(1 corresponding
C   to the 'exact' variables will be assigned a value of one on the
C   very first pass on the very first integration step.
C The variable TMP(2 is used to hold the incremental error generated
C   by the value stored in TMP(1.
C So, we can use TMP(1 and TMP(2 to calculate the appropriate amount
C   that each dependent variable.
 1160 RATIO = 1.0
C RATIO is purposely made large here so as not to miss anything.
      IF(J.LT.NTERMS) GO TO 1165
C Advance to another variable.
      II = II + 1
      IF(II.GT.IITOP) GO TO 1500
      J = 0
C Advance to a higher-order term.
 1165 J = J + 1
      IIJ = II + (J-1)*IITOP
      IL = (II-1)*LENVAR
C Save the old initial value.
      Y(LENSER+J+IL) = Y(J+IL)
C Has it been used before?  Is TMP(1 non-zero?
      IF(TMP(1,IIJ).NE.0.0) GO TO 1202
C Is the value to be accepted as is?  If so, set TMP(1 = 1.
      IF(INTSTP.NE.1 .OR. Y(LENSER+IL).EQ.0.0) GO TO 1172
      TMP(1,IIJ) = 1.0
C Set TMP1 to one so it will not be processed later.
C This is why, we must iterate on first entry.
      GO TO 1202
 1170 KFLAG = IOLD + 2
C Raise KFLAG to indicate subsequent loops.
C Repeat for a new value of the dependent variable.
 1172 DUMMY = Y(LENSER+J+IL)
      Y(J+IL) = DUMMY*(1.0 + RATIO)
      IF(Y(J+IL).EQ.0.0) Y(J+IL) = BSIZE*RATIO
C**************************************************
C This is the exit point of the iteration DO-loop.
C**************************************************
C Return to the calling program and evaluate the condition based
C   on the new dependent-variable value.  The calling program is
C   "inside" this DO-loop.
C The specific dependent variable being iterated (they are done
C   one at a time) has been assigned a value which will produce
C   an error.
      GO TO 1909
C******************************************************
C This is the Re-entry point of the iteration DO-loop.
C******************************************************
C The error produced by the value assigned to the specific dependent
C   variable will be saved in TMP(2.  That is, if the error is not
C   too far out of line.
 1200 R2 = C(KC)
      DLERR = R2 - R1
C Is the difference small enough?
      IF(DLERR.NE.0.0 .OR. KFLAG.GT.(IOLD+1)) GO TO 1205
C This variable has no effect on this term; REJECT it.
      TMP(1,IIJ) = 0.0
 1202 TMP(2,IIJ) = 0.0
      GO TO 1210
 1205 IF(ABS(R1).GT.4.0*RPASS(17)) GO TO 1206
      TMP(2,IIJ) = 0.0
      GO TO 1208
 1206 COMPAR = ABS(DLERR/R1)
C Decrease ratio for a smaller change on the next try.
      RATIO = RATIO*(COMPAR**(-0.8))
C Repeat if the change yields an error that is too large.
      IF(COMPAR.GT.5.0) GO TO 1170
C Save the parameters for the final calculation loop.
      TMP(2,IIJ) = DLERR
 1208 TMP(1,IIJ) = Y(J+IL)
 1210 IOLD = IOLD + 1
      KFLAG = IOLD + 1
C Advance to the next variable.  Restore the old value.
      Y(J+IL) = Y(LENSER+J+IL)
C**********************************************
C This is the bottom of the iteration DO-loop.
C**********************************************
C It is not written as a DO-loop because it has
C  exits to the calling program.  Reverse communication.
      GO TO 1160
 1500 DUMMY = 0.0
C Calculate variables for the final loop.
      DO 1510 II=1,IITOP
      IL = (II-1)*LENVAR
      DO 1510 JJ=1,NTERMS
      IIJ = II + (JJ-1)*IITOP
      IF(TMP(2,IIJ).EQ.0.0) GO TO 1510
      DUMMY = DUMMY + ABS(Y(LENSER+JJ+IL))
 1510 CONTINUE
      IF(DUMMY.EQ.0.0) GO TO 1900
C Subdivide the condition by the sum of variable magnitudes.
      COMPAR = R1/DUMMY
      DO 1550 II=1,IITOP
      IL = (II-1)*LENVAR
      DO 1550 JJ=1,NTERMS
      IIJ = II + (JJ-1)*IITOP
      IF(TMP(2,IIJ).EQ.0.0) GO TO 1550
      DUMMY = Y(LENSER+JJ+IL)
      DEN = TMP(1,IIJ) - DUMMY
C Each variable bears its share of the adjustment.
      Y(JJ+IL) = DUMMY - ABS(DUMMY)*DEN*COMPAR/TMP(2,IIJ)
 1550 CONTINUE
C Return to calling program to check for accuracy.
 1900 KFLAG = 90000
 1909 NYES = 1
 1910 RETURN
C This is the iteration section for the higher derivatives.
 5000 KF = KC - KOFSET
      IF((KFLAG+KF).GT.1) GO TO 7000
      IF(NPT.EQ.1 .OR. MPRINT.LT.3) GO TO 7000
      KSTP = INTSTP - 1
C Print a normal heading with byline, and outputs.
      WRITE(LIST,6010) KSTP,START
 6010 FORMAT(/3X,'Step',I4,' at',1PE12.5,'  solved by SEEK.')
 6025 DO 6099 II=1,IITOP
      IL = (II-1)*LENVAR
      NLABEL = Y(LENVAR-5+IL)
      DUMMY = 1.0
      DO 6040 K=1,NTERMS
      G(K) = Y(K+IL)*DUMMY
 6040 DUMMY = DUMMY*(K)/H
      WRITE(LIST,6044) NAMES(NLABEL),(G(K),K=1,NTERMS)
 6044 FORMAT(1X,A6,(1X,1P4E13.5))
 6099 CONTINUE
      WRITE(LIST,6111) (C(KK),KK=1,KOFSET)
 6111 FORMAT('  The constraint zeros:-',1P3E12.4)
 7000 NPT = 1
      KFLAG = KFLAG + 1
      IF(KFLAG.EQ.1) GO TO 8220
C Calculate the slope for the higher loops.
      TOP = R1 - C(KC)
      BOTTOM = G1 - F(KF)
      G2 = TOP/BOTTOM
      GO TO 8230
 8220 INIT = 0
      IF(F(KF).EQ.0.0) INIT = 1
      R1 = C(KC)
      G1 = F(KF)
      IF(G2 .EQ. 0.0) G2 = -1.0
C Print only on a very high MPRINT, or else too much output.
 8230 IF(MPRINT.GT.7) WRITE(LIST,7051) KF,KFLAG,F(KF),C(KC),G2
 7051 FORMAT(' Term ',I2,' Loop ',I2,' Guess=',1PE12.5,' Fit=',E12.5,
     A ' slope',E13.6)
      IF(C(KC).EQ.0.0) GO TO 9900
      IF(KF.GT.1 .AND. KFLAG.GT.2) GO TO 9900
      IF(ABS(C(KC)).LT.1.E-6*ABS(F(KF))) GO TO 9900
C The ultimate precision must be obtained for all the functions.
      IF(KFLAG.GT.1) GO TO 9000
      IF(INIT.EQ.1) GO TO 9100
C Restart with zero except for the first round.
      F(KF) = 0.0
      RETURN
 9000 IF(ABS(TOP/R1).GT.0.05) GO TO 9100
C For a result that is too close, move guess away and repeat.
      F(KF) = F(KF) - 10.*BOTTOM
      KFLAG = KFLAG - 1
      RETURN
 9100 G1 = F(KF)
      R1 = C(KC)
C Estimate the next function value according to the slope.
      F(KF) = F(KF) - C(KC)/G2
      IF(ABS((R1/G2)/(G1+F(KF))) .GT. 1.E-5) RETURN
      RETURN
 9900 KFLAG = 0
C Exit if the accuracy is acquired.  KFLAG=0.
      RETURN
C********
C end SEEK
C********
      END
