C  File rclib5.for                     30-DEC-1993

      SUBROUTINE MSEEK(KOFSET,KC,KFLAG,F,C,KARD,Y,NAMES,IPASS,RPASS,
     A KY1,KY2,KY3,KY4,KY5)
C********
C  ATOMFT Subroutine-Library, version 3.11, completed (1/31/93).
C    Copyright (C) 1979-93, Y. F. Chang.
C   This is used in multiple-constraint DAE problems.
C
C  (2/20/89) Caution!  Do not attempt to make any modification to
C  this code.  It has reversed communications with the main ATSPGM
C  program.  There are some complex inter-dependencies between the
C  parameters here and in ATSPGM that must be understood.
C********
      CHARACTER*6 NAMES(1)
      DIMENSION Y(1),F(1),C(1),TMP(2,500),NYES(10),IPASS(20),RPASS(20),
     A NPT(10),MARKII(10),MARKFL(10),BSIZE(10),G1(10),G2(10),R1(10),
     B R2(10),KYVAR(5,10),NUMBER(10),INIT(10)
      SAVE NYES,J,II,IIJ,IOLD,NPT,NUMBER,MARKII,MARKFL,KYVAR,
     A BSIZE,G1,G2,R1,R2,TMP,COMPAR,IL
      DATA NYES/10*0/,NUMBER/10*1/
      NUMEQS = IPASS(1)
      LENSER = IPASS(2)
      LENVAR = IPASS(3)
      MPRINT = IPASS(4)
      LIST   = IPASS(5)
      INTSTP = IPASS(9)
      NTERMS = IPASS(14)
      H      = RPASS(2)
      START  = RPASS(8)
      MAXVAR = NUMBER(KARD)
      IJBOT = (KARD-1)*50 + 1
      IJTOP = IJBOT + MAXVAR*NTERMS - 1
      IF(KC.GT.KOFSET) GO TO 5000
C Adjust initial conditions to meet constraint, KC = 1,2,etc.
C KFLAG=90000 for the final loop of iteration for the C's.
      IF(KFLAG.NE.90000) GO TO 200
      KFLAG = 0
      TEMP = ABS(C(KC))
      IF(TEMP .EQ. 0.0) GO TO 1910
      IF(TEMP .LT. 5.0*RPASS(17)) GO TO 1910
      DO 100 II=IJBOT,IJTOP
  100 TMP(1,II) = 0.0
      GO TO 1100
  200 IF(KFLAG.GT.0) GO TO 1200
C Go to the re-entry point at 1200.
      IF(KC.GT.1) GO TO 1100
C Jump over the TMP=0.  It must then be processed at least once.
      IF(NYES(KARD).NE.0) GO TO 1000
C Skip forward pass these initializations.
      KYVAR(1,KARD) = KY1
      KYVAR(2,KARD) = KY2
      KYVAR(3,KARD) = KY3
      KYVAR(4,KARD) = KY4
      KYVAR(5,KARD) = KY5
      DO 300 I=1,5
      IZ = 6 - I
      IF(KYVAR(IZ,KARD) .NE. 0) GO TO 301
  300 CONTINUE
  301 NUMBER(KARD) = IZ
      MAXVAR = IZ
      IJTOP = IJBOT + MAXVAR*NTERMS - 1
      IF(MPRINT.EQ.4) THEN
         MPRINT = 3
         IPASS(4) = 3
      ENDIF
 1000 BSIZE(KARD) = 0.0
C Find a base SIZE for use in iteration, on every first step.
      DO 1002 I=1,MAXVAR
      II = KYVAR(I,KARD)
      IL = (II-1)*LENVAR
      DO 1002 JJ=1,NTERMS
      SIZE = ABS(Y(JJ+IL))
      IF(SIZE.GT.BSIZE(KARD)) BSIZE(KARD) = SIZE
 1002 CONTINUE
      IF(BSIZE(KARD).EQ.0.0) BSIZE(KARD) = 1.0
      DO 1010 KK=1,LENSER
C Set initial guess array to zero, on every first step.
 1010 F(KK) = 0.0
      NPT(KARD) = 0
C Setup TMP-array.
      DO 1020 II=IJBOT,IJTOP
 1020 TMP(1,II) = 0.0
 1100 DO 1111 II=IJBOT,IJTOP
 1111 TMP(2,II) = 0.0
      R1(KARD) = C(KC)
      IF(ABS(R1(KARD)).GT.4.0*RPASS(17)) GO TO 1120
C Must iterate on first entry, to identify the relevant variables.
      IF(NYES(KARD).EQ.0 .AND. KFLAG.EQ.0 .AND. KC.EQ.1) GO TO 1120
C DO not iterate if close enough.
      KFLAG = 0
      GO TO 1909
 1120 KFLAG = 1
C Start at the first variable.
      I = 1
      J = 0
      IOLD = 0
C This is the iteration loop.
 1160 G2(KARD) = 1.0
C G2 is purposely made large here so as not to miss anything.
      IF(J.LT.NTERMS) GO TO 1165
C Advance to another variable.
      I = I + 1
      IF(I.GT.MAXVAR) GO TO 1500
      J = 0
C Advance to a higher-order term.
 1165 J = J + 1
      II = KYVAR(I,KARD)
      IL = (II-1)*LENVAR
      IIJ = IJBOT - 1 + I + (J-1)*MAXVAR
C Save the old initial value.
      Y(LENSER+J+IL) = Y(J+IL)
C Has it been used before?
      IF(TMP(1,IIJ).NE.0.0) GO TO 1202
C Is the value to be accepted as is?
C This must be violated if there is only one variable.
      IF(MAXVAR.EQ.1 .OR. INTSTP.NE.1 .OR. Y(LENSER+IL).EQ.0.0)
     a GO TO 1172
      TMP(1,IIJ) = 1.0
C Set TMP1 to non-zero so it will not be processed later.
C This is why, it must be iterated on the first entry.
      GO TO 1202
 1170 KFLAG = IOLD + 2
C Raise KFLAG to indicate subsequent loops.
C Repeat for a new value of the dependent variable.
 1172 G1(KARD) = Y(LENSER+J+IL)
      Y(J+IL) = G1(KARD)*(1.0 + G2(KARD))
      IF(Y(J+IL).EQ.0.0) Y(J+IL) = BSIZE(KARD)*G2(KARD)
C Store I and IOLD.
      MARKII(KARD) = I
      MARKFL(KARD) = IOLD
C Return to the calling program and evaluate the condition based
C  on the new dependent-variable value.  The calling program is
C  "inside" this DO-loop.
      GO TO 1909
C Re-entry point of the iteration DO-loop.  Pick up II and IOLD.
 1200 I = MARKII(KARD)
      II = KYVAR(I,KARD)
      IL = (II-1)*LENVAR
      IOLD = MARKFL(KARD)
      IIJ = IJBOT - 1 + I + (J-1)*MAXVAR
      R2(KARD) = C(KC)
      DLERR = R2(KARD) - R1(KARD)
C Is the difference small enough?
      IF(DLERR.NE.0.0 .OR. KFLAG.GT.(IOLD+1)) GO TO 1205
C This variable has no effect on this term; reject.
      TMP(1,IIJ) = 0.0
 1202 TMP(2,IIJ) = 0.0
      GO TO 1210
 1205 IF(ABS(R1(KARD)).GT.4.0*RPASS(17)) GO TO 1206
      TMP(2,IIJ) = 0.0
      GO TO 1208
 1206 COMPAR = ABS(DLERR/R1(KARD))
C Decrease G2 for a smaller change.
      G2(KARD) = G2(KARD)*(COMPAR**(-0.8))
C Repeat if the change yields a condition too far away.
      IF(COMPAR.GT.5.0) GO TO 1170
C Save the parameters for the final calculation loop.
      TMP(2,IIJ) = DLERR
 1208 TMP(1,IIJ) = Y(J+IL)
 1210 IOLD = IOLD + 1
      KFLAG = IOLD + 1
C Advance to the next variable.  Restore the old one.
      Y(J+IL) = Y(LENSER+J+IL)
C This is the bottom of the iteration DO-loop.  It is not written as
C  a DO-loop because it has exits to the calling program.
      GO TO 1160
 1500 DUMMY = 0.0
C Calculate variables for the final loop.
      DO 1510 I=1,MAXVAR
      II = KYVAR(I,KARD)
      IL = (II-1)*LENVAR
      DO 1510 JJ=1,NTERMS
      IIJ = IJBOT - 1 + I + (JJ-1)*MAXVAR
      IF(TMP(2,IIJ).EQ.0.0) GO TO 1510
      DUMMY = DUMMY + ABS(Y(LENSER+JJ+IL))
 1510 CONTINUE
      IF(DUMMY.EQ.0.0) GO TO 1900
C Subdivide the condition by the sum of variable magnitudes.
      COMPAR = R1(KARD)/DUMMY
      DO 1550 I=1,MAXVAR
      II = KYVAR(I,KARD)
      IL = (II-1)*LENVAR
      DO 1550 JJ=1,NTERMS
      IIJ = IJBOT - 1 + I + (JJ-1)*MAXVAR
      IF(TMP(2,IIJ).EQ.0.0) GO TO 1550
      DUMMY = Y(LENSER+JJ+IL)
      DEN = TMP(1,IIJ) - DUMMY
C Each variable bears its share of the adjustment.
      Y(JJ+IL) = DUMMY - ABS(DUMMY)*DEN*COMPAR/TMP(2,IIJ)
 1550 CONTINUE
C Return to calling program to check for accuracy.
 1900 KFLAG = 90000
 1909 NYES(KARD) = 1
 1910 RETURN
C This is the iteration section for the higher derivatives.
 5000 KF = KC - KOFSET
C The printing section.
      IF((KFLAG+KF).GT.1) GO TO 7000
      IF(NPT(KARD).EQ.1 .OR. MPRINT.LT.3) GO TO 7000
      IF(KARD.GT.1) GO TO 6025
      KSTOP = INTSTP - 1
C Print a normal heading with byline, and outputs.
      WRITE(LIST,6010) KSTOP,START
 6010 FORMAT(/5X,'Step',I4,' at',1PE12.5,'  solved by MSEEK.')
 6025 DO 6099 I=1,MAXVAR
      II = KYVAR(I,KARD)
      IL = (II-1)*LENVAR
      NLABEL = Y(LENVAR-5+IL)
      DUMMY = 1.0
      DO 6040 K=1,NTERMS
      TMP(1,IJBOT+K) = Y(K+IL)*DUMMY
 6040 DUMMY = DUMMY*(K)/H
      WRITE(LIST,6044) NAMES(NLABEL),(TMP(1,IJBOT+K),K=1,NTERMS)
 6044 FORMAT(1X,A6,(1X,1P4E13.5))
 6099 CONTINUE
      IF(MPRINT.GT.4) WRITE(LIST,6111) KARD,(C(KK),KK=1,KOFSET)
 6111 FORMAT(I4,', constraint zeros:-',1P3E12.4)
 7000 NPT(KARD) = 1
      KFLAG = KFLAG + 1
      IF(KFLAG.EQ.1) GO TO 8220
      COMPAR = AMAX1(COMPAR,ABS(F(KF)),ABS(C(KC)))
C Calculate the slope for the higher loops.
      TOP = R1(KARD) - C(KC)
      BOTTOM = G1(KARD) - F(KF)
      G2(KARD) = TOP/BOTTOM
      GO TO 8230
 8220 INIT(KARD) = 0
      COMPAR = AMAX1(ABS(F(KF)),ABS(C(KC)))
      IF(F(KF).EQ.0.0) INIT(KARD) = 1
      R1(KARD) = C(KC)
      G1(KARD) = F(KF)
      IF(G2(KARD) .EQ. 0.0) G2(KARD) = -1.0
C Print only on a very high MPRINT, or else too much output.
 8230 IF(MPRINT.GT.7) WRITE(LIST,7051)KARD,KF,KFLAG,F(KF),C(KC),G2(KARD)
 7051 FORMAT(' Card',I2,' Term ',I2,' Loop ',I2,'  Guess=',1PE12.5,
     A '  Fit=',E12.5,' slope',E13.6)
      IF(C(KC).EQ.0.0) GO TO 9900
      IF(ABS(C(KC)).LT.RPASS(17)*COMPAR) GO TO 9900
C The ultimate precision must be obtained for all the functions.
      IF(KFLAG.GT.1) GO TO 9000
      IF(INIT(KARD).EQ.1) GO TO 9100
C Restart with zero except for the first round.
      F(KF) = 0.0
      RETURN
 9000 IF(ABS(TOP/R1(KARD)).GT.0.05) GO TO 9100
C For a result that is too close, move guess away and repeat.
      F(KF) = F(KF) - 10.*BOTTOM
      KFLAG = KFLAG - 1
      RETURN
 9100 G1(KARD) = F(KF)
      R1(KARD) = C(KC)
C Estimate the next function value according to the slope.
      TEMP = C(KC)/G2(KARD)
      F(KF) = F(KF) - TEMP
      IF(ABS(TEMP/(G1(KARD)+F(KF))) .GT. 1.E-5) RETURN
 9900 KFLAG = 0
C Exit if the accuracy is acquired.  KFLAG=0.
      RETURN
C********
C end MSEEK
C********
      END
