C  File rclib8.for                     30-DEC-1993
C
C  Contents:
C      SUBROUTINE DRDCV(Y,NAMES,IPASS,RPASS)
C      SUBROUTINE DRSET(Y,NAMES,IPASS,RPASS)
C      SUBROUTINE DHEAD(KEY,Y,NAMES,IPASS,RPASS)
C      SUBROUTINE STIFF(KEY,LABEL,ATS,HSTF,HSTFIN,KMIN,AK1,PEXP,IPASS,
C     A RPASS)
C      SUBROUTINE DTRITA(KTERMS,ATS,H,RCREAL,ORDER,ERR)
C      SUBROUTINE DFORTA(KTERMS,ATS,H,RCREAL,RCIMAG,ORDER,ERR)
C      SUBROUTINE DSEVTA(KTERMS,ATS,H,RADIUS,BX,RCIMAG,ORDER,ERR)
C      SUBROUTINE DTOPLN(KTERMS,ATS,H,NORDER,RADTL,mstiff)


      SUBROUTINE DRDCV(Y,NAMES,IPASS,RPASS)
C********
C  ATOMFT Subroutine-Library, version 3.11, completed (7/23/93).
C    Copyright (C) 1979-93, Y. F. Chang.
C********
      CHARACTER*6 NAMES,LABEL
      DIMENSION Y(1),NAMES(1),IPASS(20),RPASS(20)
      DOUBLE PRECISION Y,ENDSTA,HNEWIN,ATS(201),WORK(200),SIZE1,HOLD,
     A HSTF,HSTFIN,HNEXT,HMIN,TEMP1,TEMP2,TEMP3,RC,PEXP,AK1,AK2,RADMIN,
     A ADJT,PROD,HP,CSQ,HSQ,BX,RCREAL,RCI2,RCIMAG,THETA,ANGLE,PH,
     A ORDER,ERR
      DOUBLE PRECISION H,HNEW,ERRLIM,RPASS,START,ORDERC

C IPASS(16) = KFINAL
C IPASS(17) = KENOLD
C RPASS(11) = SAVEDP
C RPASS(12) = HNWOLD
C For HEAD
C IPASS(18) = KOUNT
C For HEAD and ZEROT
C RPASS(13) = TESTB
C RPASS(14) = TESTT
C For ZEROT
C RPASS(15) = SIZE
C RPASS(16) = old HNEW
C For RDCV, HEAD, and SEEK
C RPASS(17) = ERRTOP, DMINM
      NUMEQS = IPASS(1)
      LENSER = IPASS(2)
      LENVAR = IPASS(3)
      MPRINT = IPASS(4)
      LIST   = IPASS(5)
      MSTIFF = IPASS(6)
      KTRDCV = IPASS(8)
      INTSTP = IPASS(9)
      KTSTIF = IPASS(10)
      H      = RPASS(2)
      HNEW   = RPASS(3)
      ERRLIM = RPASS(4)
      START  = RPASS(8)
      ORDERC = RPASS(10)
      NTOP = LENVAR*NUMEQS + 1
      IF(KTRDCV.EQ.0) THEN
         WRITE(LIST,50)
   50 FORMAT(' KTRDCV must not be zero.')
         STOP
      ENDIF
C-------- Initialize
      ERROR = 1.E29
      RERTOL = 0.01
      HMIN = ERROR
      RADLOW = ERROR
      HSTF = ERROR
      IF(INTSTP .GT. 1) GO TO 100
      IF(MSTIFF .EQ. 1) THEN
         KTRDCV = NUMEQS
         IPASS(8) = NUMEQS
      ENDIF
      IF(MSTIFF.EQ.1 .AND. ERRLIM.LE.RPASS(17)) WRITE(LIST,51)
   51 FORMAT(' This solution will be limited by the machine roundoff.')
C Use ORDER to pass the stepsize back from ZEROT.
  100 IF(ORDERC .GT. 49.D0) THEN
         HNEW = DSIGN((ORDERC-50.D0),H)
         RPASS(3) = HNEW
      ENDIF
C Find the maximum series length with non-zero terms.
      IF(MSTIFF .LT. 20) GO TO 160
      IF(INTSTP .GT. 1) GO TO 151
      KTSTIF = 1
      IPASS(10) = 1
      ERRLIM = 1.D-6
      RPASS(4) = 1.D-6
      IF(LENVAR .GT. 34) GO TO 151
      WRITE(LIST,9)
    9 FORMAT(' You must not reduce LENVAR when solving a stiff problem')
      STOP
C------
C Make the largest top term unity for stiff.
C------
  151 SIZE1 = 1.D-32
C GFC mod in DRDCV 19-APR following Chang's instructions:
C    DRDCV
C    1. Add   'JFLAG = 0'  just after label 151.
      JFLAG = 0

      KONSTF = 1
      DO 154 II=1,NUMEQS
      IL = (II-1)*LENVAR
C Test for steady-state.
      IF(INTSTP.EQ.1 .OR. Y(LENVAR+IL).GT.2.7D0 .OR. DABS(Y(1+IL) -
     A Y(LENSER+1+IL)).GT.DABS(Y(1+IL))*RPASS(5)) KONSTF = 0
C Look for the largest top term.
      HOLD = DABS(Y(LENSER+IL))
      IF(SIZE1.LT.HOLD) SIZE1 = HOLD
  154 CONTINUE
      IF(KONSTF.EQ.0 .OR. MSTIFF.NE.20) GO TO 156
      WRITE(LIST,10)
   10 FORMAT(' The solution has reached steady-state.')
      STOP
  156 HOLD = (1.D0/SIZE1)**(1.D0/(LENSER-1))
      H = H*HOLD
      RPASS(2) = H
      SIZE1 = 1.D0
C Adjust all stiff series so that the largest top term is one.
      DO 158 K=2,LENSER
      SIZE1 = SIZE1*HOLD
      DO 157 II=1,NUMEQS
      IL = (II-1)*LENVAR
  157 Y(K+IL) = Y(K+IL)*SIZE1
  158 CONTINUE
C Find the maximum series length with non-zero terms.
  160 LENGTH = LENSER
      DO 166 II=1,NUMEQS
      IL = (II-1)*LENVAR
C------
C Bring back the singularity location along the real axis.
      Y(LENVAR-3+IL) = Y(LENVAR-6+IL)
C The purpose is to detect if the infinite-series method is valid.
C------
      LENY = Y(LENVAR+IL) + 0.3D0
      LENGTH = MIN0(LENGTH,LENY,200)
      DO 161 K=1,LENGTH
      LENSIN = LENGTH + 1 - K
      IF(Y(LENSIN+IL) .NE. 0.D0) GO TO 162
  161 CONTINUE
C Save it in Y(LENVAR).
  162 Y(LENVAR+IL) = LENSIN + 0.3D0
C Find the first non-zero term.
      DO 163 K=1,LENSIN
      IF(Y(K+IL) .NE. 0.D0) GO TO 164
  163 CONTINUE
  164 LOWEND = K
      IF(LENSIN .LT. LENGTH-5) THEN
C Mark those that are too short so to skip processing.
         IF(MSTIFF .EQ. 1) THEN
C This stops the infinite-series method.
            WRITE(LIST,1322)
 1322 FORMAT(' The infinite-series method cannot be applied here.')
            STOP
         ENDIF
         Y(LENVAR-6+IL) = ERROR
      ELSE
C Find the Rc size indicator, and save it in Y(LENVAR-6)
         TEMP1 = DMAX1(DABS(Y(LOWEND+IL)),DABS(Y(LOWEND+1+IL)),
     A     DABS(Y(LOWEND+2+IL)))
         TEMP2 = DSQRT(DABS(Y(LENSIN+IL)))*DSQRT(DABS(Y(LENSIN-1+IL)))
         IF(Y(LENSIN-1+IL) .EQ. 0.D0) TEMP2 = DABS(Y(LENSIN+IL))
         Y(LENVAR-6+IL) = (TEMP1/TEMP2)**(1.D0/LENSIN)
      ENDIF
  166 CONTINUE
      IF(MSTIFF .EQ. 1) GO TO 170
      KTOP = MIN0(KTRDCV,NUMEQS)
      DO 168 K=1,KTOP
      RADMIN = ERROR
      DO 167 II=1,NUMEQS
      IL = (II-1)*LENVAR
      TEMP1 = Y(LENVAR-6+IL)
C Pick out the smallest estimated Rc.
      IF(TEMP1.LT.0.D0 .OR. TEMP1.GE.RADMIN) GO TO 167
      RADMIN = TEMP1
      KMAX = II
  167 CONTINUE
C Mark the short Rc by its negative.
      IL = (KMAX-1)*LENVAR
      IF(Y(LENVAR-6+IL).GT.0.D0) Y(LENVAR-6+IL) = - Y(LENVAR-6+IL)
  168 CONTINUE
C Begin main loop.
  170 DO 590 II=1,NUMEQS
      IL = (II-1)*LENVAR
      LENSIN = Y(LENVAR+IL)
      NLABEL = Y(LENVAR-5+IL)
      LORDER = 1.D1*(Y(LENVAR-5+IL) - NLABEL)
      LABEL = NAMES(NLABEL)
      KFLAG = 0
      IF(MSTIFF .EQ. 1) GO TO 172
      IF(Y(LENVAR-6+IL).GT.0.D0 .AND. MSTIFF.LT.20) GO TO 580
  172 DO 180 K=1,LENSIN
  180 ATS(K) = Y(K+IL)
      IF(INTSTP .GT. 1) GO TO 210
      Y(LENVAR-1+IL) = 7.D0
      Y(LENVAR-2+IL) = 5.D2
      Y(LENVAR-4+IL) = -2.D0
      IF(KTSTIF .NE. 0) GO TO 210
C******** Test inputs
      KTSTIF = 1
      IPASS(10) = 1
      IF(LENSIN .GE. 15) GO TO 210
      WRITE(LIST,11) LENSIN
   11 FORMAT(' LENSER =',I4,' is too short.')
      STOP
  210 IF(MSTIFF .LT. 10) GO TO 220
      IF(MSTIFF.EQ.10.OR.MSTIFF.EQ.21.OR.INTSTP.GT.KTSTIF) GO TO 410
C********  Locate singularities.
C Bring back old RCIMAG; skip 7TA if 3TA (RCI2 = -1.0) is active.
C------
  220 RCI2 = Y(LENVAR-4+IL)
      IF(RCI2 .EQ. -1.D0) GO TO 310
C********  Complex singularities.
      KFLAG = 1
C------
C First, retreave a previous order; use it if good.
C------
  221 TEMP1 = Y(LENVAR-2+IL)
      IF(TEMP1 .LT. 8.D2) GO TO 225
      TEMP1 = TEMP1 - 1.D3
      GO TO 230
C------
C Second, call Seven-term Analysis for the pole position and order.
C------
  225 CALL DSEVTA(LENSIN,ATS,H,RC,BX,RCIMAG,ORDER,ERR)
      IF(ERR .GT. 1.D0) GO TO 310
      KOK = 0
C------
C Use the previous order if Rc error is high.
C------
      IF(ERR .LT. 3.D-2) GO TO 235
  230 IF(TEMP1 .GT. 9.D0) GO TO 310
      ORDER = TEMP1
      KOK = 1
      GO TO 240
C------
C Third, rationalize the order and account for the non-positive
C   integer orders.
C------
  235 KORD = 2.D0*DSIGN((DABS(ORDER) + 0.25D0),ORDER)
      ORDER = 0.5D0*KORD
      IF(MSTIFF .NE. 1) GO TO 240
      IF(KORD.EQ.0.OR.KORD.EQ.-2.OR.KORD.EQ.-4) ORDER = ORDER + 0.05D0
C------
C Fourth, perform Four-term Analysis for the pole position.
C********  Four-term Analysis
  240 CALL DFORTA(LENSIN,ATS,H,BX,RCIMAG,ORDER,ERR)
      IF(ERR .GT. 2.D-3) GO TO 310
      IF(ERR .LT. 1.D-4) Y(LENVAR-2+IL) = ORDER + 1.D3
      IF(KOK .EQ. 1) GO TO 250
      IF(ERR .GE. 1.D-3) THEN
         Y(LENVAR-2+IL) = ORDER
      ELSE
         Y(LENVAR-2+IL) = ORDER + 1.D3
      ENDIF
  250 RC = DSQRT(BX*BX + RCIMAG*RCIMAG)
      THETA = DACOS(BX/RC)
      IF(MSTIFF .NE. 1) GO TO 270
C------
C Infinite-series not valid if the pole moves without passing top-line.
C------
      TEMP1 = DSQRT(Y(LENVAR-3+IL)*Y(LENVAR-3+IL) + RCI2*RCI2)
      TEMP3 = DABS((TEMP1-RC)/RC)
      IF(RCI2.LT.-1.5D0 .OR. TEMP3.LT.6.D-2) GO TO 280
      WRITE(LIST,1321)2,TEMP3
C------
C Usual processing here.
C------
  270 IF(ERR .GT. RERTOL) GO TO 310
  280 Y(LENVAR-1+IL) = 7.D0
      Y(LENVAR-4+IL) = RCIMAG
      RCREAL = BX + START
      IF(MPRINT.GT.5) WRITE(LIST,12) INTSTP,LABEL,RC,ERR,NAMES(1),
     A START,RCREAL,RCIMAG,ORDER
   12 FORMAT(/' Step',I4,' for',A6,' by (7/4)TA, Rc =',1PD9.2,
     A '  error',E10.2/'   At',A6,9X,'RCREAL',6X,'RCIMAG',8X,'Order'/
     A 1X,1PD12.4,3X,2D12.4,3X,D10.3)
C GFC mod in DRDCV 19-APR following Chang's instructions:
C    DRDCV
C    2. Add   'JFLAG = 1'  just before the two  'GO TO 500'.
      JFLAG = 1

      GO TO 500
C********  Real singularity.
C Examine old RCIMAG; skip 3TA when 7TA (RCI2 = positive) is active.
C------
  310 IF(RCI2 .GT. 0.D0) GO TO 410
C********  Three-term Analysis
      CALL DTRITA(LENSIN,ATS,H,BX,ORDER,ERR)
      IF(ERR .GT. 1.D0) GO TO 410
      TEMP1 = DABS(ORDER) + 0.25D0
      IF(ERR.GT.RERTOL .OR. TEMP1.GT.2.7D0) GO TO 410
      IF(MSTIFF .NE. 1) GO TO 340
C------
C Rationalize the order.
C------
      KORD = 2.D0*DSIGN(TEMP1,ORDER)
      ORDER = 0.5D0*KORD
      KORD = 1 - KORD
      IF(KORD.GT.6 .OR. KORD.LT.1) KORD = 6
C------
C Infinite-series not valid if the pole moves without passing top-line.
C------
      TEMP3 = DMIN1(BX,BX+START)
      TEMP1 = DABS((Y(LENVAR-3+IL)-BX)/TEMP3)
      IF(RCI2.LT.-1.5D0 .OR. TEMP1.LT.1.D-2) GO TO 340
      WRITE(LIST,1321)1,TEMP1
 1321 FORMAT(' This solution may have errors. Check it.',I2,1PE12.4)
C********  Two-term Analysis
  340 BX = (LENSIN-2+ORDER)*ATS(LENSIN-1)/(ATS(LENSIN)*(LENSIN-1))
      TEMP1 = (LENSIN-3+ORDER)*ATS(LENSIN-2)/(ATS(LENSIN-1)*(LENSIN-2))
      ERR = ABS((BX - TEMP1)/BX)
      BX = H*BX
      IF(ERR .GT. RERTOL) GO TO 410
      IF(ERR.LT.1.D-6 .OR. Y(LENVAR-1+IL).LT.7.D0) GO TO 350
      IF(ERR .LT. RERTOL) Y(LENVAR-1+IL) = 6.D0
      GO TO 410
  350 Y(LENVAR-1+IL) = 3.D0
      Y(LENVAR-2+IL) = ORDER
      IF(ERR.GT.1.D-3 .AND. (H*BX).GT.0.D0) THEN
         IF(KFLAG .EQ. 0) GO TO 221
         GO TO 410
      ENDIF
      Y(LENVAR-4+IL) = -1.D0
      RCREAL = BX + START
      RC = DABS(BX)
      IF(MPRINT.GT.5) WRITE(LIST,13) INTSTP,LABEL,RC,ERR,NAMES(1),
     A START,RCREAL,ORDER
   13 FORMAT(/' Step',I4,' for',A6,' by (3/2)TA, Rc =',1PD9.2,
     A ' with error',E10.2/'   At',A6,8X,'Singularity',4X,'Order'/
     A 1X,1PD12.4,2X,E12.4,4X,E10.3)
      GO TO 500
C********  Top-line Analysis
  410 CALL DTOPLN(LENSIN,ATS,H,LORDER,RC,mstiff)
      Y(LENVAR-4+IL) = ATS(201)
C------
C Top-line passes the order unchanged.
C------
      IF(MPRINT.GT.5) WRITE(LIST,14) INTSTP,LABEL,NAMES(1),START,RC
   14 FORMAT(/' Step',I4,' for',A6,' estimated by TOP-LINE analysis'/
     A '   At',A6,8X,'Rc'/1X,1PD12.4,1X,D12.4)
  500 RPASS(10) = ORDER
      IF(MSTIFF.NE.1 .OR. Y(LENVAR-4+IL).LT.-1.D0) GO TO 560
      HSQ = H*H
      WORK(LENSIN) = ATS(LENSIN)
      IF(Y(LENVAR-4+IL) .GT. 0.D0) GO TO 540
C------
C Process the infinite-series method for real-axis singularity.
C------
      JLEN = LENSIN - 1
      GO TO (522,521,523,521,524,521), KORD
  521 MMTOP = JLEN
      GO TO 525
  522 MMTOP = JLEN - 1
      GO TO 525
  523 MMTOP = JLEN - 2
      GO TO 525
  524 MMTOP = JLEN - 3
C------ Generate the series for a real-axis pole backwards.
C            (m-1) p
C F(m-1)  = --------- F(m)
C           (m+s-2) h
C------
  525 DO 526 MM=1,MMTOP
      M = LENSIN + 1 - MM
      IXZ = M - 1
      TEMP1 = IXZ/(ORDER + IXZ - 1.D0)
C-----  TEMP1 = (m-1)/(m+s-2).
  526 WORK(IXZ) = TEMP1*WORK(M)*BX/H
      GO TO (532,531,533,531,534,531), KORD
C------ For all orders, except non-positive integers.
C f(x) = A/ r^s
C------
  531 AK1 = WORK(1)*DABS(BX)**ORDER
      GO TO 555
C------ for order=zero.
C f(x) = - A ln(p - x)
C f'(x) = A/ r  h
C------
  532 AK1 = WORK(2)*BX/H
      WORK(1) = - AK1*DLOG(DABS(BX))
      GO TO 555
C------ for order = -1.
C f(x) = A (p-x) ln(p - x)
C f'(x) = - A ln(p - x) - A    h
C f"(x) = A/ r  hsq/2
C------
  533 AK1 = 2.D0*WORK(3)*BX/HSQ
      TEMP1 = DLOG(DABS(BX))
      WORK(1) = AK1*BX*TEMP1
      WORK(2) = - AK1*H*(TEMP1 + 1.D0)
      GO TO 555
C------ for order = -2.
C                   2
C f(x) = - A/2 (p-x) ln(p - x)
C f'(x) = A (p-x) ln(p - x) + A (p-x)/2   h
C f"(x) = - A ln(p - x) - A 3/2   hsq/2
C f'"(x) = A/ r   hcube/6
C------
  534 AK1 = 6.D0*WORK(4)*BX/(H*HSQ)
      TEMP1 = DLOG(DABS(BX))
      WORK(1) = - 0.5D0*AK1*BX*BX*TEMP1
      WORK(2) = AK1*H*BX*(TEMP1 + 0.5D0)
      WORK(3) = - AK1*HSQ*(TEMP1 + 1.5D0)/2.D0
      GO TO 555
C------
C Process the infinite-series method for complex poles.
C------
  540 WORK(LENSIN-1) = ATS(LENSIN-1)
      JLEN = LENSIN - 2
C------ Generate the pole-series backwards.
C             m-2   [       2b      (m-1)      csq]
C F(m-2)  = ------- [F(m-1) ---  - -------F(m) ---]
C           (m+s-3) [        h     (m+s-2)     hsq]
C------
      CSQ = RC*RC/HSQ
      TEMP3 = 2.D0*BX/H
      DO 546 MM=1,JLEN
      M = LENSIN + 1 - MM
      IXZ = M - 1
      IXY = M - 2
      TEMP1 = IXY + ORDER
      TEMP2 = IXY/(TEMP1-1.D0)
      TEMP1 = IXZ/TEMP1
C-----  temp1 = (m-1)/(m+s-2), temp2 = (m-2)/(m+s-3).
  546 WORK(IXY) = TEMP2*(WORK(IXZ)*TEMP3 - TEMP1*WORK(M)*CSQ)
C------ For all orders, except non-positive integers.
C f(x) = 2 A cos(t s + ph)/ r^s
C f'(x) =  2 A s cos(t (s+1) + ph)/ r^(s+1)  h
C                     RC*WORK(2)
C ak1  = cot t - -------------------------
C                H*order*WORK(1)sin(theta)
C                ak1 - tan angle
C ph = arctan  -------------------
C              (1 + ak1 tan angle)
C------
      ANGLE = THETA*ORDER
      TEMP2 = RC**ORDER
      IF(DABS(WORK(1))*1.D10 .LT. DABS(WORK(2))) THEN
        PH = DATAN(1.D0/DTAN(ANGLE))
        AK1 = WORK(2)*TEMP2*RC/(2.D0*H*ORDER*DCOS(ANGLE+THETA+PH))
      ELSE
        TEMP1 = RC*WORK(2)/(H*ORDER*WORK(1))
        AK1 = (DCOS(THETA) - TEMP1)/DSIN(THETA)
        AK2 = (AK1 - DTAN(ANGLE))/(1.D0 + AK1*DTAN(ANGLE))
        PH = DATAN(AK2)
        AK1 = WORK(1)*TEMP2/(2.D0*DCOS(ANGLE+PH))
      ENDIF
      Y(LENSER-1+IL) = PH
C------
C Subtract the pole-function from ATS.
C------
  555 DO 556 M=1,JLEN
      WORK(M) = ATS(M) - WORK(M)
C------
C This is the de-poled series; store it.
C------
  556 Y(M+IL) = WORK(M)
C------
C The previous analyses were based on the assumption that the highest
C   order terms have no accuracy at all.
C Or rather, the last term counted is assumed to be equal to the missing
C   part of the series.
C
C For infinite-series calculation, there is nothing missing.
C The terms to infinity are accurate to the indicated error of the
C   pole-function.
C So, I can reduce the accuracy requirement by the pole-function error.
C------
      ERR = DMAX1(ERR,RPASS(17))
      HNEWIN = RC*(ERRLIM/ERR)**(1.D0/(LENSIN-LORDER))
      IF(Y(LENVAR-4+IL).LT.0.D0 .AND. HNEWIN.GT.RC) HNEWIN = RC
      LENSIN = JLEN
C------
C There are two storage spaces for the passing of constants.
C------
      Y(LENSER+IL) = AK1
      Y(LENVAR+IL) = LENSIN + 0.3D0
      Y(LENVAR-3+IL) = BX
      HMIN = DMIN1(HNEWIN,HMIN)
      IF(INTSTP .GT. 1) HMIN = DMIN1(HMIN,2.D0*DABS(HNEW))
      GO TO 570
C------
C This is the usual constant-order method.
C------
  560 TEMP1 = 1.D0
      IF(Y(LENVAR-4+IL) .GT. -2.D0)
     A TEMP1 = DMAX1(1.D0,LENSIN**(ORDER-2.D0+LORDER))
      IF(Y(LENVAR-4+IL) .LT. -1.D1) THEN
        HNEWIN = RC*(ERRLIM/TEMP1)**(1.D0/(8-LORDER))
        Y(LENVAR+IL) = 8.3D0
        Y(LENVAR-3+IL) = BX
        HMIN = DMIN1(HNEWIN,HMIN)
      ELSE
        HNEWIN = RC*(ERRLIM/TEMP1)**(1.D0/(LENSIN-LORDER))
        Y(LENVAR+IL) = LENSIN + 0.3D0
        Y(LENVAR-3+IL) = BX
        HMIN = DMIN1(HNEWIN,HMIN)
        IF(INTSTP .GT. 1) HMIN = DMIN1(HMIN,2.D0*DABS(HNEW))
      ENDIF
  570 IF(RADLOW .LE. RC) GO TO 580
C------
C Select the lowest radius variable.
C------
      RADLOW = RC
      IPASS(15) = II
  580 IF(MPRINT .LT. 9) GO TO 590
      ADJT = RC/H
      IF(MPRINT .EQ. 10) ADJT = 1.D0
      HP = H*ADJT
      WRITE(LIST,16) LABEL,START,HP
   16 FORMAT(/' series for',A6,', at',1PE12.4,', Rc or h =',E10.2)
      PROD = 1.D0
      DO 582 J=1,LENSIN
      WORK(J) = PROD*Y(J+IL)
  582 PROD = PROD*ADJT
      LP = LENSIN/5
      NP = LENSIN - 5*LP
      MP = LP + 1
      M = LENSIN - LP*(4 - NP)
      DO 585 I=1,LP
      IF(M .LT. LENSIN) GO TO 583
      IF(NP .EQ. 4) LP = MP
      WRITE(LIST,17)(K,WORK(K),K=I,LENSIN,LP)
      GO TO 585
  583 IP = I + M
      WRITE(LIST,17)(K,WORK(K),K=I,M,MP),(L,WORK(L),L=IP,LENSIN,LP)
  585 CONTINUE
      IF(NP.GT.0) WRITE(LIST,17)(K,WORK(K),K=MP,M,MP)
   17 FORMAT(1X,I4,1PE10.3,I4,E10.3,I4,E10.3,I4,E10.3,I4,E10.3)
  590 CONTINUE
      HNEXT = HMIN
      IF(INTSTP.EQ.1 .OR. Y(LENVAR-4+IL).LT.-1.D1) GO TO 591
      RPASS(1) = 2.D0*RPASS(1)
      IF(RPASS(1) .LT. RADLOW) GO TO 592
  591 RPASS(1) = RADLOW
  592 IF(MSTIFF.LT.20) GO TO 2400
      IF(JFLAG.EQ.1 .AND. INTSTP.LE.KTSTIF) GO TO 2150
C********  STIFF
      KSTIF = 0
      DO 990 II=1,NUMEQS
      IL = (II-1)*LENVAR
      DO 611 K=1,LENSER
  611 ATS(K) = Y(K+IL)
      Y(LENSER+3+IL) = LENSIN + 0.3
      NLABEL = Y(LENVAR-5+IL)
      LABEL = NAMES(NLABEL)
      CALL STIFF(KEY,LABEL,ATS,HSTF,HSTFIN,KMIN,AK1,PEXP,IPASS,RPASS)
      GO TO (910,930,950), KEY
  910 Y(LENSER+2+IL) = HSTFIN
      IF(MPRINT.GT.4) WRITE(LIST,18) HSTFIN,HSTF
   18 FORMAT(' Stiff step =',1PD10.3,', min step =',D10.3)
      IF(HSTF .GT. HMIN*4.D0) GO TO 940
  930 KSTIF = 1
      GO TO 990
C--------
C Store the LENGTH, the first exponential term, and the expo-coef.
C--------
  940 Y(LENVAR+IL) = KMIN + 0.3D0
      Y(LENVAR-1+IL) = AK1
      Y(LENVAR-2+IL) = PEXP
      GO TO 960
C------
C Polynomial series.
C------
  950 Y(LENVAR+IL) = 5.3D0
      Y(LENVAR-1+IL) = 0.D0
      Y(LENVAR-2+IL) = 0.D0
      Y(LENSER+2+IL) = 0.D0
  960 KTOP = LENSER-2
C------
C Save the stiff information in the top half array.
C------
      DO 970 K=1,KTOP
  970 Y(32-K+IL) = ATS(K)
  990 CONTINUE
      IF(KSTIF.EQ.1) GO TO 2150
      HNEXT = HSTF
      RPASS(1) = DABS(H)
      KOVER = 1
      IPASS(15) = 1
      KTOP = LENSER - 2
      DO 2143 II=1,NUMEQS
      IL = (II-1)*LENVAR
      DO 2141 K=1,KTOP
 2141 Y(K+IL) = Y(32-K+IL)
      Y(LENSER+IL) = 0.0
 2143 Y(LENSER-1+IL) = 0.0
      GO TO 2400
 2150 IF(MPRINT.GT.3) WRITE(LIST,19) KTSTIF
   19 FORMAT(' Stiff solution skipped, non-stiff step #',I7)
      KTSTIF = KTSTIF + 1
      IPASS(10) = KTSTIF
C--------
C DO normal calculations if stiff is not working.
C--------
      HNEXT = HMIN
      DO 2155 II=1,NUMEQS
      IL = (II-1)*LENVAR
      IF(Y(LENVAR-1+IL).EQ.0.D0 .AND. Y(LENVAR+IL).GT.6.) GO TO 2155
      Y(LENVAR+IL) = Y(LENSER+3+IL)
      Y(LENVAR-1+IL) = 0
      Y(LENVAR-2+IL) = 0
 2155 CONTINUE
C******** Round HNEW down
 2400 HNEW = DSIGN(HNEXT,H)
      RPASS(3) = HNEW
      HNEWSP = HNEW
      NSHIFT = 30000.0 + ALOG10(ABS(HNEWSP))
      NSHIFT = 30003 - NSHIFT
      TEMP2 = 1.D1**NSHIFT
      TEMP1 = (START + HNEW)*TEMP2 + 0.0005D0
c the important barrier is TEMP1 and not TEMP2.
      IF(TEMP1 .GT. 2.D10) GO TO 2401
      IF(TEMP1 .GT. 2.D9) THEN
        TEMP1 = TEMP1*0.1D0
        TEMP2 = TEMP2*0.1D0
      ENDIF
      NEXT = TEMP1
      HNEW = NEXT/TEMP2 - START
      RPASS(3) = HNEW
      IF(HNEW .NE. 0.D0) GO TO 2404
 2401 WRITE(LIST,2402)
 2402 FORMAT(' **** The solution is hard against a singularity.  STOP!')
      STOP
C******** Handle reaching end of interval
 2404 IPASS(13) = 1
      RPASS(16) = HNEW
      IF(Y(NTOP) .NE. 0.D0) THEN
        IF(DABS(HNEW/Y(NTOP)) .GT. 1.0D0) THEN
          HNEW = Y(NTOP)
          Y(NTOP) = 0.D0
          RPASS(3) = HNEW
        ENDIF
      ENDIF
      ENDSTA = RPASS(9) - START
      IF(HNEW*HNEW .LT. ENDSTA*ENDSTA) RETURN
      RPASS(3) = 0.9999999D0*ENDSTA
      KOUNT = KTSTIF - 1
      IF(MSTIFF.GT.19) WRITE(LIST,21) KOUNT
   21 FORMAT(/' In the stiff solution, number of non-stiff steps =',I7)
      IPASS(13) = 4
      RETURN
C********
C end DRDCV
C********
      END
      SUBROUTINE DRSET(Y,NAMES,IPASS,RPASS)
C**********
C  ATOMFT Subroutine-Library, version 3.11, completed (7/23/93).
C    Copyright (C) 1979-93, Y. F. Chang.
C**********
      CHARACTER*6 NAMES(1)
      DIMENSION Y(1),IPASS(20),RPASS(20)
      DOUBLE PRECISION Y,DUMMY,RATIO,SUM,DLOOP,XPTSTA,CONST,YNEXT(8),
     A XSER(8),CSQ,TEMP1,TEMP2,TEMP3,XSTEP,BX,ORDER,RC,THETA,
     A ANGLE,CONSTA,PH,HNEWIN,H,HNEW,ERRLIM,ADJSTF,XPRINT,
     A DLTXPT,RPASS,START,END

C      SAVE KFINAL,KENOLD,SAVEDP,HNWOLD
C IPASS(16) = KFINAL
C IPASS(17) = KENOLD
C RPASS(11) = SAVEDP
C RPASS(12) = HNWOLD
      NUMEQS = IPASS(1)
      LENSER = IPASS(2)
      LENVAR = IPASS(3)
      MPRINT = IPASS(4)
      LIST   = IPASS(5)
      MSTIFF = IPASS(6)
      INTSTP = IPASS(9)
      KENDFG = IPASS(13)
      KOVER  = IPASS(15)
      H      = RPASS(2)
      HNEW   = RPASS(3)
      ERRLIM = RPASS(4)
      ADJSTF = RPASS(5)
      XPRINT = RPASS(6)
      DLTXPT = RPASS(7)
      START  = RPASS(8)
      END    = RPASS(9)
      NTOP = LENVAR*NUMEQS + 1
      IF(KOVER .GT. 0) GO TO 5000
      JUMP = - KOVER
      GO TO (101,201,301,5000), JUMP
C------
C This is the first call from ZEROT.
C------
  101 DO 150 II=1,NUMEQS
      IL = (II-1)*LENVAR
      NLABEL = Y(LENVAR-5+IL)
      LORDER = 1.D1*(Y(LENVAR-5+IL) - NLABEL)
C------
C Cancel the storing done previously.
C------
      IPRINT = MAX0(1,LORDER)
      DO 140 I=1,IPRINT
      LMI = LENSER + I
      DUMMY = Y(LMI+IL)
      Y(LMI+IL) = Y(I+IL)
  140 Y(I+IL) = DUMMY
  150 CONTINUE
      RETURN
C------
C This is the second call from ZEROT.
C------
  201 DO 250 II=1,NUMEQS
      IL = (II-1)*LENVAR
      NLABEL = Y(LENVAR-5+IL)
      LORDER = 1.D1*(Y(LENVAR-5+IL) - NLABEL)
C------
C Restore the results of analytic continuation.
C------
      IPRINT = MAX0(1,LORDER)
      DO 240 I=1,IPRINT
      LMI = LENSER + I
      DUMMY = Y(I+IL)
      Y(I+IL) = Y(LMI+IL)
  240 Y(LMI+IL) = DUMMY
  250 CONTINUE
      RETURN
C------
C This is the third call from ZEROT that requires printing.
C------
  301 RATIO  = HNEW/H
      IF(KENDFG.NE.3) GO TO 302
      RPASS(11) = XPRINT
      IF(DABS(HNEW).GT.DABS(XPRINT-START)) RPASS(11) = RPASS(11)+DLTXPT
  302 KENDFG = 1
      IPASS(13) = 1
      HNEWIN = HNEW
      XPRINT = START + HNEW
      RPASS(6) = XPRINT
      GO TO 5501
C------
C Start of the normal procedures.
C------
 5000 KOUNT = 0
      IF(INTSTP.EQ.1 .AND. KENDFG.NE.3) RPASS(11) = XPRINT
      IF(KENDFG.NE.3 .AND. DLTXPT.NE.0.D0) THEN
         XPRINT = RPASS(11)
         RPASS(6) = RPASS(11)
      ENDIF
      CONST = 1.D-3*ADJSTF
      CONST = DMAX1(CONST,1.D-6)
      NOPRT = 0
      IF(KENDFG.EQ.3) THEN
         XPRINT = XPRINT + DLTXPT
         RPASS(6) = XPRINT
      ENDIF
      IF(KENDFG.EQ.4) IPASS(16) = 1
C******** User demands print.
      XPTSTA = XPRINT - START
      IF(DLTXPT.EQ.(0.D0) .OR. MPRINT.LT.1 .OR.
     +  (HNEW*HNEW.LT.XPTSTA*XPTSTA)) GO TO 5200
      RATIO = XPTSTA/H
      HNEWIN = XPTSTA
      KENDFG = 3
      IPASS(13) = 3
      GO TO 5501
 5200 IF(IPASS(16).EQ.0) GO TO 5300
      IPASS(16) = 0
      KENDFG = 2
      IPASS(13) = 2
      RATIO = (END - START)/H
      XPRINT = END
      RPASS(6) = XPRINT
      HNEW = XPRINT - START
      RPASS(3) = HNEW
      HNEWIN = HNEW
      GO TO 5501
 5300 RATIO  = HNEW/H
      KOUNT = KOUNT + 1
      HNEWIN = HNEW
      KENDFG = 1
      IPASS(13) = 1
      RPASS(11) = XPRINT
      XPRINT = START + HNEW
      RPASS(6) = XPRINT
C------
C This is the re-entry from ZEROT.
C------
 5501 TEMP3 = RPASS(13)
      LENSIN = LENSER
C******** Summation and store in WORKAR.  Analytic continuation.
      DO 8200 II=1,NUMEQS
      IL = (II-1)*LENVAR
      NLABEL = Y(LENVAR-5+IL)
      LORDER = 1.D1*(Y(LENVAR-5+IL) - NLABEL)
      KTOP = Y(LENVAR+IL)
      DLOOP = 1.D0
      IF(Y(LENVAR-4+IL).LT.-1.D0 .OR. MSTIFF.NE.1) THEN
         IF(LORDER .GT. 2) GO TO 8031
         IF(LORDER .EQ. 2) GO TO 8021
         YNEXT(1) = Y(1+IL)
         IF(LORDER .EQ. 0) GO TO 8034
         DO 8012 J=2,KTOP
         DLOOP = DLOOP*RATIO
         TEMP1 = DLOOP*Y(J+IL)
 8012    YNEXT(1) = YNEXT(1) + TEMP1
         TEMP1 = 2.D0*TEMP1
c Magnitude of remainder.
         IF(YNEXT(1).NE.0.D0) TEMP3 = DMAX1(TEMP3,DABS(TEMP1/YNEXT(1)))
         GO TO 8034
 8021    YNEXT(1) = Y(1+IL)
         YNEXT(2) = 0.D0
         DO 8022 J=2,KTOP
         YNEXT(2) = YNEXT(2) + DLOOP*Y(J+IL)*((J-1)/H)
         DLOOP = DLOOP*RATIO
         TEMP1 = DLOOP*Y(J+IL)
 8022    YNEXT(1) = YNEXT(1) + TEMP1
         TEMP1 = 2.D0*TEMP1
c Magnitude of remainder.
         IF(YNEXT(1).NE.0.D0) TEMP3 = DMAX1(TEMP3,DABS(TEMP1/YNEXT(1)))
         GO TO 8034
 8031    DUMMY = 1.D0
         DO 8032 I=1,LORDER
         IBOT = I + 1
         DLOOP = 1.D0
         YNEXT(I) = Y(I+IL)*DUMMY
         DO 8030 J=IBOT,KTOP
         DLOOP = DLOOP*RATIO*(J-1)/(J-IBOT+1)
         TEMP1 = DLOOP*Y(J+IL)*DUMMY
 8030    YNEXT(I) = YNEXT(I) + TEMP1
 8032    DUMMY = DUMMY*I/H
         TEMP1 = 2.D0*TEMP1
c Magnitude of remainder.
         IF(YNEXT(1).NE.0.D0) TEMP3 = DMAX1(TEMP3,DABS(TEMP1/YNEXT(1)))
 8034    CONTINUE
C--------
      ELSE
         XSTEP = RATIO*H
         ORDER = Y(LENVAR-2+IL)
         IF(ORDER .GT. 501.D0) ORDER = ORDER - 1.D3
         TEMP1 = DABS(ORDER) + 0.1D0
         KORD = 2.D0*DSIGN(TEMP1,ORDER)
         KORD = 1 - KORD
         IF(KORD.GT.6 .OR. KORD.LT.1) KORD = 6
         BX = Y(LENVAR-3+IL)
         CONSTA = Y(LENSER+IL)
         TEMP1 = BX - XSTEP
         IF(Y(LENVAR-4+IL) .LT. 0.D0) THEN
            GO TO (522,521,523,521,524,521), KORD
C------ For all orders, except non-positive integers.
C            A
C f(x) =  ---------
C         (p - x)^s
C------
  521       XSER(1) = CONSTA/(DABS(TEMP1)**ORDER)
            KBOT = 2
            GO TO 525
C------For order=zero.
C                                   A
C f(x) = - A ln|p - x|, f'(x) =  -------
C                                (p - x)
C------
  522       XSER(1) = - CONSTA*DLOG(DABS(TEMP1))
            XSER(2) = CONSTA/TEMP1
            KBOT = 3
            GO TO 525
C------ for order = -1.
C f(x) = A (p-x) ln(p - x),  f'(x) = - A ln(p - x) - A
C
C f"(x) = A/(p - x)
C------
  523       TEMP2 = DLOG(DABS(TEMP1))
            XSER(1) = CONSTA*TEMP1*TEMP2
            XSER(2) = - CONSTA*(TEMP2 + 1.D0)
            XSER(3) = CONSTA/TEMP1
            KBOT = 4
            GO TO 525
C------ for order = -2.
C                   2
C f(x) = - A/2 (p-x) ln(p - x), f'(x) = A (p-x) ln(p - x) + A (p-x)/2
C
C f"(x) = - A ln(p - x) - A 3/2,  f'"(x) = A/(p - x)
C------
  524       TEMP2 = DLOG(DABS(TEMP1))
            XSER(1) = - 0.5D0*CONSTA*TEMP1*TEMP1*TEMP2
            XSER(2) = CONSTA*TEMP1*(TEMP2 + 0.5D0)
            XSER(3) = - CONSTA*(TEMP2 + 1.5D0)
            XSER(4) = CONSTA/TEMP1
            KBOT = 5
  525       IF((KBOT-1) .LT. LORDER) THEN
C------ Generate additional terms if needed.
C        (k+s-2)
C f(k) = ------- f(k-1)
C           p
C------
               DO 526 K=KBOT,LORDER
               TEMP2 = K + ORDER - 2.D0
  526          XSER(K) = XSER(K-1)*TEMP2/TEMP1
            ENDIF
         ELSE
C------
C This is for complex poles.
C------
            CSQ = TEMP1*TEMP1 + Y(LENVAR-4+IL)*Y(LENVAR-4+IL)
            RC = DSQRT(CSQ)
            THETA = DACOS(TEMP1/RC)
            PH = Y(LENSER-1+IL)
C------ For all orders, except non-positive integers.
C f(x) =  2 A cos(t s + ph)/ r^s
C
C f'(x) = 2 A s cos(t (s+1) + ph)/ r^(s+1)
C------
            ANGLE = THETA*ORDER + PH
            TEMP2 = RC**ORDER
            TEMP3 = 2.D0*CONSTA/TEMP2
            XSER(1) = TEMP3*DCOS(ANGLE)
            XSER(2) = TEMP3*ORDER*DCOS(ANGLE+THETA)/RC
C------ Generate additional terms if needed.
C        (k+s-2)
C f(k) = ------- [f(k-1) 2b  -  f(k-2) (k+s-3)]
C          csq
C------
            IF(LORDER .GT. 2) THEN
               DO 546 K=3,LORDER
               TEMP2 = K + ORDER - 2.D0
               TEMP3 = TEMP2 - 1.D0
  546          XSER(K) = TEMP2/CSQ*(2.D0*BX*XSER(K-1) - TEMP3*XSER(K-2))
            ENDIF
         ENDIF
C------
C Bring back and sum the de-poled series.
C------
         IF(LORDER .GT. 2) GO TO 8131
         IF(LORDER .EQ. 2) GO TO 8121
 8111    YNEXT(1) = Y(1+IL) + XSER(1)
         DO 8112 J=2,KTOP
         DLOOP = DLOOP*RATIO
 8112    YNEXT(1) = YNEXT(1) + DLOOP*Y(J+IL)
         GO TO 8134
 8121    YNEXT(1) = Y(1+IL) + XSER(1)
         YNEXT(2) = XSER(2)
         DO 8122 J=2,KTOP
         YNEXT(2) = YNEXT(2) + DLOOP*Y(J+IL)*((J-1)/h)
         DLOOP = DLOOP*RATIO
 8122    YNEXT(1) = YNEXT(1) + DLOOP*Y(J+IL)
         GO TO 8134
 8131    DUMMY = 1.D0
         DO 8132 I=1,LORDER
         IBOT = I + 1
         DLOOP = 1.D0
         YNEXT(I) = Y(I+IL)*DUMMY + XSER(I)
         DO 8130 J=IBOT,KTOP
         DLOOP = DLOOP*RATIO*(J-1)/(J-IBOT+1)
 8130    YNEXT(I) = YNEXT(I) + DLOOP*Y(J+IL)*DUMMY
 8132    DUMMY = DUMMY*I/H
 8134    CONTINUE
      ENDIF
      IF(MSTIFF.LT.20) GO TO 8044
C--------
C Add the exponential factor for stiff into YNEXT.
C--------
      IF(Y(LENVAR-1+IL).EQ.0.D0) GO TO 8044
      DUMMY = RATIO*H
      DLOOP = Y(LENVAR-2+IL)*DUMMY
      IF((-DLOOP).GT.2.D2) GO TO 8042
      SUM = Y(LENVAR-1+IL)*DEXP(DLOOP)
      YNEXT(1) = YNEXT(1) + SUM
 8042 IF(INTSTP.EQ.1 .OR. MSTIFF.NE.20) GO TO 8044
C------
C Constancy test
C------
      SUM = Y(1+IL) + Y(LENVAR-1+IL)
      IF(DABS((YNEXT(1)-SUM)/YNEXT(1)).GT.CONST .OR.
     A DABS(Y(LENSER+2+IL)/(1.2D0*HNEW)).GT.1.D0) GO TO 8044
      WRITE(LIST,1650)NAMES(NLABEL),YNEXT(1),NAMES(NLABEL)
 1650 FORMAT(' The function',A6,' is constant at',1PD14.6/
     A '   Look for a steady-state solution.'/
     A '  Set all derivatives to zero, use the value of',A6,' given,'/
     A '    and solve for the other functions.'/
     A '   Then, re-submit to ATOMFT.'/
     A '   Use MSTIFF=21 or 22, DO not use MSTIFF=20.')
      STOP
 8044 IPRINT = MAX0(1,LORDER)
      IF(KENDFG.EQ.1 .AND. MPRINT.LT.4) GO TO 8050
C------
C Store the YNEXT into the top part of dependent variables.
C------
      DO 8047 I=1,IPRINT
      LMI = LENSER + I
 8047 Y(LMI+IL) = YNEXT(I)
      IF(KENDFG .EQ. 3) GO TO 8200
C******** Place the analytic continuation back into Y(1).
 8050 DO 8080 I=1,IPRINT
      LMI = LENSER + I
      Y(LMI+IL) = Y(I+IL)
 8080 Y(I+IL) = YNEXT(I)
C------
C Update the singularity location along the real axis.
C The purpose is to detect if the infinite-series method is valid.
C------
      Y(LENVAR-6+IL) = Y(LENVAR-3+IL) - HNEW
      LENSIN = MIN0(KTOP,LENSIN)
 8200 CONTINUE
C Infinite-series cannot correct for a large remainder.
      IF(MSTIFF.EQ.1 .OR. MSTIFF.GT.19 .OR. KOVER.LT.0) GO TO 8400
      IF(TEMP3.LT.ERRLIM .OR. KENDFG.EQ.2) GO TO 8400
      IF(MPRINT .GT. 5) WRITE(LIST,8202)TEMP3,ERRLIM
 8202 FORMAT(' Adjusting the stepsize in DRSET.'/
     A ' The remainder vs error limit',1P2D12.4)
      IF(KOUNT .GT. 1) GO TO 8400
      HNEW = HNEWIN/(2.D0*TEMP3/ERRLIM)**(1.D0/(LENSIN-1))
      RPASS(3) = HNEW
      IF(IPASS(17).EQ.3 .AND. DABS(HNEW).LT.DABS(RPASS(12))) THEN
         HNEW = RPASS(12)
         RPASS(3) = HNEW
         NOPRT = 1
      ENDIF
      IF(KENDFG .EQ. 3) GO TO 5300
      XPRINT = RPASS(11)
      RPASS(6) = XPRINT
      DO 8300 II=1,NUMEQS
      IL = (II-1)*LENVAR
      NLABEL = Y(LENVAR-5+IL)
      LORDER = 1.D1*(Y(LENVAR-5+IL) - NLABEL)
      IPRINT = MAX0(1,LORDER)
      DO 8201 I=1,IPRINT
      LMI = LENSER + I
 8201 Y(I+IL) = Y(LMI+IL)
 8300 CONTINUE
      GO TO 5300
 8400 RPASS(12) = HNEWIN
      IPASS(17) = KENDFG
      IF(NOPRT .EQ. 1) RETURN
      IF(KENDFG.EQ.1 .AND. MPRINT.LT.4) RETURN
      IF((KENDFG.EQ.3.AND.MPRINT.EQ.1) .OR. MPRINT.EQ.0) RETURN
      DO 8500 II=1,NUMEQS
      IL = (II-1)*LENVAR
      NLABEL = Y(LENVAR-5+IL)
      LORDER = 1.D1*(Y(LENVAR-5+IL) - NLABEL)
C******** Print at user's request
      IF(II .EQ. 1) WRITE(LIST,1010) INTSTP,NAMES(1),XPRINT
 1010 FORMAT(/5X,'Step number',I6,' at',A6,' = ',1PD15.8)
      IPRINT = MAX0(1,LORDER)
      IF(KENDFG .EQ. 3) THEN
         WRITE(LIST,4) NAMES(NLABEL),(Y(K+IL),K=LENSER+1,LENSER+IPRINT)
      ELSE
         WRITE(LIST,4) NAMES(NLABEL),(Y(K+IL),K=1,IPRINT)
      ENDIF
    4 FORMAT(1X,A6,(1P3D22.14))
 8500 CONTINUE
      RETURN
C********
C end DRSET
C********
      END
      SUBROUTINE DHEAD(KEY,Y,NAMES,IPASS,RPASS)
C********
C  ATOMFT Subroutine-Library, version 3.11, completed (5/31/93).
C    Copyright (C) 1979-93, Y. F. Chang.
C********
      DIMENSION IPASS(20),RPASS(20),Y(1)
      CHARACTER*6 NAMES(1)
      DOUBLE PRECISION Y,TMP,H,HNEW,RPASS,TOP,DLOOP
      SAVE NOPRT
      DATA NOPRT/1/
C IPASS(18) = KOUNT
C RPASS(13) = TESTB
C RPASS(14) = TESTT
      NUMEQS = IPASS(1)
      LENSER = IPASS(2)
      LENVAR = IPASS(3)
      MPRINT = IPASS(4)
      LIST   = IPASS(5)
      MSTIFF = IPASS(6)
      INTSTP = IPASS(9)
      KTSTIF = IPASS(10)
      GO TO (1000,2000,3000,4000,5000), KEY
 1000 IF(NOPRT .EQ. 0) GO TO 1010
      NOPRT = 0
      IF(MSTIFF.EQ.1) WRITE(LIST,17)
   17 FORMAT(' Results calculated by an infinite-series method.'/
     A       ' ------------------------------------------------')
C for independent variable name.
 1010 IF(MPRINT.EQ.0) RETURN
      WRITE(LIST,11) NAMES(1),RPASS(8)
   11 FORMAT(/5X,'Step number     0 at',A6,' = ',1PD15.8)
      DO 1100 II=1,NUMEQS
      IL = (II-1)*LENVAR
      NLABEL = Y(LENVAR-5+IL)
      LORDER = 1.D1*(Y(LENVAR-5+IL) - NLABEL)
      IPRINT = MAX0(1,LORDER)
      WRITE(LIST,12) NAMES(NLABEL),(Y(I+IL),I=1,IPRINT)
   12 FORMAT(1X,A6,(1P3D22.14))
 1100 CONTINUE
      RETURN
 2000 IF(MSTIFF.GE.20 .AND. KTSTIF.GT.0) GO TO 2500
      IL = (IPASS(15)-1)*LENVAR
      LENSIN = Y(LENVAR+IL) + 0.1
      TMP = DABS(Y(LENSIN+IL))
      IF(KTSTIF.GT.1 .AND. TMP.LT.1.0) GO TO 2500
      IF(TMP.EQ.0.D0) GO TO 2500
      IF(TMP.LT.RPASS(14) .AND. TMP.GT.RPASS(13)) GO TO 2500
      IPASS(18) = IPASS(18) + 1
      IF(IPASS(18) .LT. 5) GO TO 2200
      WRITE(LIST,16) NAMES(1),RPASS(8)
   16 FORMAT(1X,A6,1PD8.1,', the trial H adjustment needs some help.')
      STOP
 2200 H = RPASS(2)
      TOP = 0.6D0
      IF(TMP .GT. 1.D0) TOP = 1.2D0
      HNEW = RPASS(2)*TMP**(TOP/(1-LENSIN))
      RPASS(2) = HNEW
      IF(MPRINT.GT.3) WRITE(LIST,13) NAMES(1),RPASS(8),HNEW,LENSIN
   13 FORMAT(1X,A6,1PD8.1,', H adjusted to',1PD12.5,' at term #',I4)
      DO 2300 II=1,NUMEQS
      IL = (II-1)*LENVAR
      NLABEL = Y(LENVAR-5+IL)
      LORDER = 1.D1*(Y(LENVAR-5+IL) - NLABEL)
      IF(LORDER .LT. 2) GO TO 2300
      TMP = H
      DLOOP = 1.D0
      DO 2250 K=2,LORDER
      Y(K+IL) = Y(K+IL)*DLOOP/TMP
      DLOOP = DLOOP*K
 2250 TMP = TMP*H
 2300 CONTINUE
      IPASS(7) = 0
      RETURN
 2500 IPASS(7) = 1
C Reset KOUNT to zero.
      IPASS(18) = 0
      RETURN
 3000 WRITE(LIST,14) INTSTP
   14 FORMAT(/5X,'The solution stopped normally after',I4,
     A ' steps as set by NSTEPS.')
      RETURN
 4000 WRITE(LIST,15) RPASS(3),RPASS(9)
   15 FORMAT(/' The ODE-generating portion of the subroutine for your'/
     A ' User-Defined function has failed to converge.  Your initial'/
     B ' point',1PD9.2,' is too far away from the desired'/
     C ' point',D12.4,'  This solution is aborted.')
      STOP
 5000 IF(NOPRT .EQ. 0) GO TO 5010
      WRITE(LIST,10)IPASS(13),IPASS(7)
   10 FORMAT(' ATOMFT  ver. ',I1,'.',I1,'1, copyright (C) 1979-93, Y. F.
     A Chang; Solution results.'/' ******')
 5010 RPASS(17) = 1.D1**(-IPASS(12))
      IPASS(18) = 0
      KXPDBL = IPASS(11)/10000
      KEXP = KXPDBL*7/10
      RPASS(13) = 1.D-1**(KEXP)
      RPASS(14) = 1.D1**(KEXP)
      RPASS(15) = 1.0
      DO 5100 II=1,NUMEQS
      IL = (II-1)*LENVAR
      DO 5100 K=1,LENSER
      Y(K+IL) = 0.D0
 5100 CONTINUE
      NTOP = LENVAR*NUMEQS + 1
      Y(NTOP) = 0.D0
      IPASS(16) = 0
      IPASS(17) = 0
      RPASS(12) = 0.0
      RETURN
C********
C end DHEAD
C********
      END
      SUBROUTINE STIFF(KEY,LABEL,ATS,HSTF,HSTFIN,KMIN,AK1,PEXP,IPASS,
     A RPASS)
C********
C  ATOMFT Subroutine-Library, version 3.11, completed (1/31/93).
C    Copyright (C) 1979-93, Y. F. Chang.
C********
      CHARACTER*6 LABEL
      DIMENSION IPASS(20),RPASS(20)
      DOUBLE PRECISION ATS(50),WORK(50),SIGMA(30),EPSLON(30),DELTA(30),
     A DEL(30),ELP(30),EXPO(30),ERRC(30),ERRL(30),ERRR(30),SIZE,HOLD,
     A TEMP1,TEMP2,TEMP3,TEMP4,TEMP5,TEMP6,TEMP7,TEMP8,PEXP,PDEL,PEPS,
     A PSIG,AK1,HSTF,HSTFIN,HFOUR,H,RPASS
      LENSER = IPASS(2)
      MPRINT = IPASS(4)
      LIST   = IPASS(5)
      MSTIFF = IPASS(6)
      H      = RPASS(2)
C------
C Calculation of exponential coefficient.
C------
      IF(MSTIFF.LT.32) GO TO 700
      KPOWER = MSTIFF - 30
      WRITE(LIST,1611)IPASS(9),LABEL,RPASS(8),H,KPOWER
 1611 FORMAT(/' Step',I4,', for',A6,', at',1PD12.4,', h=',D10.3/
     A '  #    Lambda     error    For stiff-order =',I2)
 1615 FORMAT(' ',I2,1PD13.5,D8.1)
  639 TEMP3 = 3.146D0
      HFOUR = H**KPOWER
      IBOT = KPOWER + 1
      DO 650 I=IBOT,LENSER
      TEMP1 = 1.D0
      DO 640 K=1,KPOWER
  640 TEMP1 = TEMP1*(I-K)
      ERRC(I) = 1.D0
      HOLD = ATS(I)
      SIZE = ATS(I-KPOWER)
      WORK(I) = 0.D0
      IF(HOLD.EQ.0.D0 .OR. SIZE.EQ.0.D0) GO TO 645
      WORK(I) = HOLD/(HFOUR*SIZE)*TEMP1
      ERRR(I) = DABS((WORK(I)-TEMP3)/WORK(I))
      TEMP3 = WORK(I)
  645 WRITE(LIST,1615) I,WORK(I),ERRR(I)
  650 CONTINUE
  700 IF(MPRINT.GT.7) WRITE(LIST,1711) IPASS(9),LABEL,RPASS(8),H
 1711 FORMAT(/' Step',I4,', for',A6,', at',1PD12.4,', h=',D10.3/'  #   r
     Aaw exp   error   error  calc. exp    DELTA    epsilon   sigma')
 1715 FORMAT(' ',I2,1PD11.3,2D8.1,D11.3,3D10.2)
      TEMP3 = 3.146D0
      TEMP8 = 3.146D0
      TEMP4 = 3.146D0
      DO 750 I=3,LENSER
C------
C Perform compound and linear fitting of the exponential.
C------
      ERRC(I) = 1.D0
      HOLD = ATS(I)
      SIZE = ATS(I-1)
      WORK(I) = 0.D0
      IF(HOLD.EQ.0.D0 .OR. SIZE.EQ.0.D0) GO TO 750
      WORK(I) = HOLD/(H*SIZE)*(I-1)
      ERRR(I) = DABS((WORK(I)-TEMP4)/WORK(I))
      TEMP4 = WORK(I)
C------
      IF(MSTIFF.EQ.23) GO TO 720
      TEMP1 = WORK(I) - WORK(I-2)
      DEL(I) = TEMP1*.5D0
      TEMP5 = .5D0*(WORK(I-1) - WORK(I) + DEL(I))
      ELP(I) = WORK(I) + TEMP5 - DEL(I)*(I-2)
      ERRL(I) = .5D0*DABS((ELP(I)-TEMP8)/(ELP(I)+TEMP8))
      IF(DABS(ELP(I)).LT.DABS(5.D0*DEL(I))) ERRL(I) = 1.D1
      TEMP8 = ELP(I)
C------
  720 ERRC(I) = 1.D9
      IF(I.LT.5) GO TO 745
      TEMP1 = WORK(I) - WORK(I-1)
      TEMP5 = WORK(I-1) - WORK(I-2)
      TEMP6 = WORK(I-2) - WORK(I-3)
      HOLD = TEMP5 - TEMP6
      IF(HOLD.EQ.0.D0) GO TO 745
      SIGMA(I) = (TEMP1 - TEMP5)/HOLD
      HOLD = SIGMA(I) - 1.D0
      IF(HOLD.EQ.0.D0) GO TO 745
      TEMP6 = (SIGMA(I)*TEMP5 - TEMP1)/HOLD
      IF(DABS(TEMP6/WORK(I)).GT.1.D-5) GO TO 740
      TEMP6 = 0.D0
      IF(TEMP1.EQ.0.D0 .OR. TEMP5.EQ.0.D0) GO TO 745
      SIGMA(I) = TEMP1/TEMP5
      HOLD = SIGMA(I) - 1.D0
      IF(HOLD.EQ.0.D0) GO TO 745
  740 SIZE = (TEMP1 - TEMP6)*SIGMA(I)/HOLD
      TEMP5 = WORK(I) - TEMP6*(I-2) - SIZE
      EPSLON(I) = SIZE/SIGMA(I)**(I-2)
      IF(TEMP5.EQ.0.D0) GO TO 745
      ERRC(I) = DABS((TEMP5-TEMP3)/TEMP5)
      TEMP3 = TEMP5
      IF(ERRC(I).GT.ERRR(I)) GO TO 745
      IF(ERRC(I).LT.ERRL(I) .OR. MSTIFF.EQ.23) GO TO 748
      GO TO 746
  745 IF(ERRR(I).LT.ERRL(I) .OR. MSTIFF.EQ.23) GO TO 747
C------
C This is the linear exponential.
C------
  746 IF(ELP(I).GT.0.D0) GO TO 747
      EXPO(I) = ELP(I)
      ERRC(I) = ERRL(I)
      IF(MPRINT.GT.7) WRITE(LIST,1715) I,WORK(I),ERRR(I),ERRC(I),
     A EXPO(I),DEL(I)
      DELTA(I) = DEL(I)
      SIGMA(I) = 0.D0
      EPSLON(I) = 0.D0
      GO TO 750
C------
C This is the raw exponential.
C------
  747 EXPO(I) = WORK(I)
      ERRC(I) = ERRR(I)
      IF(MPRINT.GT.7) WRITE(LIST,1715) I,EXPO(I),ERRC(I)
      DELTA(I) = 0.D0
      SIGMA(I) = 0.D0
      EPSLON(I) = 0.D0
      GO TO 750
C------
C This is the compound fit.
C------
  748 IF(TEMP5.GT.0.D0) GO TO 747
      IF(MPRINT.GT.7) WRITE(LIST,1715) I,WORK(I),ERRR(I),ERRC(I),
     A TEMP5,TEMP6,EPSLON(I),SIGMA(I)
      EXPO(I) = TEMP5
      DELTA(I) = TEMP6
  750 CONTINUE
      DO 755 I=6,LENSER
      IF(WORK(I).NE.0.D0) GO TO 756
  755 CONTINUE
C------
C The series is all zero.  Treat it as a polynomial.
C------
      KEY = 3
      GO TO 9999
  756 TEMP8 = 1.D1
      DO 760 I=6,LENSER
      TEMP2 = ERRC(I)
C------
C Pick out the minimum error, or the first error < 1.E-6.
C------
      IF(EXPO(I).GT.0.D0) GO TO 760
      IF(TEMP2.GT.1.D-6) GO TO 759
      TEMP8 = TEMP2
      NUMSTF = I
      GO TO 761
  759 IF(TEMP8.LE.TEMP2) GO TO 760
      TEMP8 = TEMP2
      NUMSTF = I
  760 CONTINUE
  761 TEMP7 = ERRC(NUMSTF-1)
      TEMP6 = ERRC(NUMSTF+1)
      IF(NUMSTF.EQ.LENSER) TEMP6 = ERRC(NUMSTF-1)
      TEMP6 = DMIN1(TEMP6,TEMP7)
C------
C There must be at least two small ERRC.
C------
      KEY = 2
      IF(TEMP8.GT.1.D-2 .OR. (TEMP8.LT.1.D-2 .AND. TEMP6.GT.1.D-2))
     A GO TO 9999
      IF(MSTIFF.EQ.23) GO TO 771
      TEMP5 = 1.D1
      DO 765 I=6,LENSER
      TEMP2 = ERRC(I)
      IF(EXPO(I).GT.0.D0 .OR. EPSLON(I).EQ.0.D0) GO TO 765
      IF(TEMP2.GT.1.D-6) GO TO 764
      TEMP5 = TEMP2
      KUMSTF = I
      GO TO 766
  764 IF(TEMP5.LE.TEMP2) GO TO 765
      TEMP5 = TEMP2
      KUMSTF = I
  765 CONTINUE
  766 IF(TEMP5.GT.1.D-2) GO TO 767
      IF(KUMSTF.EQ.NUMSTF) GO TO 771
      NUMSTF = KUMSTF
      TEMP7 = ERRC(NUMSTF-1)
      TEMP6 = ERRC(NUMSTF+1)
      IF(NUMSTF.EQ.LENSER) TEMP6 = ERRC(NUMSTF-1)
      TEMP6 = DMIN1(TEMP6,TEMP7)
      TEMP8 = TEMP5
      GO TO 771
  767 LTOP = NUMSTF
      DO 770 L=1,LTOP
      N = LTOP - L
      M = N - 1
      IF(EXPO(M).GT.0.D0 .OR. ERRC(M).GT.1.D-1) GO TO 771
      TEMP7 = DABS((EXPO(N)-EXPO(M))/EXPO(N))
      IF(TEMP7.GT.1.2D0*ERRC(LTOP)) GO TO 771
  770 NUMSTF = NUMSTF - 1
  771 PEXP = EXPO(NUMSTF)
      PDEL = DELTA(NUMSTF)
      PEPS = EPSLON(NUMSTF)
      PSIG = SIGMA(NUMSTF)
C------
C Reducing ratio for HNEW if the error > 1.E-6.
C------
      FACTOR = 1.0
      TEMP8 = DMAX1(TEMP6,TEMP8)
      IF(TEMP8.GT.1.D-6) FACTOR = 0.5*ALOG(SNGL(TEMP8)/1.E-7)
      KMIN = NUMSTF
C--------
C Calculate the exponential factors for all series terms.
C--------
      EXPO(1) = PEXP + PEPS
      KEY = 2
      IF(EXPO(1).EQ.0.D0) GO TO 9999
      DO 810 K=2,LENSER
  810 EXPO(K) = PEXP + PDEL*(K-1) + PEPS*PSIG**(K-1)
      HOLD = ATS(NUMSTF)
      DELTA(NUMSTF) = 1.D-32
C--------
C Factor out the negative exponential.
C--------
      DO 812 K=2,KMIN
      N = KMIN + 1 - K
      DELTA(N) = 1.D0
      HOLD = HOLD*N/(EXPO(N)*H)
      EPSLON(N) = ATS(N) - HOLD
      IF(ATS(N).NE.0.D0) DELTA(N) = DABS(EPSLON(N)/ATS(N))
  812 CONTINUE
C------
C AK1 is the constant at the first term.
C------
      AK1 = HOLD
      SIZE = DABS(EPSLON(1))
      TEMP2 = DABS(ATS(1))
      TEMP1 = DMAX1(SIZE,TEMP2)
      SIGMA(1) = 1.D0
C--------
C Use the first and last terms to find HSTF, and store in SIGMA(n).
C--------
      TEMP6 = 8.D0/DLOG(RPASS(5))**2
      TEMP2 = DABS(EPSLON(2))
      IF(TEMP2.LT.1.D-30) TEMP2 = 1.D-30
      SIGMA(2) = H*TEMP6*TEMP1/TEMP2
      DO 830 K=3,KMIN
      TEMP5 = RPASS(5)
      IF(MSTIFF.EQ.21 .AND. K.EQ.3) TEMP5 = 3.D1*RPASS(5)
C------
C Boost ADJSTF for MSTIFF=21.
C------
      IF(MSTIFF.EQ.21 .AND. K.EQ.4) TEMP5 = 5.D0*RPASS(5)
      TEMP2 = DABS(EPSLON(K))
      IF(DELTA(K).LT.1.D-6) TEMP2 = 1.D-6*DABS(ATS(K))
      SIGMA(K) = H*(TEMP1*TEMP5/TEMP2)**(1.0/(K-1))
  830 CONTINUE
      KMIN = KMIN - 1
      IF(MPRINT.GT.5) WRITE(LIST,1830) LABEL,IPASS(9),RPASS(8),H
 1830 FORMAT(/' For',A6,' step',I5,', at',1PD12.4,', h=',D10.3)
      IF(MPRINT.GT.6) WRITE(LIST,1831) (K,SIGMA(K),DELTA(K),K=2,KMIN)
 1831 FORMAT(' ',I3,1PD9.2,'/',D6.0,I3,D9.2,'/',D6.0,I3,D9.2,'/',D6.0,
     B I3,D9.2,'/',D6.0)
      NUMSTF = KMIN + 1
      DO 840 K=2,KMIN
      N = KMIN + 2 - K
      IF(DELTA(N).LT.1.D-5) GO TO 840
      IF(DELTA(N-1).GT.1.D-5) GO TO 841
  840 NUMSTF = N
C------
C DELTA < 1.D-5, or else normal step.
C------
  841 KEY = 2
      IF(NUMSTF.GT.KMIN .OR. NUMSTF.GT.12) GO TO 9999
      KMIN = NUMSTF
      HSTFIN = SIGMA(KMIN)
      KN = KMIN - 1
      IF(DELTA(KN).GT.1.D-3 .OR. HSTFIN.GT.SIGMA(KN)) GO TO 843
      TEMP4 = DABS(EPSLON(KN)/EPSLON(1))
      IF(TEMP4.LT.1.D-6) KMIN = KN
C Move it down if n-1 term is small.
      IF(TEMP4.LT.1.D-3 .AND. MSTIFF.EQ.21) KMIN = KN
      HSTFIN = SIGMA(KMIN)
  843 IF(MSTIFF.NE.21) GO TO 847
      KN = KMIN
      KTOP = KMIN - 2
      IF(KTOP.LT.2) GO TO 846
      DO 845 K=2,KMIN
      N = KMIN + 1 - K
      IF(DABS(EPSLON(N)/EPSLON(1)).GT.1.D-6) GO TO 846
  845 KN = N
  846 KMIN = KN
      HSTFIN = SIGMA(KMIN)
      IF(KMIN.LT.3) GO TO 847
      TEMP4 = SIGMA(KMIN-1)
C Use a geometric average if n-1 is better and MSTIFF=21.
      IF(HSTFIN.LT.TEMP4) HSTFIN = DSQRT(HSTFIN*TEMP4)
  847 IF(KMIN.LT.3) KMIN = 3
      KN = KMIN - 1
      IF(MPRINT.GT.5) WRITE(LIST,1850) KN,AK1,PEXP
 1850 FORMAT('  KMIN,AK(1),EXPO',I3,1P2D12.4)
      IF(MPRINT.GT.6) WRITE(LIST,1855) (K,EPSLON(K),K=1,KN)
 1855 FORMAT(1X,I3,1PD10.3,I3,D10.3,I3,D10.3,I3,D10.3,I3,D10.3)
C--------
C Zero out all the terms that passed the exponential test.
C--------
      DO 860 K=1,KMIN
  860 ATS(K) = EPSLON(K)
      DO 870 K=KMIN,LENSER
  870 ATS(K) = 0.D0
      KMIN = KMIN - 1
C------
C Adjust HNEW according to the reduction ratio.
C------
      HOLD = HSTFIN/FACTOR
      HSTF = DMIN1(HSTF,HOLD)
      KEY = 1
 9999 RETURN
C********
C end STIFF
C********
      END
      SUBROUTINE DTRITA(KTERMS,ATS,H,RCREAL,ORDER,ERR)
C********
C  ATOMFT Subroutine-Library, version 3.11, completed (1/31/93).
C    Copyright (C) 1979-93, Y. F. Chang.
C
C Given a series called ATS, of length KTERMS, this subroutine
C   will attempt to find a singularity on the real axis.
C This code is due to G. F. Corliss.
C
C  KTERMS  input length of the series.
C  ATS     input Taylor series.
C  H       input stepsize.
C  RCREAL  output singularity position along the real axis, from
C            the point of the Taylor expansiion.
C  ORDER   output order of the singularity.
C  ERR     output estimated error in this calculation.
C          1. ERR=2 indicates that this calculation cannot
C              find a pair of conjugate singularities.
C          2. Results with ERR > 0.01 should not be used in
C              precise computations.
C
C See
C 1. Y. F. Chang, "Automatic solution of differential equations,"
C    Lecture Notes in Math., vol. 430, Springer-Verlag, New York,
C    1974, pp. 61-94.
C 2. Y. F. Chang & G. F. Corliss, "Three and Five Term Convergence
C    Tests," Proc. 6th Manitoba Conf. Num. Math., 1976, pp. 135-153.
C 3. Y. F. Chang & G. F. Corliss, "Ratio-like and Recurrence Relation
C    Tests for Convergence of Series," J. Inst. Math. Appl., v. 25,
C    1980, pp. 349-359.
C********
      DOUBLE PRECISION ATS(1),H,RCREAL,ORDER,ERR,HOVERC,TEMP1,TEMP2,
     A HRC1
C------
C Abortive exit, if any of the top terms of the series is zero.
C------
      IF(ATS(KTERMS-1).EQ.0.D0 .OR. ATS(KTERMS-2).EQ.0.D0 .OR.
     A ATS(KTERMS-3).EQ.0.D0 .OR. ATS(KTERMS-4).EQ.0.D0) GO TO 9999
C********  Three-term analysis
      TEMP2 = (KTERMS-3)*ATS(KTERMS-2)/ATS(KTERMS-3)
      TEMP1 = (KTERMS-2)*ATS(KTERMS-1)/ATS(KTERMS-2)
      HRC1 = TEMP1 - TEMP2
      IF(HRC1 .EQ. 0.D0) GO TO 9999
      TEMP2 = (KTERMS-1)*ATS(KTERMS)/ATS(KTERMS-1)
      HOVERC = TEMP2 - TEMP1
      IF(HOVERC .EQ. 0.D0) GO TO 9999
      ERR = DABS((HOVERC - HRC1)/HOVERC)
C------
C Compute ORDER and singularity position.
C------
      ORDER = TEMP2/HOVERC - (KTERMS-2)
      RCREAL = H/HOVERC
      RETURN
C------
C Abortive exit.
C------
 9999 ERR = 2.D0
      RCREAL = 0.D0
      ORDER = 0.D0
      RETURN
C********
C end DTRITA
C********
      END
      SUBROUTINE DFORTA(KTERMS,ATS,H,RCREAL,RCIMAG,ORDER,ERR)
C********
C  ATOMFT Subroutine-Library, version 3.11, completed (1/31/93).
C    Copyright (C) 1979-93, Y. F. Chang.
C
C Given a series called ATS, of length KTERMS, this subroutine
C   will attempt to find a singularity on the real axis.
C
C  KTERMS  input length of the series.
C  ATS     input Taylor series.
C  H       input stepsize.
C  RCREAL  output singularity position along the real axis, from
C            the point of the Taylor expansiion.
C  RCIMAG  output singularity position in the imaginary direction.
C  ORDER   input order of the singularity.
C  ERR     output estimated error in this calculation.
C          1. ERR=2 indicates that this calculation cannot
C              find a pair of conjugate singularities.
C          2. Results with ERR > 0.4 should not be used in
C              precise computations.
C
C See
C 1. Y. F. Chang, "Automatic solution of differential equations,"
C    Lecture Notes in Math., vol. 430, Springer-Verlag, New York,
C    1974, pp. 61-94.
C 2. Y. F. Chang & G. F. Corliss, "Ratio-like and Recurrence Relation
C    Tests for Convergence of Series," J. Inst. Math. Appl., v. 25,
C    1980, pp. 349-359.
C********
      DOUBLE PRECISION ATS(1),H,RCREAL,COSIN,RC,RCIMAG,ORDER,
     A ERR,HOVERC,HVC1,TEMP1,FM,FM1,FM2,FM3,TM1,TM2,TM3,TMS2,
     A TMS3,TMS4,TMTOP,TMBOT
C********  Four-term analysis.
      FM = ATS(KTERMS)
      FM1 = ATS(KTERMS-1)
      FM2 = ATS(KTERMS-2)
      FM3 = ATS(KTERMS-3)
      TM1 = (KTERMS-1)
      TM2 = (KTERMS-2)
      TM3 = (KTERMS-3)
      TMS2 = (KTERMS+ORDER-2)
      TMS3 = (KTERMS+ORDER-3)
      TMS4 = (KTERMS+ORDER-4)
      IF(DABS(FM) .LT. DABS(FM1)) GO TO 50
      TMTOP = TM2*TM3*(TM1*TMS3*FM2 - TM2*TMS2*FM1/FM*FM1)
      TMBOT = TMS2*TMS3*(TM2*TMS4*FM1/FM*FM3 - TM3*TMS3*FM2/FM*FM2)
      GO TO 60
   50 TMTOP = TM2*TM3*(TM1*TMS3*FM/FM1*FM2 - TM2*TMS2*FM1)
      TMBOT = TMS2*TMS3*(TM2*TMS4*FM3 - TM3*TMS3*FM2/FM1*FM2)
   60 TEMP1 = TMTOP/TMBOT
      IF(TEMP1 .LT. 0.D0) GO TO 9999
      HOVERC = DSQRT(TEMP1)
C This is the cosine of the angle.
      IF(FM1 .EQ. 0.D0) GO TO 103
      IF(DABS(FM1) .LT. DABS(FM2)) GO TO 102
      COSIN = (TM1*FM/(HOVERC*TMS2) + HOVERC*TMS3*FM2/TM2)/(2.D0*FM1)
      GO TO 104
C For better accuracy.
  102 COSIN = (TM2*FM1/(HOVERC*TMS3) + HOVERC*TMS4*FM3/TM3)/(2.D0*FM2)
      GO TO 104
  103 COSIN = HOVERC*TMS4*FM3/TM3/(2.D0*FM2)
  104 IF(DABS(COSIN) .GT. 1.01D0) GO TO 9999
      RC = H/HOVERC
      RCREAL = RC*COSIN
      RC = DABS(RC)
      RCIMAG = RC*DSQRT(DABS(1.D0 - COSIN*COSIN))
      LTERMS = KTERMS - 1
C To avoid a 90-degree pole.
      IF(FM2 .EQ. 0.D0) LTERMS = LTERMS - 1
      FM = ATS(LTERMS)
      FM1 = ATS(LTERMS-1)
      FM2 = ATS(LTERMS-2)
      FM3 = ATS(LTERMS-3)
      TM1 = (LTERMS-1)
      TM2 = (LTERMS-2)
      TM3 = (LTERMS-3)
      TMS2 = (LTERMS+ORDER-2)
      TMS3 = (LTERMS+ORDER-3)
      TMS4 = (LTERMS+ORDER-4)
      IF(DABS(FM) .LT. DABS(FM1)) GO TO 150
      TMTOP = TM2*TM3*(TM1*TMS3*FM2 - TM2*TMS2*FM1/FM*FM1)
      TMBOT = TMS2*TMS3*(TM2*TMS4*FM1/FM*FM3 - TM3*TMS3*FM2/FM*FM2)
      GO TO 160
  150 TMTOP = TM2*TM3*(TM1*TMS3*FM/FM1*FM2 - TM2*TMS2*FM1)
      TMBOT = TMS2*TMS3*(TM2*TMS4*FM3 - TM3*TMS3*FM2/FM1*FM2)
  160 TEMP1 = TMTOP/TMBOT
      IF(TEMP1 .LT. 0.D0) GO TO 9999
      HVC1 = DSQRT(TEMP1)
      ERR = DABS((HOVERC - HVC1)/HOVERC)
C------
C Normal exit.
C------
      RETURN
C------
C Abortive exit.
C------
 9999 ERR = 2.D0
      RETURN
C********
C end DFORTA
C********
      END
      SUBROUTINE DSEVTA(KTERMS,ATS,H,RADIUS,BX,RCIMAG,ORDER,ERR)
C********
C  ATOMFT Subroutine-Library, version 3.11, completed (1/31/93).
C    Copyright (C) 1979-93, Y. F. Chang.
C
C Given a series called ATS, of length KTERMS, this subroutine
C   will find a pair of conjugate singularities in the complex plane.
C This code is partially due to G. F. Corliss.
C
C  KTERMS  input length of the series.
C  ATS     input Taylor series.
C  H       input stepsize.
C  RADIUS  output radius of convergence.
C  BX      output singularity position along the real axis, from
C            the point of the Taylor expansiion.
C            In my other calculations, I refer to this as BX.
C  RCIMAG  output singularity position in the imaginary direction.
C  ORDER   output order of the singularity.
C  ERR     output error flag.
C          1. normal ERR; the solution is accepted.
C          2. ERR = 2, this calculation cannot find the singularities.
C
C See
C 1. Y. F. Chang, "The Automatic Taylor Series Method of Analysis."
C********
      DOUBLE PRECISION ATS(1),H,RADIUS,BX,RCIMAG,ORDER,ERR,HOVERC,
     A TEMP1,TEMP2,COSINE,COEF(6,6),X(5)
      DIMENSION IPVT(5)
      JUMP = 1
      LTERMS = KTERMS
      IF(ATS(LTERMS-1).NE.0.D0) GO TO 2300
C********  Seven-term Analysis
 1300 DO 1330 MM=1,3
         M = LTERMS + 2 - MM*2
         M1 = M - 1
         M2 = M - 2
         IF (ATS(M2) .EQ. 0.0D0) GO TO 9999
         M3 = M - 3
C------
C Define the matrix coefficients.  Use TEMP1 to scale the system.
C------
         X(1) = - (M2*M3)*ATS(M2)
         X(2) = - (M2+M3)*ATS(M2)
         X(3) = - ATS(M2)
         TEMP1 = 3.D0/(DABS(X(1)) + DABS(X(2)) + DABS(X(3)))
         COEF(MM,1) = X(1)*TEMP1
         COEF(MM,2) = X(2)*TEMP1
         COEF(MM,3) = X(3)*TEMP1
 1330 COEF(MM,4) = (M1*M2)*ATS(M)*TEMP1
C------
C Solve by Gaussian elimination.
C------
      DO 1340 M=1,3
 1340 IPVT(M) = M
      DO 1350 M=1,2
C------
C Find the pivot element.
C------
         TEMP2 = 0.D0
         DO 1341 MM=M,3
            M1 = IPVT(MM)
            TEMP1 = DABS(COEF(M1,M))
            IF(TEMP1 .GT. TEMP2) THEN
               IMAX = MM
               TEMP2 = TEMP1
            ENDIF
 1341    CONTINUE
C------
C Exchange rows IMAX and M.
C------
         M1 = IPVT(IMAX)
         IPVT(IMAX) = IPVT(M)
         IPVT(M) = M1
C------
C Eliminate the rest of column M.
C------
         M1 = M + 1
         DO 1348 MM=M1,3
            IMM = IPVT(MM)
            IM  = IPVT(M)
C------
C Abortive exit if the denominator is zero.
C------
            IF(COEF(IM,M) .EQ. 0.D0) GO TO 9999
            TEMP1 = COEF(IMM,M)/COEF(IM,M)
            COEF(IMM,M) = TEMP1
            DO 1346 I=M1,4
 1346       COEF(IMM,I) = COEF(IMM,I) - TEMP1*COEF(IM,I)
 1348    CONTINUE
 1350 CONTINUE
C------
C Back substitution.
C------
      IM =IPVT(3)
C------
C Abortive exit if the denominator is zero.
C------
      IF(COEF(IM,3) .EQ. 0.D0) GO TO 9999
      X(3) = COEF(IM,4)/COEF(IM,3)
      IM = IPVT(2)
      TEMP1 = COEF(IM,4) - COEF(IM,3)*X(3)
      IF(COEF(IM,2) .EQ. 0.D0) GO TO 9999
      X(2) = TEMP1/COEF(IM,2)
      IM = IPVT(1)
      TEMP1 = COEF(IM,4) - COEF(IM,2)*X(2) - COEF(IM,3)*X(3)
      IF(COEF(IM,1) .EQ. 0.D0) GO TO 9999
      X(1) = TEMP1/COEF(IM,1)
C------
C Abortive exit if the square is negative.
C------
      IF(X(1) .LE. 0.D0) GO TO 9999
      IF(JUMP .EQ. 2) GO TO 1400
      HOVERC = DSQRT(X(1))
      ORDER = X(2)/X(1)
      IF(DABS(ORDER) .GT. 1.D1) GO TO 9999
      RADIUS = DABS(H/HOVERC)
      RCIMAG = RADIUS
      JUMP = 2
      LTERMS = KTERMS - 2
      GO TO 1300
 1400 TEMP1 =  DSQRT(X(1))
      ERR = DABS((HOVERC - TEMP1)/HOVERC)
      RETURN
C********  Seven-term Analysis
 2300 DO 2330 MM=1,5
         M = LTERMS + 1 - MM
         M1 = M - 1
         M2 = M - 2
         IF (ATS(M2) .EQ. 0.0D0) GO TO 9999
         M3 = M - 3
C------
C Define the matrix coefficients.  Use TEMP1 to scale the system.
C------
         X(1) = - (M2+M3)*ATS(M2)
         X(2) = - ATS(M2)
         X(3) = - (M2*M3)*ATS(M2)
         X(4) = (2*M2*M2)*ATS(M1)
         X(5) = (2*M2)*ATS(M1)
         TEMP1 = 5.D0/(DABS(X(1)) + DABS(X(2)) + DABS(X(3)) +
     A     DABS(X(4)) + DABS(X(5)))
         COEF(MM,1) = X(1)*TEMP1
         COEF(MM,2) = X(2)*TEMP1
         COEF(MM,3) = X(3)*TEMP1
         COEF(MM,4) = X(4)*TEMP1
         COEF(MM,5) = X(5)*TEMP1
 2330 COEF(MM,6) = (M1*M2)*ATS(M)*TEMP1
C------
C Solve by Gaussian elimination.
C------
      DO 2340 M=1,5
 2340 IPVT(M) = M
      DO 2350 M=1,4
C------
C Find the pivot element.
C------
         TEMP2 = 0.D0
         DO 2341 MM=M,5
            M1 = IPVT(MM)
            TEMP1 = DABS(COEF(M1,M))
            IF(TEMP1 .GT. TEMP2) THEN
               IMAX = MM
               TEMP2 = TEMP1
            ENDIF
 2341    CONTINUE
C------
C Exchange rows IMAX and M.
C------
         M1 = IPVT(IMAX)
         IPVT(IMAX) = IPVT(M)
         IPVT(M) = M1
C------
C Eliminate the rest of column M.
C------
         M1 = M + 1
         DO 2348 MM=M1,5
            IMM = IPVT(MM)
            IM  = IPVT(M)
C------
C Abortive exit if the denominator is zero.
C------
            IF(COEF(IM,M) .EQ. 0.D0) GO TO 9999
            TEMP1 = COEF(IMM,M)/COEF(IM,M)
            COEF(IMM,M) = TEMP1
            DO 2346 I=M1,6
 2346       COEF(IMM,I) = COEF(IMM,I) - TEMP1*COEF(IM,I)
 2348    CONTINUE
 2350 CONTINUE
C------
C Back substitution.
C------
      IM =IPVT(5)
C------
C Abortive exit if the denominator is zero.
C------
      IF(COEF(IM,5) .EQ. 0.D0) GO TO 9999
      X(5) = COEF(IM,6)/COEF(IM,5)
      IM = IPVT(4)
      TEMP1 = COEF(IM,6) - COEF(IM,5)*X(5)
      IF(COEF(IM,4) .EQ. 0.D0) GO TO 9999
      X(4) = TEMP1/COEF(IM,4)
      IM = IPVT(3)
      TEMP1 = COEF(IM,6) - COEF(IM,4)*X(4) - COEF(IM,5)*X(5)
      IF(COEF(IM,3) .EQ. 0.D0) GO TO 9999
      X(3) = TEMP1/COEF(IM,3)
C------
C Abortive exit if the square is negative.
C------
      IF(X(3) .LE. 0.D0) GO TO 9999
      IF(JUMP .GT. 1) GO TO 2400
      HOVERC = DSQRT(X(3))
      COSINE = X(4)/HOVERC
      IF(DABS(COSINE) .LT. 1.D-2) THEN
C------
C When the cosine is less than 1.D-2, perform the 3x3.
C Then, the series will have alternating large terms; so,
C   pick out the highest-order large term.
C------
         TEMP1 = DABS(ATS(LTERMS-1)*HOVERC/ATS(LTERMS))
         IF(TEMP1 .GT. 1.D0) LTERMS = LTERMS - 1
         GO TO 1300
      ENDIF
C------
C Abortive exit if the cosine is too big.
C------
      IF(COSINE*COSINE .GT. 1.D0) GO TO 9999
      ORDER = X(5)/X(4)
      RADIUS = H/HOVERC
      IF(DABS(ORDER) .GT. 1.D1) GO TO 9999
      BX = RADIUS*COSINE
      RADIUS = DABS(RADIUS)
      RCIMAG = RADIUS*DSQRT(DABS(1.D0 - COSINE*COSINE))
      JUMP = 2
      LTERMS = KTERMS - 1
      GO TO 2300
 2400 TEMP1 =  DSQRT(X(3))
      ERR = DABS((HOVERC - TEMP1)/HOVERC)
C------
C Normal exit.
C------
      RETURN
C------
C Abortive exit.
C------
 9999 ERR = 2.D0
      RADIUS = 0.D0
      BX = 0.D0
      RCIMAG = 0.D0
      ORDER = 0.D0
      RETURN
C********
C end DSEVTA
C********
      END
      SUBROUTINE DTOPLN(KTERMS,ATS,H,NORDER,RADTL,mstiff)
C********
C  ATOMFT Subroutine-Library, version 3.11, completed (5/31/93).
C    Copyright (C) 1979-93, Y. F. Chang.
C
C This is an improved version with no GOTO's.
C
C Given a series called ATS, of length KTERMS, this subroutine
C   will find the slope of the top envelope to Log{ |ATS(K)| }
C   between the 5-th term and KTERMS.
C The inverse of this slope is a good estimate for the Radius
C   of Convergence.
C
C  KTERMS  input length of the series.
C  ATS     input Taylor series.
C  H       input stepsize.
C  NORDER  input ODE order.
C  RADTL   output Radius of Convergence, Rc.
C
C See Y. F. Chang, "Automatic solution of differential equations",
C    Lecture Notes in Math., vol. 430, Springer-Verlag, New York,
C    1974, pp. 61-94.
C********
C GFC mod 29-AUG-1993 per Chang's instructions:
c     DOUBLE PRECISION WORK(100),ATS(101),H,HMAG,SLOPE,DMAXH,DMAXL,TEMP1,
c    A RADTL,DLOOP,RATIO,WORK2(100)
      DOUBLE PRECISION WORK(200),ATS(201),H,HMAG,SLOPE,DMAXH,DMAXL,
     ATEMP1,RADTL,DLOOP,RATIO,WORK2(200)
      LENSIN = KTERMS
      HMAG = DABS(H)
C------
C Transfer to the local array.
C------
      LOWEND = 0
      DO 100 K=1,LENSIN
         TEMP1 = DABS(ATS(K))
         IF(ATS(K) .NE. 0.D0) THEN
C Find the first non-zero term.
            IF(LOWEND .EQ. 0) LOWEND = K
         ELSE
            TEMP1 = 1.D-35
         ENDIF
         WORK(K) = TEMP1
  100 WORK2(K) = TEMP1
      LOWD = LOWEND + NORDER
      IF(NORDER .LT. 2) GO TO 118
C------
C Shift the series by the order of the ODE.
C This is to account for derivatives.
C------
      DO 110 I=2,NORDER
        LENSIN = LENSIN - 1
        DO 109 K=1,LENSIN
  109   WORK2(K) = WORK2(K+1)*K/HMAG
  110 CONTINUE
  118 RADTL = HMAG
      IF(MSTIFF .EQ. 10) LENSIN = LENSIN/2
      DO 400 KOUNT=1,5
C Maximum of five low-end terms.
        DMAXL = DMAX1(WORK2(LOWD+1),WORK2(LOWD+2),WORK2(LOWD+3),
     A  WORK2(LOWD+4),WORK2(LOWD+5))
C Maximum of the last seven terms.
        DMAXH = DMAX1(WORK2(LENSIN),WORK2(LENSIN-1),WORK2(LENSIN-2),
     A  WORK2(LENSIN-3),WORK2(LENSIN-4),WORK2(LENSIN-5),WORK2(LENSIN-6))
C Draw a straight logarithm-slope line.
        SLOPE = (DMAXL/DMAXH)**(1.D0/(LENSIN-6))
C------
        RADTL = RADTL*SLOPE
        IF(DABS(1.D0 - SLOPE) .LT. 1.D-3) GO TO 401
        DLOOP = 1.D0
C Adjust the series by this slope, and repeat the process.
        DO 330 J=2,LENSIN
        DLOOP = DLOOP*SLOPE
  330 WORK2(J) = DLOOP*WORK2(J)
  400 CONTINUE
  401 ATS(201) = -2.D0
      IF(MSTIFF .EQ. 10) RETURN
      LENSIN = KTERMS
C Test for last-pole situations.
      DLOOP = 1.D0
      RATIO = RADTL/HMAG
      DO 500 J=2,LENSIN
C Adjust the original series by the 0.7*Rc.
        DLOOP = DLOOP*RATIO
  500 WORK2(J) = DLOOP*WORK(J)
C Search backwards for a viable term.
      DO 600 I=1,LENSIN
      J = LENSIN - I + 1
C Is there a last-pole situation?
      IF(WORK2(J) .GT. WORK2(LOWEND)*1.D-5) GO TO 601
  600 CONTINUE
C Yes.  Artificially use just 8 terms of the Taylor series.
  601 IF(J .GT. 5) RETURN
      ATS(201) = -2.D1
      RADTL = (WORK(LOWEND)/WORK(8))**(1.43D-1)*HMAG
      RETURN
C********
C end DTOPLN
C********
      END
