C  File rclib9.for                     30-DEC-1993

      SUBROUTINE DZEROT(Y,ROOT,TMPV,NAMES,IPASS,RPASS)
C********
C ATOMFT Subroutine-Library, version 3.11, completed (7/23/93).
C    Copyright (C) 1979-93, Y. F. Chang.
C  This DZEROT(3.11) can be used with a non-zero DLTXPT and for
C  the solution of stiff problems.
C********
      CHARACTER*6 NAMES(1)
      DIMENSION IPASS(20),RPASS(20)
      DOUBLE PRECISION Y(1),TMPV(1),TMPB(200),HNEWIN,ROOT,ZSTEP,RATIO,
     A DUMMY,HADJ,UNDER,DLOOP,RRMIN,ROOTR(8),ROOTI(8),DN,
     A TEMP1,TEMP2,H,XPRINT,RPASS,START,ORDER

C RPASS(13) = TESTB
C RPASS(15) = SIZE
C RPASS(16) = old HNEW
      NUMEQS = IPASS(1)
      LENSER = IPASS(2)
      LENVAR = IPASS(3)
      MPRINT = IPASS(4)
      LIST   = IPASS(5)
      MSTIFF = IPASS(6)
      KENDFG = IPASS(13)
      H      = RPASS(2)
      XPRINT = RPASS(6)
      START  = RPASS(8)
C******** Initialize
      NTOP = LENVAR*NUMEQS + 1
      KSUBFT = IPASS(7)
      IPASS(7) = 1
      LKOVER = IPASS(15)
      IF(IPASS(9) .GT. 1) GO TO 120
      ZSTEP = START - 1.D1*H
      KC = LENSER/2
      DO 110 II=1,NUMEQS
      IL = (II-1)*LENVAR
      IF(Y(KC).EQ.TMPV(KC+IL) .AND. Y(KC-1).EQ.TMPV(KC-1+IL)) GO TO 111
  110 CONTINUE
      IPASS(19) = 0
      GO TO 112
C It is a dependent variable.
  111 IPASS(19) = II
  112 IF(IPASS(19).NE.0 .AND. (MSTIFF.EQ.1 .OR. MSTIFF.GT.19)) THEN
C------
C I can do stiff.  But, not the dependent variables.
C------
         IF(MSTIFF.GT.19) WRITE(LIST,10)
   10 FORMAT(' For STIFF problems,')
         IF(MSTIFF.EQ.1) WRITE(LIST,11)
   11 FORMAT(' For MSTIFF=1,')
         WRITE(LIST,12)
   12 FORMAT(' DZEROT can only work with NON-dependent variables.'/
     A ' For a dependent variable, say F, use a dummy variable TEST.'/
     A ' Then, place'/
     A '      TEST = F , in the first data block in ODEINP, and'/
     A '      CALL DZEROT(TEST,ROOT,TMPV,NAMES,IPASS,RPASS)'/
     A ' in the fourth data block.')
         STOP
      ENDIF
      IF(MSTIFF.GT.19) then
        WRITE(LIST,13)
   13 FORMAT(' For stiff, DZEROT will be forcing many small steps.'/
     A ' It is best that you solve this problem without DZEROT, then'/
     B '   re-start close to your desired point with DZEROT.')
        GO TO 120
      ENDIF
      IF(MSTIFF.NE.1 .AND. IPASS(19).EQ.0) WRITE(LIST,14)
   14 FORMAT(' ZEROT is not as accurate for a variable that is not'/
     A ' a dependent variable.'/
     A ' You may wish to declare an auxiliary variable as follows.'/
     A '      DIFF(AUX,T,0) = WHATEVER , in ODEINP, and then'/
     C '      CALL ZEROT(AUX,ROOT,TMPV,NAMES,IPASS,RPASS)')
  120 UNDER = DMAX1((2.D0*RPASS(17)),RPASS(4))
      IF(KENDFG.EQ.3) GO TO 130
      RPASS(15) = DSQRT(RPASS(15)*DABS(Y(1)))
C------
C Call DRSET to cancel the storing for KENDFG=1 or 2.
C------
      IPASS(15) = -1
      CALL DRSET(TMPV,NAMES,IPASS,RPASS)
C------
C Look for the series length.  This must be done every call.
C------
  130 DO 150 I=1,LENSER
      J = LENSER + 1 - I
      DUMMY = DABS(Y(J))
      IF(DUMMY .GT. RPASS(13)) GO TO 151
  150 CONTINUE
  151 LENSIN = J
C------
C The analysis is now done on every call.  Transfer the series to TMPB.
C------
      DO 160 J=1,LENSIN
  160 TMPB(J) = Y(J)
      HNEWIN = RPASS(3)
C------
C For KENDFG=3.
C------
      IF(KENDFG.EQ.3) HNEWIN = XPRINT - START
      TMPB(1) = TMPB(1) - ROOT
      IF(DABS(TMPB(1)) .GT. UNDER) GO TO 430
C For subft, KSUBFT=-1.  Otherwise, it is +1.
      IF(KSUBFT .LT. 0) THEN
         HADJ = 0.D0
         ZSTEP = START
         GO TO 6800
      ENDIF
C------
C Remove a near-zero root.
C------
  419 DO 420 J=2,LENSIN
  420 TMPB(J-1) = TMPB(J)
      IF(DABS(TMPB(1)) .LE. UNDER) GO TO 419
  430 CALL DRTPLY(8,TMPB,ROOTR,ROOTI,LIST,RPASS)
      RRMIN = 5000.D0
      NPOS = 0
      DO 480 K=1,7
      IF(ROOTR(K).LT.0.D0 .OR. ROOTI(K).NE.0.D0) GO TO 480
C------
C..Look only for zeros in the positive direction.
C------
      IF(ROOTR(K) .LT. RRMIN) THEN
         RRMIN = ROOTR(K)
         NPOS = K
      ENDIF
  480 CONTINUE
      IF(NPOS .EQ. 0) GO TO 9000
C--------
C Success.  We have a positive root.
C--------
 6000 HADJ = RRMIN*H
      IF(DABS(HADJ) .GT. 3.D0*RPASS(16)) GO TO 9000
      DO 6550 KNT=1,7
      ZSTEP = START + HADJ
C Stop if beyond END.
      IF((ZSTEP-RPASS(9))*H .GT. 0.D0) GO TO 9000
      ROOTR(KNT) = HADJ
      RATIO = HADJ/H
      DLOOP = 1.D0
      TEMP1 = Y(1)
      DO 6510 J=2,LENSIN
      DLOOP = DLOOP*RATIO
 6510 TEMP1 = TEMP1 + DLOOP*Y(J)
      TEMP2 = DABS(TEMP1 - ROOT)/RPASS(15)
      IF(TEMP2 .LT. UNDER) GO TO 6600
      IF(TEMP2 .GT. 1.D-1) GO TO 9000
      ROOTI(KNT) = TEMP1 - ROOT
      IF(KNT .EQ. 1) THEN
C Set the limit for the next HNEW.
        TEMP1 = HADJ + START
        TEMP3 = DABS(TEMP1 - XPRINT)*(1.D0 - TEMP2)
        IF(TMPV(NTOP).EQ.0.D0.OR.TMPV(NTOP).GT.TEMP3)
     A      TMPV(NTOP) = TEMP3 * 9.6D-1
        HADJ = HADJ + 1.1D0*DSIGN(TEMP2,TEMP2*(Y(1)-ROOT))
      ELSE
        DN = ROOTI(KNT) - ROOTI(KNT-1)
        IF(DN .EQ. 0.D0) GO TO 9000
        HADJ = ROOTR(KNT-1) - ROOTI(KNT-1)*(ROOTR(KNT)-ROOTR(KNT-1))/DN
        DUMMY = DABS((HADJ - ROOTR(KNT))/HADJ)
        IF(DUMMY .LT. UNDER) GO TO 6600
      ENDIF
 6550 CONTINUE
C If KNT=7, the point is too far away.
      GO TO 9000
C Set the limit for the next HNEW.
 6600 TMPV(NTOP) = DABS(HADJ + START - XPRINT) * 0.99D0
C Take an extra step if root is beyond old HNEW, RPASS(16).
      IF(DABS(HADJ) .GT. RPASS(16)) GO TO 9000
C This root is valid; stop and print.
      IF(MPRINT.GT.3 .AND. DABS(HADJ).LT.DABS(HNEWIN)) WRITE(LIST,411)
  411 FORMAT(' *****--------Throw away the above step.--------*****')
 6800 IPASS(7) = 0
      IF(MPRINT.GT.1) THEN
        ZSTEP = START + HADJ
        WRITE(LIST,15) NAMES(1),ZSTEP
   15 FORMAT(/' There is a root at',A6,' =',1PD20.12)
      ENDIF
      RPASS(15) = 1.D0
      ORDER = 5.D1 + RPASS(1)
      TMPV(NTOP) = 0.D0
C------
C Use ORDER to pass back to RDCV the fact that HNEW should
C  be the un-forced HNEW.
C------
      RPASS(10) = ORDER
      RPASS(3) = HADJ
      IPASS(15) = -3
      KPRINT = IPASS(4)
      IF(KPRINT.GT.0 .AND. KPRINT.LT.4) IPASS(4) = 4
      GO TO 9100
 9000 IF(KENDFG.EQ.3) GO TO 9999
      IPASS(15) = -2
      KPRINT = IPASS(4)
 9100 CALL DRSET(TMPV,NAMES,IPASS,RPASS)
      IPASS(4) = KPRINT
 9999 IPASS(15) = LKOVER
      RETURN
C********
C end DZEROT
C********
      END
